# GstPad

A GstElement is linked to other elements via "pads", which are extremely light-weight generic link points.

Pads have a GstPadDirection, source pads produce data, sink pads consume data.

Pads are typically created from a GstPadTemplate with gst_pad_new_from_template and are then added to a GstElement. This usually happens when the element is created but it can also happen dynamically based on the data that the element is processing or based on the pads that the application requests.

Pads without pad templates can be created with gst_pad_new, which takes a direction and a name as an argument. If the name is NULL, then a guaranteed unique name will be assigned to it.

A GstElement creating a pad will typically use the various gst_pad_set_*_function() calls to register callbacks for events, queries or dataflow on the pads.

gst_pad_get_parent will retrieve the GstElement that owns the pad.

After two pads are retrieved from an element by gst_element_get_static_pad, the pads can be linked with gst_pad_link. (For quick links, you can also use gst_element_link, which will make the obvious link for you if it's straightforward.). Pads can be unlinked again with gst_pad_unlink. gst_pad_get_peer can be used to check what the pad is linked to.

Before dataflow is possible on the pads, they need to be activated with gst_pad_set_active.

gst_pad_query and gst_pad_peer_query can be used to query various properties of the pad and the stream.

To send a GstEvent on a pad, use gst_pad_send_event and gst_pad_push_event. Some events will be sticky on the pad, meaning that after they pass on the pad they can be queried later with gst_pad_get_sticky_event and gst_pad_sticky_events_foreach. gst_pad_get_current_caps and gst_pad_has_current_caps are convenience functions to query the current sticky CAPS event on a pad.

GstElements will use gst_pad_push and gst_pad_pull_range to push out or pull in a buffer.

The dataflow, events and queries that happen on a pad can be monitored with probes that can be installed with gst_pad_add_probe. gst_pad_is_blocked can be used to check if a block probe is installed on the pad. gst_pad_is_blocking checks if the blocking probe is currently blocking the pad. gst_pad_remove_probe is used to remove a previously installed probe and unblock blocking probes if any.

Pad have an offset that can be retrieved with gst_pad_get_offset. This offset will be applied to the running_time of all data passing over the pad. gst_pad_set_offset can be used to change the offset.

Convenience functions exist to start, pause and stop the task on a pad with gst_pad_start_task, gst_pad_pause_task and gst_pad_stop_task respectively.

## GstPad

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstPad
                    ╰──GstProxyPad

The GstPad structure. Use the functions to update the variables.

### Members

`object` (GstObject) –
No description available
`element_private` (gpointer) –

private data owned by the parent element

`padtemplate` (GstPadTemplate *) –

padtemplate for this pad

`direction` (GstPadDirection) –

the direction of the pad, cannot change after creating the pad.

`ABI._gst_reserved` (gpointer *) –
No description available
`ABI.abi.last_flowret` (GstFlowReturn) –
No description available
`ABI.abi.eventfullfunc` (GstPadEventFullFunction) –
No description available

### Class structure

#### GstPadClass

##### Fields

`parent_class` (GstObjectClass) –
No description available

### Gst.PadClass

##### Attributes

`parent_class` (Gst.ObjectClass) –
No description available

### Gst.PadClass

##### Attributes

`parent_class` (Gst.ObjectClass) –
No description available

## Gst.Pad

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.Pad
                    ╰──Gst.ProxyPad

The Gst.Pad structure. Use the functions to update the variables.

### Members

`object` (Gst.Object) –
No description available
`element_private` (Object) –

private data owned by the parent element

`padtemplate` (Gst.PadTemplate) –

padtemplate for this pad

`direction` (Gst.PadDirection) –

the direction of the pad, cannot change after creating the pad.

## Gst.Pad

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.Pad
                    ╰──Gst.ProxyPad

The Gst.Pad structure. Use the functions to update the variables.

### Members

`object` (Gst.Object) –
No description available
`element_private` (object) –

private data owned by the parent element

`padtemplate` (Gst.PadTemplate) –

padtemplate for this pad

`direction` (Gst.PadDirection) –

the direction of the pad, cannot change after creating the pad.

### Constructors

#### gst_pad_new

    GstPad *
    gst_pad_new (const gchar * name,
                 GstPadDirection direction)

Creates a new pad with the given name in the given direction. If name is NULL, a guaranteed unique name (across all pads) will be assigned. This function makes a copy of the name so you can safely free the name.

Parameters:

`name` ( [nullable]) –

the name of the new pad.

`direction` –

the GstPadDirection of the pad.

Returns ( [transfer: floating]) –

a new GstPad.

MT safe.

#### Gst.Pad.prototype.new

    function Gst.Pad.prototype.new(name: String, direction: Gst.PadDirection): {
        // javascript wrapper for 'gst_pad_new'
    }

Creates a new pad with the given name in the given direction. If name is null, a guaranteed unique name (across all pads) will be assigned. This function makes a copy of the name so you can safely free the name.

Parameters:

`name` (String) –

the name of the new pad.

`direction` (Gst.PadDirection) –

the Gst.PadDirection of the pad.

Returns (Gst.Pad) –

a new Gst.Pad.

MT safe.

#### Gst.Pad.new

    def Gst.Pad.new (name, direction):
        #python wrapper for 'gst_pad_new'

Creates a new pad with the given name in the given direction. If name is None, a guaranteed unique name (across all pads) will be assigned. This function makes a copy of the name so you can safely free the name.

Parameters:

`name` (str) –

the name of the new pad.

`direction` (Gst.PadDirection) –

the Gst.PadDirection of the pad.

Returns (Gst.Pad) –

a new Gst.Pad.

MT safe.

#### gst_pad_new_from_static_template

    GstPad *
    gst_pad_new_from_static_template (GstStaticPadTemplate * templ,
                                      const gchar * name)

Creates a new pad with the given name from the given static template. If name is NULL, a guaranteed unique name (across all pads) will be assigned. This function makes a copy of the name so you can safely free the name.

Parameters:

`templ` –

the GstStaticPadTemplate to use

`name` –

the name of the pad

Returns ( [transfer: floating]) –

a new GstPad.

#### Gst.Pad.prototype.new_from_static_template

    function Gst.Pad.prototype.new_from_static_template(templ: Gst.StaticPadTemplate, name: String): {
        // javascript wrapper for 'gst_pad_new_from_static_template'
    }

Creates a new pad with the given name from the given static template. If name is null, a guaranteed unique name (across all pads) will be assigned. This function makes a copy of the name so you can safely free the name.

Parameters:

`templ` (Gst.StaticPadTemplate) –

the Gst.StaticPadTemplate to use

`name` (String) –

the name of the pad

Returns (Gst.Pad) –

a new Gst.Pad.

#### Gst.Pad.new_from_static_template

    def Gst.Pad.new_from_static_template (templ, name):
        #python wrapper for 'gst_pad_new_from_static_template'

Creates a new pad with the given name from the given static template. If name is None, a guaranteed unique name (across all pads) will be assigned. This function makes a copy of the name so you can safely free the name.

Parameters:

`templ` (Gst.StaticPadTemplate) –

the Gst.StaticPadTemplate to use

`name` (str) –

the name of the pad

Returns (Gst.Pad) –

a new Gst.Pad.

#### gst_pad_new_from_template

    GstPad *
    gst_pad_new_from_template (GstPadTemplate * templ,
                               const gchar * name)

Creates a new pad with the given name from the given template. If name is NULL, a guaranteed unique name (across all pads) will be assigned. This function makes a copy of the name so you can safely free the name.

Parameters:

`templ` –

the pad template to use

`name` ( [nullable]) –

the name of the pad

Returns ( [transfer: floating]) –

a new GstPad.

#### Gst.Pad.prototype.new_from_template

    function Gst.Pad.prototype.new_from_template(templ: Gst.PadTemplate, name: String): {
        // javascript wrapper for 'gst_pad_new_from_template'
    }

Creates a new pad with the given name from the given template. If name is null, a guaranteed unique name (across all pads) will be assigned. This function makes a copy of the name so you can safely free the name.

Parameters:

`templ` (Gst.PadTemplate) –

the pad template to use

`name` (String) –

the name of the pad

Returns (Gst.Pad) –

a new Gst.Pad.

#### Gst.Pad.new_from_template

    def Gst.Pad.new_from_template (templ, name):
        #python wrapper for 'gst_pad_new_from_template'

Creates a new pad with the given name from the given template. If name is None, a guaranteed unique name (across all pads) will be assigned. This function makes a copy of the name so you can safely free the name.

Parameters:

`templ` (Gst.PadTemplate) –

the pad template to use

`name` (str) –

the name of the pad

Returns (Gst.Pad) –

a new Gst.Pad.

### Methods

#### gst_pad_activate_mode

    gboolean
    gst_pad_activate_mode (GstPad * pad,
                           GstPadMode mode,
                           gboolean active)

Activates or deactivates the given pad in mode via dispatching to the pad's activatemodefunc. For use from within pad activation functions only.

If you don't know what this is, you probably don't want to call it.

Parameters:

`pad` –

the GstPad to activate or deactivate.

`mode` –

the requested activation mode

`active` –

whether or not the pad should be active.

Returns –

TRUE if the operation was successful.

MT safe.

#### Gst.Pad.prototype.activate_mode

    function Gst.Pad.prototype.activate_mode(mode: Gst.PadMode, active: Number): {
        // javascript wrapper for 'gst_pad_activate_mode'
    }

Activates or deactivates the given pad in mode via dispatching to the pad's activatemodefunc. For use from within pad activation functions only.

If you don't know what this is, you probably don't want to call it.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to activate or deactivate.

`mode` (Gst.PadMode) –

the requested activation mode

`active` (Number) –

whether or not the pad should be active.

Returns (Number) –

true if the operation was successful.

MT safe.

#### Gst.Pad.activate_mode

    def Gst.Pad.activate_mode (self, mode, active):
        #python wrapper for 'gst_pad_activate_mode'

Activates or deactivates the given pad in mode via dispatching to the pad's activatemodefunc. For use from within pad activation functions only.

If you don't know what this is, you probably don't want to call it.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to activate or deactivate.

`mode` (Gst.PadMode) –

the requested activation mode

`active` (bool) –

whether or not the pad should be active.

Returns (bool) –

True if the operation was successful.

MT safe.

#### gst_pad_add_probe

    gulong
    gst_pad_add_probe (GstPad * pad,
                       GstPadProbeType mask,
                       GstPadProbeCallback callback,
                       gpointer user_data,
                       GDestroyNotify destroy_data)

Be notified of different states of pads. The provided callback is called for every state that matches mask.

Probes are called in groups: First GST_PAD_PROBE_TYPE_BLOCK probes are called, then others, then finally GST_PAD_PROBE_TYPE_IDLE. The only exception here are GST_PAD_PROBE_TYPE_IDLE probes that are called immediately if the pad is already idle while calling gst_pad_add_probe. In each of the groups, probes are called in the order in which they were added.

Parameters:

`pad` –

the GstPad to add the probe to

`mask` –

the probe mask

`callback` ( [closure]) –

GstPadProbeCallback that will be called with notifications of the pad state

`user_data` –

user data passed to the callback

`destroy_data` –

GDestroyNotify for user_data

Returns –

an id or 0 if no probe is pending. The id can be used to remove the probe with gst_pad_remove_probe. When using GST_PAD_PROBE_TYPE_IDLE it can happen that the probe can be run immediately and if the probe returns GST_PAD_PROBE_REMOVE this functions returns 0.

MT safe.

#### Gst.Pad.prototype.add_probe

    function Gst.Pad.prototype.add_probe(mask: Gst.PadProbeType, callback: Gst.PadProbeCallback, user_data: Object): {
        // javascript wrapper for 'gst_pad_add_probe'
    }

Be notified of different states of pads. The provided callback is called for every state that matches mask.

Probes are called in groups: First GST_PAD_PROBE_TYPE_BLOCK probes are called, then others, then finally GST_PAD_PROBE_TYPE_IDLE. The only exception here are GST_PAD_PROBE_TYPE_IDLE probes that are called immediately if the pad is already idle while calling Gst.Pad.prototype.add_probe. In each of the groups, probes are called in the order in which they were added.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to add the probe to

`mask` (Gst.PadProbeType) –

the probe mask

`callback` (Gst.PadProbeCallback) –

Gst.PadProbeCallback that will be called with notifications of the pad state

`user_data` (Object) –

user data passed to the callback

Returns (Number) –

an id or 0 if no probe is pending. The id can be used to remove the probe with Gst.Pad.prototype.remove_probe. When using GST_PAD_PROBE_TYPE_IDLE it can happen that the probe can be run immediately and if the probe returns GST_PAD_PROBE_REMOVE this functions returns 0.

MT safe.

#### Gst.Pad.add_probe

    def Gst.Pad.add_probe (self, mask, callback, *user_data):
        #python wrapper for 'gst_pad_add_probe'

Be notified of different states of pads. The provided callback is called for every state that matches mask.

Probes are called in groups: First GST_PAD_PROBE_TYPE_BLOCK probes are called, then others, then finally GST_PAD_PROBE_TYPE_IDLE. The only exception here are GST_PAD_PROBE_TYPE_IDLE probes that are called immediately if the pad is already idle while calling Gst.Pad.add_probe. In each of the groups, probes are called in the order in which they were added.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to add the probe to

`mask` (Gst.PadProbeType) –

the probe mask

`callback` (Gst.PadProbeCallback) –

Gst.PadProbeCallback that will be called with notifications of the pad state

`user_data` (variadic) –

user data passed to the callback

Returns (int) –

an id or 0 if no probe is pending. The id can be used to remove the probe with Gst.Pad.remove_probe. When using GST_PAD_PROBE_TYPE_IDLE it can happen that the probe can be run immediately and if the probe returns GST_PAD_PROBE_REMOVE this functions returns 0.

MT safe.

#### gst_pad_can_link

    gboolean
    gst_pad_can_link (GstPad * srcpad,
                      GstPad * sinkpad)

Checks if the source pad and the sink pad are compatible so they can be linked.

Parameters:

`srcpad` –

the source GstPad.

`sinkpad` –

the sink GstPad.

Returns –

TRUE if the pads can be linked.

#### Gst.Pad.prototype.can_link

    function Gst.Pad.prototype.can_link(sinkpad: Gst.Pad): {
        // javascript wrapper for 'gst_pad_can_link'
    }

Checks if the source pad and the sink pad are compatible so they can be linked.

Parameters:

`srcpad` (Gst.Pad) –

the source Gst.Pad.

`sinkpad` (Gst.Pad) –

the sink Gst.Pad.

Returns (Number) –

true if the pads can be linked.

#### Gst.Pad.can_link

    def Gst.Pad.can_link (self, sinkpad):
        #python wrapper for 'gst_pad_can_link'

Checks if the source pad and the sink pad are compatible so they can be linked.

Parameters:

`srcpad` (Gst.Pad) –

the source Gst.Pad.

`sinkpad` (Gst.Pad) –

the sink Gst.Pad.

Returns (bool) –

True if the pads can be linked.

#### gst_pad_chain

    GstFlowReturn
    gst_pad_chain (GstPad * pad,
                   GstBuffer * buffer)

Chain a buffer to pad.

The function returns GST_FLOW_FLUSHING if the pad was flushing.

If the buffer type is not acceptable for pad (as negotiated with a preceding GST_EVENT_CAPS event), this function returns GST_FLOW_NOT_NEGOTIATED.

The function proceeds calling the chain function installed on pad (see gst_pad_set_chain_function) and the return value of that function is returned to the caller. GST_FLOW_NOT_SUPPORTED is returned if pad has no chain function.

In all cases, success or failure, the caller loses its reference to buffer after calling this function.

Parameters:

`pad` –

a sink GstPad, returns GST_FLOW_ERROR if not.

`buffer` ( [transfer: full]) –

the GstBuffer to send, return GST_FLOW_ERROR if not.

Returns –

a GstFlowReturn from the pad.

MT safe.

#### Gst.Pad.prototype.chain

    function Gst.Pad.prototype.chain(buffer: Gst.Buffer): {
        // javascript wrapper for 'gst_pad_chain'
    }

Chain a buffer to pad.

The function returns Gst.FlowReturn.FLUSHING if the pad was flushing.

If the buffer type is not acceptable for pad (as negotiated with a preceding GST_EVENT_CAPS event), this function returns Gst.FlowReturn.NOT_NEGOTIATED.

The function proceeds calling the chain function installed on pad (see gst_pad_set_chain_function (not introspectable)) and the return value of that function is returned to the caller. Gst.FlowReturn.NOT_SUPPORTED is returned if pad has no chain function.

In all cases, success or failure, the caller loses its reference to buffer after calling this function.

Parameters:

`pad` (Gst.Pad) –

a sink Gst.Pad, returns GST_FLOW_ERROR if not.

`buffer` (Gst.Buffer) –

the Gst.Buffer to send, return GST_FLOW_ERROR if not.

Returns (Gst.FlowReturn) –

a Gst.FlowReturn from the pad.

MT safe.

#### Gst.Pad.chain

    def Gst.Pad.chain (self, buffer):
        #python wrapper for 'gst_pad_chain'

Chain a buffer to pad.

The function returns Gst.FlowReturn.FLUSHING if the pad was flushing.

If the buffer type is not acceptable for pad (as negotiated with a preceding GST_EVENT_CAPS event), this function returns Gst.FlowReturn.NOT_NEGOTIATED.

The function proceeds calling the chain function installed on pad (see gst_pad_set_chain_function (not introspectable)) and the return value of that function is returned to the caller. Gst.FlowReturn.NOT_SUPPORTED is returned if pad has no chain function.

In all cases, success or failure, the caller loses its reference to buffer after calling this function.

Parameters:

`pad` (Gst.Pad) –

a sink Gst.Pad, returns GST_FLOW_ERROR if not.

`buffer` (Gst.Buffer) –

the Gst.Buffer to send, return GST_FLOW_ERROR if not.

Returns (Gst.FlowReturn) –

a Gst.FlowReturn from the pad.

MT safe.

#### gst_pad_chain_list

    GstFlowReturn
    gst_pad_chain_list (GstPad * pad,
                        GstBufferList * list)

Chain a bufferlist to pad.

The function returns GST_FLOW_FLUSHING if the pad was flushing.

If pad was not negotiated properly with a CAPS event, this function returns GST_FLOW_NOT_NEGOTIATED.

The function proceeds calling the chainlist function installed on pad (see gst_pad_set_chain_list_function) and the return value of that function is returned to the caller. GST_FLOW_NOT_SUPPORTED is returned if pad has no chainlist function.

In all cases, success or failure, the caller loses its reference to list after calling this function.

MT safe.

Parameters:

`pad` –

a sink GstPad, returns GST_FLOW_ERROR if not.

`list` ( [transfer: full]) –

the GstBufferList to send, return GST_FLOW_ERROR if not.

Returns –

a GstFlowReturn from the pad.

#### Gst.Pad.prototype.chain_list

    function Gst.Pad.prototype.chain_list(list: Gst.BufferList): {
        // javascript wrapper for 'gst_pad_chain_list'
    }

Chain a bufferlist to pad.

The function returns Gst.FlowReturn.FLUSHING if the pad was flushing.

If pad was not negotiated properly with a CAPS event, this function returns Gst.FlowReturn.NOT_NEGOTIATED.

The function proceeds calling the chainlist function installed on pad (see gst_pad_set_chain_list_function (not introspectable)) and the return value of that function is returned to the caller. Gst.FlowReturn.NOT_SUPPORTED is returned if pad has no chainlist function.

In all cases, success or failure, the caller loses its reference to list after calling this function.

MT safe.

Parameters:

`pad` (Gst.Pad) –

a sink Gst.Pad, returns GST_FLOW_ERROR if not.

`list` (Gst.BufferList) –

the Gst.BufferList to send, return GST_FLOW_ERROR if not.

Returns (Gst.FlowReturn) –

a Gst.FlowReturn from the pad.

#### Gst.Pad.chain_list

    def Gst.Pad.chain_list (self, list):
        #python wrapper for 'gst_pad_chain_list'

Chain a bufferlist to pad.

The function returns Gst.FlowReturn.FLUSHING if the pad was flushing.

If pad was not negotiated properly with a CAPS event, this function returns Gst.FlowReturn.NOT_NEGOTIATED.

The function proceeds calling the chainlist function installed on pad (see gst_pad_set_chain_list_function (not introspectable)) and the return value of that function is returned to the caller. Gst.FlowReturn.NOT_SUPPORTED is returned if pad has no chainlist function.

In all cases, success or failure, the caller loses its reference to list after calling this function.

MT safe.

Parameters:

`pad` (Gst.Pad) –

a sink Gst.Pad, returns GST_FLOW_ERROR if not.

`list` (Gst.BufferList) –

the Gst.BufferList to send, return GST_FLOW_ERROR if not.

Returns (Gst.FlowReturn) –

a Gst.FlowReturn from the pad.

#### gst_pad_check_reconfigure

    gboolean
    gst_pad_check_reconfigure (GstPad * pad)

Check and clear the GST_PAD_FLAG_NEED_RECONFIGURE flag on pad and return TRUE if the flag was set.

Parameters:

`pad` –

the GstPad to check

Returns –

TRUE is the GST_PAD_FLAG_NEED_RECONFIGURE flag was set on pad.

#### Gst.Pad.prototype.check_reconfigure

    function Gst.Pad.prototype.check_reconfigure(): {
        // javascript wrapper for 'gst_pad_check_reconfigure'
    }

Check and clear the Gst.PadFlags.NEED_RECONFIGURE flag on pad and return true if the flag was set.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to check

Returns (Number) –

true is the GST_PAD_FLAG_NEED_RECONFIGURE flag was set on pad.

#### Gst.Pad.check_reconfigure

    def Gst.Pad.check_reconfigure (self):
        #python wrapper for 'gst_pad_check_reconfigure'

Check and clear the Gst.PadFlags.NEED_RECONFIGURE flag on pad and return True if the flag was set.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to check

Returns (bool) –

True is the GST_PAD_FLAG_NEED_RECONFIGURE flag was set on pad.

#### gst_pad_create_stream_id

    gchar *
    gst_pad_create_stream_id (GstPad * pad,
                              GstElement * parent,
                              const gchar * stream_id)

Creates a stream-id for the source GstPad pad by combining the upstream information with the optional stream_id of the stream of pad. pad must have a parent GstElement and which must have zero or one sinkpad. stream_id can only be NULL if the parent element of pad has only a single source pad.

This function generates an unique stream-id by getting the upstream stream-start event stream ID and appending stream_id to it. If the element has no sinkpad it will generate an upstream stream-id by doing an URI query on the element and in the worst case just uses a random number. Source elements that don't implement the URI handler interface should ideally generate a unique, deterministic stream-id manually instead.

Since stream IDs are sorted alphabetically, any numbers in the stream ID should be printed with a fixed number of characters, preceded by 0's, such as by using the format %03u instead of %u.

Parameters:

`pad` –

A source GstPad

`parent` –

Parent GstElement of pad

`stream_id` ( [nullable]) –

The stream-id

Returns –

A stream-id for pad. g_free after usage.

#### Gst.Pad.prototype.create_stream_id

    function Gst.Pad.prototype.create_stream_id(parent: Gst.Element, stream_id: String): {
        // javascript wrapper for 'gst_pad_create_stream_id'
    }

Creates a stream-id for the source Gst.Pad pad by combining the upstream information with the optional stream_id of the stream of pad. pad must have a parent Gst.Element and which must have zero or one sinkpad. stream_id can only be null if the parent element of pad has only a single source pad.

This function generates an unique stream-id by getting the upstream stream-start event stream ID and appending stream_id to it. If the element has no sinkpad it will generate an upstream stream-id by doing an URI query on the element and in the worst case just uses a random number. Source elements that don't implement the URI handler interface should ideally generate a unique, deterministic stream-id manually instead.

Since stream IDs are sorted alphabetically, any numbers in the stream ID should be printed with a fixed number of characters, preceded by 0's, such as by using the format %03u instead of %u.

Parameters:

`pad` (Gst.Pad) –

A source Gst.Pad

`parent` (Gst.Element) –

Parent Gst.Element of pad

`stream_id` (String) –

The stream-id

Returns (String) –

A stream-id for pad. GLib.prototype.free after usage.

#### Gst.Pad.create_stream_id

    def Gst.Pad.create_stream_id (self, parent, stream_id):
        #python wrapper for 'gst_pad_create_stream_id'

Creates a stream-id for the source Gst.Pad pad by combining the upstream information with the optional stream_id of the stream of pad. pad must have a parent Gst.Element and which must have zero or one sinkpad. stream_id can only be None if the parent element of pad has only a single source pad.

This function generates an unique stream-id by getting the upstream stream-start event stream ID and appending stream_id to it. If the element has no sinkpad it will generate an upstream stream-id by doing an URI query on the element and in the worst case just uses a random number. Source elements that don't implement the URI handler interface should ideally generate a unique, deterministic stream-id manually instead.

Since stream IDs are sorted alphabetically, any numbers in the stream ID should be printed with a fixed number of characters, preceded by 0's, such as by using the format %03u instead of %u.

Parameters:

`pad` (Gst.Pad) –

A source Gst.Pad

`parent` (Gst.Element) –

Parent Gst.Element of pad

`stream_id` (str) –

The stream-id

Returns (str) –

A stream-id for pad. GLib.free after usage.

#### gst_pad_create_stream_id_printf

    gchar *
    gst_pad_create_stream_id_printf (GstPad * pad,
                                     GstElement * parent,
                                     const gchar * stream_id,
                                     ... ...)

Creates a stream-id for the source GstPad pad by combining the upstream information with the optional stream_id of the stream of pad. pad must have a parent GstElement and which must have zero or one sinkpad. stream_id can only be NULL if the parent element of pad has only a single source pad.

This function generates an unique stream-id by getting the upstream stream-start event stream ID and appending stream_id to it. If the element has no sinkpad it will generate an upstream stream-id by doing an URI query on the element and in the worst case just uses a random number. Source elements that don't implement the URI handler interface should ideally generate a unique, deterministic stream-id manually instead.

Parameters:

`pad` –

A source GstPad

`parent` –

Parent GstElement of pad

`stream_id` ( [nullable]) –

The stream-id

`...` –

parameters for the stream_id format string

Returns –

A stream-id for pad. g_free after usage.

#### gst_pad_create_stream_id_printf_valist

    gchar *
    gst_pad_create_stream_id_printf_valist (GstPad * pad,
                                            GstElement * parent,
                                            const gchar * stream_id,
                                            va_list var_args)

Creates a stream-id for the source GstPad pad by combining the upstream information with the optional stream_id of the stream of pad. pad must have a parent GstElement and which must have zero or one sinkpad. stream_id can only be NULL if the parent element of pad has only a single source pad.

This function generates an unique stream-id by getting the upstream stream-start event stream ID and appending stream_id to it. If the element has no sinkpad it will generate an upstream stream-id by doing an URI query on the element and in the worst case just uses a random number. Source elements that don't implement the URI handler interface should ideally generate a unique, deterministic stream-id manually instead.

Parameters:

`pad` –

A source GstPad

`parent` –

Parent GstElement of pad

`stream_id` ( [nullable]) –

The stream-id

`var_args` –

parameters for the stream_id format string

Returns –

A stream-id for pad. g_free after usage.

#### gst_pad_event_default

    gboolean
    gst_pad_event_default (GstPad * pad,
                           GstObject * parent,
                           GstEvent * event)

Invokes the default event handler for the given pad.

The EOS event will pause the task associated with pad before it is forwarded to all internally linked pads,

The event is sent to all pads internally linked to pad. This function takes ownership of event.

Parameters:

`pad` –

a GstPad to call the default event handler on.

`parent` ( [nullable]) –

the parent of pad or NULL

`event` ( [transfer: full]) –

the GstEvent to handle.

Returns –

TRUE if the event was sent successfully.

#### Gst.Pad.prototype.event_default

    function Gst.Pad.prototype.event_default(parent: Gst.Object, event: Gst.Event): {
        // javascript wrapper for 'gst_pad_event_default'
    }

Invokes the default event handler for the given pad.

The EOS event will pause the task associated with pad before it is forwarded to all internally linked pads,

The event is sent to all pads internally linked to pad. This function takes ownership of event.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to call the default event handler on.

`parent` (Gst.Object) –

the parent of pad or null

`event` (Gst.Event) –

the Gst.Event to handle.

Returns (Number) –

true if the event was sent successfully.

#### Gst.Pad.event_default

    def Gst.Pad.event_default (self, parent, event):
        #python wrapper for 'gst_pad_event_default'

Invokes the default event handler for the given pad.

The EOS event will pause the task associated with pad before it is forwarded to all internally linked pads,

The event is sent to all pads internally linked to pad. This function takes ownership of event.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to call the default event handler on.

`parent` (Gst.Object) –

the parent of pad or None

`event` (Gst.Event) –

the Gst.Event to handle.

Returns (bool) –

True if the event was sent successfully.

#### gst_pad_forward

    gboolean
    gst_pad_forward (GstPad * pad,
                     GstPadForwardFunction forward,
                     gpointer user_data)

Calls forward for all internally linked pads of pad. This function deals with dynamically changing internal pads and will make sure that the forward function is only called once for each pad.

When forward returns TRUE, no further pads will be processed.

Parameters:

`pad` –

a GstPad

`forward` ( [scope call]) –

a GstPadForwardFunction

`user_data` –

user data passed to forward

Returns –

TRUE if one of the dispatcher functions returned TRUE.

#### Gst.Pad.prototype.forward

    function Gst.Pad.prototype.forward(forward: Gst.PadForwardFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_forward'
    }

Calls forward for all internally linked pads of pad. This function deals with dynamically changing internal pads and will make sure that the forward function is only called once for each pad.

When forward returns true, no further pads will be processed.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad

`forward` (Gst.PadForwardFunction) –

a Gst.PadForwardFunction

`user_data` (Object) –

user data passed to forward

Returns (Number) –

true if one of the dispatcher functions returned true.

#### Gst.Pad.forward

    def Gst.Pad.forward (self, forward, *user_data):
        #python wrapper for 'gst_pad_forward'

Calls forward for all internally linked pads of pad. This function deals with dynamically changing internal pads and will make sure that the forward function is only called once for each pad.

When forward returns True, no further pads will be processed.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad

`forward` (Gst.PadForwardFunction) –

a Gst.PadForwardFunction

`user_data` (variadic) –

user data passed to forward

Returns (bool) –

True if one of the dispatcher functions returned True.

#### gst_pad_get_allowed_caps

    GstCaps *
    gst_pad_get_allowed_caps (GstPad * pad)

Gets the capabilities of the allowed media types that can flow through pad and its peer.

The allowed capabilities is calculated as the intersection of the results of calling gst_pad_query_caps on pad and its peer. The caller owns a reference on the resulting caps.

Parameters:

`pad` –

a GstPad.

Returns ( [transfer: full][nullable]) –

the allowed GstCaps of the pad link. Unref the caps when you no longer need it. This function returns NULL when pad has no peer.

MT safe.

#### Gst.Pad.prototype.get_allowed_caps

    function Gst.Pad.prototype.get_allowed_caps(): {
        // javascript wrapper for 'gst_pad_get_allowed_caps'
    }

Gets the capabilities of the allowed media types that can flow through pad and its peer.

The allowed capabilities is calculated as the intersection of the results of calling Gst.Pad.prototype.query_caps on pad and its peer. The caller owns a reference on the resulting caps.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad.

Returns (Gst.Caps) –

the allowed Gst.Caps of the pad link. Unref the caps when you no longer need it. This function returns null when pad has no peer.

MT safe.

#### Gst.Pad.get_allowed_caps

    def Gst.Pad.get_allowed_caps (self):
        #python wrapper for 'gst_pad_get_allowed_caps'

Gets the capabilities of the allowed media types that can flow through pad and its peer.

The allowed capabilities is calculated as the intersection of the results of calling Gst.Pad.query_caps on pad and its peer. The caller owns a reference on the resulting caps.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad.

Returns (Gst.Caps) –

the allowed Gst.Caps of the pad link. Unref the caps when you no longer need it. This function returns None when pad has no peer.

MT safe.

#### gst_pad_get_current_caps

    GstCaps *
    gst_pad_get_current_caps (GstPad * pad)

Gets the capabilities currently configured on pad with the last GST_EVENT_CAPS event.

Parameters:

`pad` –

a GstPad to get the current capabilities of.

Returns ( [transfer: full][nullable]) –

the current caps of the pad with incremented ref-count or NULL when pad has no caps. Unref after usage.

#### Gst.Pad.prototype.get_current_caps

    function Gst.Pad.prototype.get_current_caps(): {
        // javascript wrapper for 'gst_pad_get_current_caps'
    }

Gets the capabilities currently configured on pad with the last Gst.EventType.CAPS event.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to get the current capabilities of.

Returns (Gst.Caps) –

the current caps of the pad with incremented ref-count or null when pad has no caps. Unref after usage.

#### Gst.Pad.get_current_caps

    def Gst.Pad.get_current_caps (self):
        #python wrapper for 'gst_pad_get_current_caps'

Gets the capabilities currently configured on pad with the last Gst.EventType.CAPS event.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to get the current capabilities of.

Returns (Gst.Caps) –

the current caps of the pad with incremented ref-count or None when pad has no caps. Unref after usage.

#### gst_pad_get_direction

    GstPadDirection
    gst_pad_get_direction (GstPad * pad)

Gets the direction of the pad. The direction of the pad is decided at construction time so this function does not take the LOCK.

Parameters:

`pad` –

a GstPad to get the direction of.

Returns –

the GstPadDirection of the pad.

MT safe.

#### Gst.Pad.prototype.get_direction

    function Gst.Pad.prototype.get_direction(): {
        // javascript wrapper for 'gst_pad_get_direction'
    }

Gets the direction of the pad. The direction of the pad is decided at construction time so this function does not take the LOCK.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to get the direction of.

Returns (Gst.PadDirection) –

the Gst.PadDirection of the pad.

MT safe.

#### Gst.Pad.get_direction

    def Gst.Pad.get_direction (self):
        #python wrapper for 'gst_pad_get_direction'

Gets the direction of the pad. The direction of the pad is decided at construction time so this function does not take the LOCK.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to get the direction of.

Returns (Gst.PadDirection) –

the Gst.PadDirection of the pad.

MT safe.

#### gst_pad_get_element_private

    gpointer
    gst_pad_get_element_private (GstPad * pad)

Gets the private data of a pad. No locking is performed in this function.

Parameters:

`pad` –

the GstPad to get the private data of.

Returns ( [transfer: none][nullable]) –

a gpointer to the private data.

#### Gst.Pad.prototype.get_element_private

    function Gst.Pad.prototype.get_element_private(): {
        // javascript wrapper for 'gst_pad_get_element_private'
    }

Gets the private data of a pad. No locking is performed in this function.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to get the private data of.

Returns (Object) –

a Object to the private data.

#### Gst.Pad.get_element_private

    def Gst.Pad.get_element_private (self):
        #python wrapper for 'gst_pad_get_element_private'

Gets the private data of a pad. No locking is performed in this function.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to get the private data of.

Returns (object) –

a object to the private data.

#### gst_pad_get_last_flow_return

    GstFlowReturn
    gst_pad_get_last_flow_return (GstPad * pad)

Gets the GstFlowReturn return from the last data passed by this pad.

Parameters:

`pad` –

the GstPad

Returns –
No description available

Since : 1.4

#### Gst.Pad.prototype.get_last_flow_return

    function Gst.Pad.prototype.get_last_flow_return(): {
        // javascript wrapper for 'gst_pad_get_last_flow_return'
    }

Gets the Gst.FlowReturn return from the last data passed by this pad.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad

Returns (Gst.FlowReturn) –
No description available

Since : 1.4

#### Gst.Pad.get_last_flow_return

    def Gst.Pad.get_last_flow_return (self):
        #python wrapper for 'gst_pad_get_last_flow_return'

Gets the Gst.FlowReturn return from the last data passed by this pad.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad

Returns (Gst.FlowReturn) –
No description available

Since : 1.4

#### gst_pad_get_offset

    gint64
    gst_pad_get_offset (GstPad * pad)

Get the offset applied to the running time of pad. pad has to be a source pad.

Parameters:

`pad` –

a GstPad

Returns –

the offset.

#### Gst.Pad.prototype.get_offset

    function Gst.Pad.prototype.get_offset(): {
        // javascript wrapper for 'gst_pad_get_offset'
    }

Get the offset applied to the running time of pad. pad has to be a source pad.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad

Returns (Number) –

the offset.

#### Gst.Pad.get_offset

    def Gst.Pad.get_offset (self):
        #python wrapper for 'gst_pad_get_offset'

Get the offset applied to the running time of pad. pad has to be a source pad.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad

Returns (int) –

the offset.

#### gst_pad_get_pad_template

    GstPadTemplate *
    gst_pad_get_pad_template (GstPad * pad)

Gets the template for pad.

Parameters:

`pad` –

a GstPad.

Returns ( [transfer: full][nullable]) –

the GstPadTemplate from which this pad was instantiated, or NULL if this pad has no template. Unref after usage.

#### Gst.Pad.prototype.get_pad_template

    function Gst.Pad.prototype.get_pad_template(): {
        // javascript wrapper for 'gst_pad_get_pad_template'
    }

Gets the template for pad.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad.

Returns (Gst.PadTemplate) –

the Gst.PadTemplate from which this pad was instantiated, or null if this pad has no template. Unref after usage.

#### Gst.Pad.get_pad_template

    def Gst.Pad.get_pad_template (self):
        #python wrapper for 'gst_pad_get_pad_template'

Gets the template for pad.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad.

Returns (Gst.PadTemplate) –

the Gst.PadTemplate from which this pad was instantiated, or None if this pad has no template. Unref after usage.

#### gst_pad_get_pad_template_caps

    GstCaps *
    gst_pad_get_pad_template_caps (GstPad * pad)

Gets the capabilities for pad's template.

Parameters:

`pad` –

a GstPad to get the template capabilities from.

Returns ( [transfer: full]) –

the GstCaps of this pad template. Unref after usage.

#### Gst.Pad.prototype.get_pad_template_caps

    function Gst.Pad.prototype.get_pad_template_caps(): {
        // javascript wrapper for 'gst_pad_get_pad_template_caps'
    }

Gets the capabilities for pad's template.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to get the template capabilities from.

Returns (Gst.Caps) –

the Gst.Caps of this pad template. Unref after usage.

#### Gst.Pad.get_pad_template_caps

    def Gst.Pad.get_pad_template_caps (self):
        #python wrapper for 'gst_pad_get_pad_template_caps'

Gets the capabilities for pad's template.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to get the template capabilities from.

Returns (Gst.Caps) –

the Gst.Caps of this pad template. Unref after usage.

#### gst_pad_get_parent_element

    GstElement *
    gst_pad_get_parent_element (GstPad * pad)

Gets the parent of pad, cast to a GstElement. If a pad has no parent or its parent is not an element, return NULL.

Parameters:

`pad` –

a pad

Returns ( [transfer: full][nullable]) –

the parent of the pad. The caller has a reference on the parent, so unref when you're finished with it.

MT safe.

#### Gst.Pad.prototype.get_parent_element

    function Gst.Pad.prototype.get_parent_element(): {
        // javascript wrapper for 'gst_pad_get_parent_element'
    }

Gets the parent of pad, cast to a Gst.Element. If a pad has no parent or its parent is not an element, return null.

Parameters:

`pad` (Gst.Pad) –

a pad

Returns (Gst.Element) –

the parent of the pad. The caller has a reference on the parent, so unref when you're finished with it.

MT safe.

#### Gst.Pad.get_parent_element

    def Gst.Pad.get_parent_element (self):
        #python wrapper for 'gst_pad_get_parent_element'

Gets the parent of pad, cast to a Gst.Element. If a pad has no parent or its parent is not an element, return None.

Parameters:

`pad` (Gst.Pad) –

a pad

Returns (Gst.Element) –

the parent of the pad. The caller has a reference on the parent, so unref when you're finished with it.

MT safe.

#### gst_pad_get_peer

    GstPad *
    gst_pad_get_peer (GstPad * pad)

Gets the peer of pad. This function refs the peer pad so you need to unref it after use.

Parameters:

`pad` –

a GstPad to get the peer of.

Returns ( [transfer: full][nullable]) –

the peer GstPad. Unref after usage.

MT safe.

#### Gst.Pad.prototype.get_peer

    function Gst.Pad.prototype.get_peer(): {
        // javascript wrapper for 'gst_pad_get_peer'
    }

Gets the peer of pad. This function refs the peer pad so you need to unref it after use.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to get the peer of.

Returns (Gst.Pad) –

the peer Gst.Pad. Unref after usage.

MT safe.

#### Gst.Pad.get_peer

    def Gst.Pad.get_peer (self):
        #python wrapper for 'gst_pad_get_peer'

Gets the peer of pad. This function refs the peer pad so you need to unref it after use.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to get the peer of.

Returns (Gst.Pad) –

the peer Gst.Pad. Unref after usage.

MT safe.

#### gst_pad_get_range

    GstFlowReturn
    gst_pad_get_range (GstPad * pad,
                       guint64 offset,
                       guint size,
                       GstBuffer ** buffer)

When pad is flushing this function returns GST_FLOW_FLUSHING immediately and buffer is NULL.

Calls the getrange function of pad, see GstPadGetRangeFunction for a description of a getrange function. If pad has no getrange function installed (see gst_pad_set_getrange_function) this function returns GST_FLOW_NOT_SUPPORTED.

If buffer points to a variable holding NULL, a valid new GstBuffer will be placed in buffer when this function returns GST_FLOW_OK. The new buffer must be freed with gst_buffer_unref after usage.

When buffer points to a variable that points to a valid GstBuffer, the buffer will be filled with the result data when this function returns GST_FLOW_OK. If the provided buffer is larger than size, only size bytes will be filled in the result buffer and its size will be updated accordingly.

Note that less than size bytes can be returned in buffer when, for example, an EOS condition is near or when buffer is not large enough to hold size bytes. The caller should check the result buffer size to get the result size.

When this function returns any other result value than GST_FLOW_OK, buffer will be unchanged.

This is a lowlevel function. Usually gst_pad_pull_range is used.

Parameters:

`pad` –

a src GstPad, returns GST_FLOW_ERROR if not.

`offset` –

The start offset of the buffer

`size` –

The length of the buffer

`buffer` ( [out]) –

a pointer to hold the GstBuffer, returns GST_FLOW_ERROR if NULL.

Returns –

a GstFlowReturn from the pad.

MT safe.

#### Gst.Pad.prototype.get_range

    function Gst.Pad.prototype.get_range(offset: Number, size: Number): {
        // javascript wrapper for 'gst_pad_get_range'
    }

When pad is flushing this function returns Gst.FlowReturn.FLUSHING immediately and buffer is null.

Calls the getrange function of pad, see Gst.PadGetRangeFunction for a description of a getrange function. If pad has no getrange function installed (see gst_pad_set_getrange_function (not introspectable)) this function returns Gst.FlowReturn.NOT_SUPPORTED.

If buffer points to a variable holding null, a valid new Gst.Buffer will be placed in buffer when this function returns Gst.FlowReturn.OK. The new buffer must be freed with gst_buffer_unref (not introspectable) after usage.

When buffer points to a variable that points to a valid Gst.Buffer, the buffer will be filled with the result data when this function returns Gst.FlowReturn.OK. If the provided buffer is larger than size, only size bytes will be filled in the result buffer and its size will be updated accordingly.

Note that less than size bytes can be returned in buffer when, for example, an EOS condition is near or when buffer is not large enough to hold size bytes. The caller should check the result buffer size to get the result size.

When this function returns any other result value than Gst.FlowReturn.OK, buffer will be unchanged.

This is a lowlevel function. Usually Gst.Pad.prototype.pull_range is used.

Parameters:

`pad` (Gst.Pad) –

a src Gst.Pad, returns Gst.FlowReturn.ERROR if not.

`offset` (Number) –

The start offset of the buffer

`size` (Number) –

The length of the buffer

Returns a tuple made of:

(Gst.FlowReturn ) –

a Gst.FlowReturn from the pad.

MT safe.

`buffer` (Gst.Buffer ) –

a Gst.FlowReturn from the pad.

MT safe.

#### Gst.Pad.get_range

    def Gst.Pad.get_range (self, offset, size):
        #python wrapper for 'gst_pad_get_range'

When pad is flushing this function returns Gst.FlowReturn.FLUSHING immediately and buffer is None.

Calls the getrange function of pad, see Gst.PadGetRangeFunction for a description of a getrange function. If pad has no getrange function installed (see gst_pad_set_getrange_function (not introspectable)) this function returns Gst.FlowReturn.NOT_SUPPORTED.

If buffer points to a variable holding None, a valid new Gst.Buffer will be placed in buffer when this function returns Gst.FlowReturn.OK. The new buffer must be freed with gst_buffer_unref (not introspectable) after usage.

When buffer points to a variable that points to a valid Gst.Buffer, the buffer will be filled with the result data when this function returns Gst.FlowReturn.OK. If the provided buffer is larger than size, only size bytes will be filled in the result buffer and its size will be updated accordingly.

Note that less than size bytes can be returned in buffer when, for example, an EOS condition is near or when buffer is not large enough to hold size bytes. The caller should check the result buffer size to get the result size.

When this function returns any other result value than Gst.FlowReturn.OK, buffer will be unchanged.

This is a lowlevel function. Usually Gst.Pad.pull_range is used.

Parameters:

`pad` (Gst.Pad) –

a src Gst.Pad, returns Gst.FlowReturn.ERROR if not.

`offset` (int) –

The start offset of the buffer

`size` (int) –

The length of the buffer

Returns a tuple made of:

(Gst.FlowReturn ) –

a Gst.FlowReturn from the pad.

MT safe.

`buffer` (Gst.Buffer ) –

a Gst.FlowReturn from the pad.

MT safe.

#### gst_pad_get_single_internal_link

    GstPad *
    gst_pad_get_single_internal_link (GstPad * pad)

If there is a single internal link of the given pad, this function will return it. Otherwise, it will return NULL.

Parameters:

`pad` –

the GstPad to get the internal link of.

Returns ( [transfer: full][nullable]) –

a GstPad, or NULL if pad has none or more than one internal links. Unref returned pad with gst_object_unref.

Since : 1.18

#### Gst.Pad.prototype.get_single_internal_link

    function Gst.Pad.prototype.get_single_internal_link(): {
        // javascript wrapper for 'gst_pad_get_single_internal_link'
    }

If there is a single internal link of the given pad, this function will return it. Otherwise, it will return NULL.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to get the internal link of.

Returns (Gst.Pad) –

a Gst.Pad, or null if pad has none or more than one internal links. Unref returned pad with Gst.Object.prototype.unref.

Since : 1.18

#### Gst.Pad.get_single_internal_link

    def Gst.Pad.get_single_internal_link (self):
        #python wrapper for 'gst_pad_get_single_internal_link'

If there is a single internal link of the given pad, this function will return it. Otherwise, it will return NULL.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to get the internal link of.

Returns (Gst.Pad) –

a Gst.Pad, or None if pad has none or more than one internal links. Unref returned pad with Gst.Object.unref.

Since : 1.18

#### gst_pad_get_sticky_event

    GstEvent *
    gst_pad_get_sticky_event (GstPad * pad,
                              GstEventType event_type,
                              guint idx)

Returns a new reference of the sticky event of type event_type from the event.

Parameters:

`pad` –

the GstPad to get the event from.

`event_type` –

the GstEventType that should be retrieved.

`idx` –

the index of the event

Returns ( [transfer: full][nullable]) –

a GstEvent of type event_type or NULL when no event of event_type was on pad. Unref after usage.

#### Gst.Pad.prototype.get_sticky_event

    function Gst.Pad.prototype.get_sticky_event(event_type: Gst.EventType, idx: Number): {
        // javascript wrapper for 'gst_pad_get_sticky_event'
    }

Returns a new reference of the sticky event of type event_type from the event.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to get the event from.

`event_type` (Gst.EventType) –

the Gst.EventType that should be retrieved.

`idx` (Number) –

the index of the event

Returns (Gst.Event) –

a Gst.Event of type event_type or null when no event of event_type was on pad. Unref after usage.

#### Gst.Pad.get_sticky_event

    def Gst.Pad.get_sticky_event (self, event_type, idx):
        #python wrapper for 'gst_pad_get_sticky_event'

Returns a new reference of the sticky event of type event_type from the event.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to get the event from.

`event_type` (Gst.EventType) –

the Gst.EventType that should be retrieved.

`idx` (int) –

the index of the event

Returns (Gst.Event) –

a Gst.Event of type event_type or None when no event of event_type was on pad. Unref after usage.

#### gst_pad_get_stream

    GstStream *
    gst_pad_get_stream (GstPad * pad)

Returns the current GstStream for the pad, or NULL if none has been set yet, i.e. the pad has not received a stream-start event yet.

This is a convenience wrapper around gst_pad_get_sticky_event and gst_event_parse_stream.

Parameters:

`pad` –

A source GstPad

Returns ( [nullable][transfer: full]) –

the current GstStream for pad, or NULL. unref the returned stream when no longer needed.

Since : 1.10

#### Gst.Pad.prototype.get_stream

    function Gst.Pad.prototype.get_stream(): {
        // javascript wrapper for 'gst_pad_get_stream'
    }

Returns the current Gst.Stream for the pad, or null if none has been set yet, i.e. the pad has not received a stream-start event yet.

This is a convenience wrapper around Gst.Pad.prototype.get_sticky_event and Gst.Event.prototype.parse_stream.

Parameters:

`pad` (Gst.Pad) –

A source Gst.Pad

Returns (Gst.Stream) –

the current Gst.Stream for pad, or null. unref the returned stream when no longer needed.

Since : 1.10

#### Gst.Pad.get_stream

    def Gst.Pad.get_stream (self):
        #python wrapper for 'gst_pad_get_stream'

Returns the current Gst.Stream for the pad, or None if none has been set yet, i.e. the pad has not received a stream-start event yet.

This is a convenience wrapper around Gst.Pad.get_sticky_event and Gst.Event.parse_stream.

Parameters:

`pad` (Gst.Pad) –

A source Gst.Pad

Returns (Gst.Stream) –

the current Gst.Stream for pad, or None. unref the returned stream when no longer needed.

Since : 1.10

#### gst_pad_get_stream_id

    gchar *
    gst_pad_get_stream_id (GstPad * pad)

Returns the current stream-id for the pad, or NULL if none has been set yet, i.e. the pad has not received a stream-start event yet.

This is a convenience wrapper around gst_pad_get_sticky_event and gst_event_parse_stream_start.

The returned stream-id string should be treated as an opaque string, its contents should not be interpreted.

Parameters:

`pad` –

A source GstPad

Returns ( [nullable]) –

a newly-allocated copy of the stream-id for pad, or NULL. g_free the returned string when no longer needed.

Since : 1.2

#### Gst.Pad.prototype.get_stream_id

    function Gst.Pad.prototype.get_stream_id(): {
        // javascript wrapper for 'gst_pad_get_stream_id'
    }

Returns the current stream-id for the pad, or null if none has been set yet, i.e. the pad has not received a stream-start event yet.

This is a convenience wrapper around Gst.Pad.prototype.get_sticky_event and Gst.Event.prototype.parse_stream_start.

The returned stream-id string should be treated as an opaque string, its contents should not be interpreted.

Parameters:

`pad` (Gst.Pad) –

A source Gst.Pad

Returns (String) –

a newly-allocated copy of the stream-id for pad, or null. GLib.prototype.free the returned string when no longer needed.

Since : 1.2

#### Gst.Pad.get_stream_id

    def Gst.Pad.get_stream_id (self):
        #python wrapper for 'gst_pad_get_stream_id'

Returns the current stream-id for the pad, or None if none has been set yet, i.e. the pad has not received a stream-start event yet.

This is a convenience wrapper around Gst.Pad.get_sticky_event and Gst.Event.parse_stream_start.

The returned stream-id string should be treated as an opaque string, its contents should not be interpreted.

Parameters:

`pad` (Gst.Pad) –

A source Gst.Pad

Returns (str) –

a newly-allocated copy of the stream-id for pad, or None. GLib.free the returned string when no longer needed.

Since : 1.2

#### gst_pad_get_task_state

    GstTaskState
    gst_pad_get_task_state (GstPad * pad)

Get pad task state. If no task is currently set, GST_TASK_STOPPED is returned.

Parameters:

`pad` –

the GstPad to get task state from

Returns –

The current state of pad's task.

Since : 1.12

#### Gst.Pad.prototype.get_task_state

    function Gst.Pad.prototype.get_task_state(): {
        // javascript wrapper for 'gst_pad_get_task_state'
    }

Get pad task state. If no task is currently set, Gst.TaskState.STOPPED is returned.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to get task state from

Returns (Gst.TaskState) –

The current state of pad's task.

Since : 1.12

#### Gst.Pad.get_task_state

    def Gst.Pad.get_task_state (self):
        #python wrapper for 'gst_pad_get_task_state'

Get pad task state. If no task is currently set, Gst.TaskState.STOPPED is returned.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to get task state from

Returns (Gst.TaskState) –

The current state of pad's task.

Since : 1.12

#### gst_pad_has_current_caps

    gboolean
    gst_pad_has_current_caps (GstPad * pad)

Check if pad has caps set on it with a GST_EVENT_CAPS event.

Parameters:

`pad` –

a GstPad to check

Returns –

TRUE when pad has caps associated with it.

#### Gst.Pad.prototype.has_current_caps

    function Gst.Pad.prototype.has_current_caps(): {
        // javascript wrapper for 'gst_pad_has_current_caps'
    }

Check if pad has caps set on it with a Gst.EventType.CAPS event.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to check

Returns (Number) –

true when pad has caps associated with it.

#### Gst.Pad.has_current_caps

    def Gst.Pad.has_current_caps (self):
        #python wrapper for 'gst_pad_has_current_caps'

Check if pad has caps set on it with a Gst.EventType.CAPS event.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to check

Returns (bool) –

True when pad has caps associated with it.

#### gst_pad_is_active

    gboolean
    gst_pad_is_active (GstPad * pad)

Query if a pad is active

Parameters:

`pad` –

the GstPad to query

Returns –

TRUE if the pad is active.

MT safe.

#### Gst.Pad.prototype.is_active

    function Gst.Pad.prototype.is_active(): {
        // javascript wrapper for 'gst_pad_is_active'
    }

Query if a pad is active

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to query

Returns (Number) –

true if the pad is active.

MT safe.

#### Gst.Pad.is_active

    def Gst.Pad.is_active (self):
        #python wrapper for 'gst_pad_is_active'

Query if a pad is active

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to query

Returns (bool) –

True if the pad is active.

MT safe.

#### gst_pad_is_blocked

    gboolean
    gst_pad_is_blocked (GstPad * pad)

Checks if the pad is blocked or not. This function returns the last requested state of the pad. It is not certain that the pad is actually blocking at this point (see gst_pad_is_blocking).

Parameters:

`pad` –

the GstPad to query

Returns –

TRUE if the pad is blocked.

MT safe.

#### Gst.Pad.prototype.is_blocked

    function Gst.Pad.prototype.is_blocked(): {
        // javascript wrapper for 'gst_pad_is_blocked'
    }

Checks if the pad is blocked or not. This function returns the last requested state of the pad. It is not certain that the pad is actually blocking at this point (see Gst.Pad.prototype.is_blocking).

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to query

Returns (Number) –

true if the pad is blocked.

MT safe.

#### Gst.Pad.is_blocked

    def Gst.Pad.is_blocked (self):
        #python wrapper for 'gst_pad_is_blocked'

Checks if the pad is blocked or not. This function returns the last requested state of the pad. It is not certain that the pad is actually blocking at this point (see Gst.Pad.is_blocking).

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to query

Returns (bool) –

True if the pad is blocked.

MT safe.

#### gst_pad_is_blocking

    gboolean
    gst_pad_is_blocking (GstPad * pad)

Checks if the pad is blocking or not. This is a guaranteed state of whether the pad is actually blocking on a GstBuffer or a GstEvent.

Parameters:

`pad` –

the GstPad to query

Returns –

TRUE if the pad is blocking.

MT safe.

#### Gst.Pad.prototype.is_blocking

    function Gst.Pad.prototype.is_blocking(): {
        // javascript wrapper for 'gst_pad_is_blocking'
    }

Checks if the pad is blocking or not. This is a guaranteed state of whether the pad is actually blocking on a Gst.Buffer or a Gst.Event.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to query

Returns (Number) –

true if the pad is blocking.

MT safe.

#### Gst.Pad.is_blocking

    def Gst.Pad.is_blocking (self):
        #python wrapper for 'gst_pad_is_blocking'

Checks if the pad is blocking or not. This is a guaranteed state of whether the pad is actually blocking on a Gst.Buffer or a Gst.Event.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to query

Returns (bool) –

True if the pad is blocking.

MT safe.

#### gst_pad_is_linked

    gboolean
    gst_pad_is_linked (GstPad * pad)

Checks if a pad is linked to another pad or not.

Parameters:

`pad` –

pad to check

Returns –

TRUE if the pad is linked, FALSE otherwise.

MT safe.

#### Gst.Pad.prototype.is_linked

    function Gst.Pad.prototype.is_linked(): {
        // javascript wrapper for 'gst_pad_is_linked'
    }

Checks if a pad is linked to another pad or not.

Parameters:

`pad` (Gst.Pad) –

pad to check

Returns (Number) –

true if the pad is linked, false otherwise.

MT safe.

#### Gst.Pad.is_linked

    def Gst.Pad.is_linked (self):
        #python wrapper for 'gst_pad_is_linked'

Checks if a pad is linked to another pad or not.

Parameters:

`pad` (Gst.Pad) –

pad to check

Returns (bool) –

True if the pad is linked, False otherwise.

MT safe.

#### gst_pad_iterate_internal_links

    GstIterator *
    gst_pad_iterate_internal_links (GstPad * pad)

Gets an iterator for the pads to which the given pad is linked to inside of the parent element.

Each GstPad element yielded by the iterator will have its refcount increased, so unref after use.

Free-function: gst_iterator_free

Parameters:

`pad` –

the GstPad to get the internal links of.

Returns ( [transfer: full][nullable]) –

a new GstIterator of GstPad or NULL when the pad does not have an iterator function configured. Use gst_iterator_free after usage.

#### Gst.Pad.prototype.iterate_internal_links

    function Gst.Pad.prototype.iterate_internal_links(): {
        // javascript wrapper for 'gst_pad_iterate_internal_links'
    }

Gets an iterator for the pads to which the given pad is linked to inside of the parent element.

Each Gst.Pad element yielded by the iterator will have its refcount increased, so unref after use.

Free-function: gst_iterator_free

Parameters:

`pad` (Gst.Pad) –

the GstPad to get the internal links of.

Returns (Gst.Iterator) –

a new Gst.Iterator of Gst.Pad or null when the pad does not have an iterator function configured. Use Gst.Iterator.prototype.free after usage.

#### Gst.Pad.iterate_internal_links

    def Gst.Pad.iterate_internal_links (self):
        #python wrapper for 'gst_pad_iterate_internal_links'

Gets an iterator for the pads to which the given pad is linked to inside of the parent element.

Each Gst.Pad element yielded by the iterator will have its refcount increased, so unref after use.

Free-function: gst_iterator_free

Parameters:

`pad` (Gst.Pad) –

the GstPad to get the internal links of.

Returns (Gst.Iterator) –

a new Gst.Iterator of Gst.Pad or None when the pad does not have an iterator function configured. Use Gst.Iterator.free after usage.

#### gst_pad_iterate_internal_links_default

    GstIterator *
    gst_pad_iterate_internal_links_default (GstPad * pad,
                                            GstObject * parent)

Iterate the list of pads to which the given pad is linked to inside of the parent element. This is the default handler, and thus returns an iterator of all of the pads inside the parent element with opposite direction.

The caller must free this iterator after use with gst_iterator_free.

Parameters:

`pad` –

the GstPad to get the internal links of.

`parent` ( [nullable]) –

the parent of pad or NULL

Returns ( [nullable]) –

a GstIterator of GstPad, or NULL if pad has no parent. Unref each returned pad with gst_object_unref.

#### Gst.Pad.prototype.iterate_internal_links_default

    function Gst.Pad.prototype.iterate_internal_links_default(parent: Gst.Object): {
        // javascript wrapper for 'gst_pad_iterate_internal_links_default'
    }

Iterate the list of pads to which the given pad is linked to inside of the parent element. This is the default handler, and thus returns an iterator of all of the pads inside the parent element with opposite direction.

The caller must free this iterator after use with Gst.Iterator.prototype.free.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to get the internal links of.

`parent` (Gst.Object) –

the parent of pad or null

Returns (Gst.Iterator) –

a Gst.Iterator of Gst.Pad, or null if pad has no parent. Unref each returned pad with Gst.Object.prototype.unref.

#### Gst.Pad.iterate_internal_links_default

    def Gst.Pad.iterate_internal_links_default (self, parent):
        #python wrapper for 'gst_pad_iterate_internal_links_default'

Iterate the list of pads to which the given pad is linked to inside of the parent element. This is the default handler, and thus returns an iterator of all of the pads inside the parent element with opposite direction.

The caller must free this iterator after use with Gst.Iterator.free.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to get the internal links of.

`parent` (Gst.Object) –

the parent of pad or None

Returns (Gst.Iterator) –

a Gst.Iterator of Gst.Pad, or None if pad has no parent. Unref each returned pad with Gst.Object.unref.

#### gst_pad_link

    GstPadLinkReturn
    gst_pad_link (GstPad * srcpad,
                  GstPad * sinkpad)

Links the source pad and the sink pad.

Parameters:

`srcpad` –

the source GstPad to link.

`sinkpad` –

the sink GstPad to link.

Returns –

A result code indicating if the connection worked or what went wrong.

MT Safe.

#### Gst.Pad.prototype.link

    function Gst.Pad.prototype.link(sinkpad: Gst.Pad): {
        // javascript wrapper for 'gst_pad_link'
    }

Links the source pad and the sink pad.

Parameters:

`srcpad` (Gst.Pad) –

the source Gst.Pad to link.

`sinkpad` (Gst.Pad) –

the sink Gst.Pad to link.

Returns (Gst.PadLinkReturn) –

A result code indicating if the connection worked or what went wrong.

MT Safe.

#### Gst.Pad.link

    def Gst.Pad.link (self, sinkpad):
        #python wrapper for 'gst_pad_link'

Links the source pad and the sink pad.

Parameters:

`srcpad` (Gst.Pad) –

the source Gst.Pad to link.

`sinkpad` (Gst.Pad) –

the sink Gst.Pad to link.

Returns (Gst.PadLinkReturn) –

A result code indicating if the connection worked or what went wrong.

MT Safe.

#### gst_pad_link_full

    GstPadLinkReturn
    gst_pad_link_full (GstPad * srcpad,
                       GstPad * sinkpad,
                       GstPadLinkCheck flags)

Links the source pad and the sink pad.

This variant of gst_pad_link provides a more granular control on the checks being done when linking. While providing some considerable speedups the caller of this method must be aware that wrong usage of those flags can cause severe issues. Refer to the documentation of GstPadLinkCheck for more information.

MT Safe.

Parameters:

`srcpad` –

the source GstPad to link.

`sinkpad` –

the sink GstPad to link.

`flags` –

the checks to validate when linking

Returns –

A result code indicating if the connection worked or what went wrong.

#### Gst.Pad.prototype.link_full

    function Gst.Pad.prototype.link_full(sinkpad: Gst.Pad, flags: Gst.PadLinkCheck): {
        // javascript wrapper for 'gst_pad_link_full'
    }

Links the source pad and the sink pad.

This variant of Gst.Pad.prototype.link provides a more granular control on the checks being done when linking. While providing some considerable speedups the caller of this method must be aware that wrong usage of those flags can cause severe issues. Refer to the documentation of Gst.PadLinkCheck for more information.

MT Safe.

Parameters:

`srcpad` (Gst.Pad) –

the source Gst.Pad to link.

`sinkpad` (Gst.Pad) –

the sink Gst.Pad to link.

`flags` (Gst.PadLinkCheck) –

the checks to validate when linking

Returns (Gst.PadLinkReturn) –

A result code indicating if the connection worked or what went wrong.

#### Gst.Pad.link_full

    def Gst.Pad.link_full (self, sinkpad, flags):
        #python wrapper for 'gst_pad_link_full'

Links the source pad and the sink pad.

This variant of Gst.Pad.link provides a more granular control on the checks being done when linking. While providing some considerable speedups the caller of this method must be aware that wrong usage of those flags can cause severe issues. Refer to the documentation of Gst.PadLinkCheck for more information.

MT Safe.

Parameters:

`srcpad` (Gst.Pad) –

the source Gst.Pad to link.

`sinkpad` (Gst.Pad) –

the sink Gst.Pad to link.

`flags` (Gst.PadLinkCheck) –

the checks to validate when linking

Returns (Gst.PadLinkReturn) –

A result code indicating if the connection worked or what went wrong.

#### gst_pad_link_maybe_ghosting

    gboolean
    gst_pad_link_maybe_ghosting (GstPad * src,
                                 GstPad * sink)

Links src to sink, creating any GstGhostPad's in between as necessary.

This is a convenience function to save having to create and add intermediate GstGhostPad's as required for linking across GstBin boundaries.

If src or sink pads don't have parent elements or do not share a common ancestor, the link will fail.

Parameters:

`src` –

a GstPad

`sink` –

a GstPad

Returns –

whether the link succeeded.

Since : 1.10

#### Gst.Pad.prototype.link_maybe_ghosting

    function Gst.Pad.prototype.link_maybe_ghosting(sink: Gst.Pad): {
        // javascript wrapper for 'gst_pad_link_maybe_ghosting'
    }

Links src to sink, creating any Gst.GhostPad's in between as necessary.

This is a convenience function to save having to create and add intermediate Gst.GhostPad's as required for linking across Gst.Bin boundaries.

If src or sink pads don't have parent elements or do not share a common ancestor, the link will fail.

Parameters:

`src` (Gst.Pad) –

a Gst.Pad

`sink` (Gst.Pad) –

a Gst.Pad

Returns (Number) –

whether the link succeeded.

Since : 1.10

#### Gst.Pad.link_maybe_ghosting

    def Gst.Pad.link_maybe_ghosting (self, sink):
        #python wrapper for 'gst_pad_link_maybe_ghosting'

Links src to sink, creating any Gst.GhostPad's in between as necessary.

This is a convenience function to save having to create and add intermediate Gst.GhostPad's as required for linking across Gst.Bin boundaries.

If src or sink pads don't have parent elements or do not share a common ancestor, the link will fail.

Parameters:

`src` (Gst.Pad) –

a Gst.Pad

`sink` (Gst.Pad) –

a Gst.Pad

Returns (bool) –

whether the link succeeded.

Since : 1.10

#### gst_pad_link_maybe_ghosting_full

    gboolean
    gst_pad_link_maybe_ghosting_full (GstPad * src,
                                      GstPad * sink,
                                      GstPadLinkCheck flags)

Links src to sink, creating any GstGhostPad's in between as necessary.

This is a convenience function to save having to create and add intermediate GstGhostPad's as required for linking across GstBin boundaries.

If src or sink pads don't have parent elements or do not share a common ancestor, the link will fail.

Calling gst_pad_link_maybe_ghosting_full with flags == GST_PAD_LINK_CHECK_DEFAULT is the recommended way of linking pads with safety checks applied.

Parameters:

`src` –

a GstPad

`sink` –

a GstPad

`flags` –

some GstPadLinkCheck flags

Returns –

whether the link succeeded.

Since : 1.10

#### Gst.Pad.prototype.link_maybe_ghosting_full

    function Gst.Pad.prototype.link_maybe_ghosting_full(sink: Gst.Pad, flags: Gst.PadLinkCheck): {
        // javascript wrapper for 'gst_pad_link_maybe_ghosting_full'
    }

Links src to sink, creating any Gst.GhostPad's in between as necessary.

This is a convenience function to save having to create and add intermediate Gst.GhostPad's as required for linking across Gst.Bin boundaries.

If src or sink pads don't have parent elements or do not share a common ancestor, the link will fail.

Calling Gst.Pad.prototype.link_maybe_ghosting_full with flags == Gst.PadLinkCheck.DEFAULT is the recommended way of linking pads with safety checks applied.

Parameters:

`src` (Gst.Pad) –

a Gst.Pad

`sink` (Gst.Pad) –

a Gst.Pad

`flags` (Gst.PadLinkCheck) –

some Gst.PadLinkCheck flags

Returns (Number) –

whether the link succeeded.

Since : 1.10

#### Gst.Pad.link_maybe_ghosting_full

    def Gst.Pad.link_maybe_ghosting_full (self, sink, flags):
        #python wrapper for 'gst_pad_link_maybe_ghosting_full'

Links src to sink, creating any Gst.GhostPad's in between as necessary.

This is a convenience function to save having to create and add intermediate Gst.GhostPad's as required for linking across Gst.Bin boundaries.

If src or sink pads don't have parent elements or do not share a common ancestor, the link will fail.

Calling Gst.Pad.link_maybe_ghosting_full with flags == Gst.PadLinkCheck.DEFAULT is the recommended way of linking pads with safety checks applied.

Parameters:

`src` (Gst.Pad) –

a Gst.Pad

`sink` (Gst.Pad) –

a Gst.Pad

`flags` (Gst.PadLinkCheck) –

some Gst.PadLinkCheck flags

Returns (bool) –

whether the link succeeded.

Since : 1.10

#### gst_pad_mark_reconfigure

    gst_pad_mark_reconfigure (GstPad * pad)

Mark a pad for needing reconfiguration. The next call to gst_pad_check_reconfigure will return TRUE after this call.

Parameters:

`pad` –

the GstPad to mark

#### Gst.Pad.prototype.mark_reconfigure

    function Gst.Pad.prototype.mark_reconfigure(): {
        // javascript wrapper for 'gst_pad_mark_reconfigure'
    }

Mark a pad for needing reconfiguration. The next call to Gst.Pad.prototype.check_reconfigure will return true after this call.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to mark

#### Gst.Pad.mark_reconfigure

    def Gst.Pad.mark_reconfigure (self):
        #python wrapper for 'gst_pad_mark_reconfigure'

Mark a pad for needing reconfiguration. The next call to Gst.Pad.check_reconfigure will return True after this call.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to mark

#### gst_pad_needs_reconfigure

    gboolean
    gst_pad_needs_reconfigure (GstPad * pad)

Check the GST_PAD_FLAG_NEED_RECONFIGURE flag on pad and return TRUE if the flag was set.

Parameters:

`pad` –

the GstPad to check

Returns –

TRUE is the GST_PAD_FLAG_NEED_RECONFIGURE flag is set on pad.

#### Gst.Pad.prototype.needs_reconfigure

    function Gst.Pad.prototype.needs_reconfigure(): {
        // javascript wrapper for 'gst_pad_needs_reconfigure'
    }

Check the Gst.PadFlags.NEED_RECONFIGURE flag on pad and return true if the flag was set.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to check

Returns (Number) –

true is the GST_PAD_FLAG_NEED_RECONFIGURE flag is set on pad.

#### Gst.Pad.needs_reconfigure

    def Gst.Pad.needs_reconfigure (self):
        #python wrapper for 'gst_pad_needs_reconfigure'

Check the Gst.PadFlags.NEED_RECONFIGURE flag on pad and return True if the flag was set.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to check

Returns (bool) –

True is the GST_PAD_FLAG_NEED_RECONFIGURE flag is set on pad.

#### gst_pad_pause_task

    gboolean
    gst_pad_pause_task (GstPad * pad)

Pause the task of pad. This function will also wait until the function executed by the task is finished if this function is not called from the task function.

Parameters:

`pad` –

the GstPad to pause the task of

Returns –

a TRUE if the task could be paused or FALSE when the pad has no task.

#### Gst.Pad.prototype.pause_task

    function Gst.Pad.prototype.pause_task(): {
        // javascript wrapper for 'gst_pad_pause_task'
    }

Pause the task of pad. This function will also wait until the function executed by the task is finished if this function is not called from the task function.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to pause the task of

Returns (Number) –

a true if the task could be paused or false when the pad has no task.

#### Gst.Pad.pause_task

    def Gst.Pad.pause_task (self):
        #python wrapper for 'gst_pad_pause_task'

Pause the task of pad. This function will also wait until the function executed by the task is finished if this function is not called from the task function.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to pause the task of

Returns (bool) –

a True if the task could be paused or False when the pad has no task.

#### gst_pad_peer_query

    gboolean
    gst_pad_peer_query (GstPad * pad,
                        GstQuery * query)

Performs gst_pad_query on the peer of pad.

The caller is responsible for both the allocation and deallocation of the query structure.

Parameters:

`pad` –

a GstPad to invoke the peer query on.

`query` ( [transfer: none]) –

the GstQuery to perform.

Returns –

TRUE if the query could be performed. This function returns FALSE if pad has no peer.

#### Gst.Pad.prototype.peer_query

    function Gst.Pad.prototype.peer_query(query: Gst.Query): {
        // javascript wrapper for 'gst_pad_peer_query'
    }

Performs Gst.Pad.prototype.query on the peer of pad.

The caller is responsible for both the allocation and deallocation of the query structure.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to invoke the peer query on.

`query` (Gst.Query) –

the Gst.Query to perform.

Returns (Number) –

true if the query could be performed. This function returns false if pad has no peer.

#### Gst.Pad.peer_query

    def Gst.Pad.peer_query (self, query):
        #python wrapper for 'gst_pad_peer_query'

Performs Gst.Pad.query on the peer of pad.

The caller is responsible for both the allocation and deallocation of the query structure.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to invoke the peer query on.

`query` (Gst.Query) –

the Gst.Query to perform.

Returns (bool) –

True if the query could be performed. This function returns False if pad has no peer.

#### gst_pad_peer_query_accept_caps

    gboolean
    gst_pad_peer_query_accept_caps (GstPad * pad,
                                    GstCaps * caps)

Check if the peer of pad accepts caps. If pad has no peer, this function returns TRUE.

Parameters:

`pad` –

a GstPad to check the peer of

`caps` –

a GstCaps to check on the pad

Returns –

TRUE if the peer of pad can accept the caps or pad has no peer.

#### Gst.Pad.prototype.peer_query_accept_caps

    function Gst.Pad.prototype.peer_query_accept_caps(caps: Gst.Caps): {
        // javascript wrapper for 'gst_pad_peer_query_accept_caps'
    }

Check if the peer of pad accepts caps. If pad has no peer, this function returns true.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to check the peer of

`caps` (Gst.Caps) –

a Gst.Caps to check on the pad

Returns (Number) –

true if the peer of pad can accept the caps or pad has no peer.

#### Gst.Pad.peer_query_accept_caps

    def Gst.Pad.peer_query_accept_caps (self, caps):
        #python wrapper for 'gst_pad_peer_query_accept_caps'

Check if the peer of pad accepts caps. If pad has no peer, this function returns True.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to check the peer of

`caps` (Gst.Caps) –

a Gst.Caps to check on the pad

Returns (bool) –

True if the peer of pad can accept the caps or pad has no peer.

#### gst_pad_peer_query_caps

    GstCaps *
    gst_pad_peer_query_caps (GstPad * pad,
                             GstCaps * filter)

Gets the capabilities of the peer connected to this pad. Similar to gst_pad_query_caps.

When called on srcpads filter contains the caps that upstream could produce in the order preferred by upstream. When called on sinkpads filter contains the caps accepted by downstream in the preferred order. filter might be NULL but if it is not NULL the returned caps will be a subset of filter.

Parameters:

`pad` –

a GstPad to get the capabilities of.

`filter` ( [nullable]) –

a GstCaps filter, or NULL.

Returns ( [transfer: full]) –

the caps of the peer pad with incremented ref-count. When there is no peer pad, this function returns filter or, when filter is NULL, ANY caps.

#### Gst.Pad.prototype.peer_query_caps

    function Gst.Pad.prototype.peer_query_caps(filter: Gst.Caps): {
        // javascript wrapper for 'gst_pad_peer_query_caps'
    }

Gets the capabilities of the peer connected to this pad. Similar to Gst.Pad.prototype.query_caps.

When called on srcpads filter contains the caps that upstream could produce in the order preferred by upstream. When called on sinkpads filter contains the caps accepted by downstream in the preferred order. filter might be null but if it is not null the returned caps will be a subset of filter.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to get the capabilities of.

`filter` (Gst.Caps) –

a Gst.Caps filter, or null.

Returns (Gst.Caps) –

the caps of the peer pad with incremented ref-count. When there is no peer pad, this function returns filter or, when filter is null, ANY caps.

#### Gst.Pad.peer_query_caps

    def Gst.Pad.peer_query_caps (self, filter):
        #python wrapper for 'gst_pad_peer_query_caps'

Gets the capabilities of the peer connected to this pad. Similar to Gst.Pad.query_caps.

When called on srcpads filter contains the caps that upstream could produce in the order preferred by upstream. When called on sinkpads filter contains the caps accepted by downstream in the preferred order. filter might be None but if it is not None the returned caps will be a subset of filter.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to get the capabilities of.

`filter` (Gst.Caps) –

a Gst.Caps filter, or None.

Returns (Gst.Caps) –

the caps of the peer pad with incremented ref-count. When there is no peer pad, this function returns filter or, when filter is None, ANY caps.

#### gst_pad_peer_query_convert

    gboolean
    gst_pad_peer_query_convert (GstPad * pad,
                                GstFormat src_format,
                                gint64 src_val,
                                GstFormat dest_format,
                                gint64 * dest_val)

Queries the peer pad of a given sink pad to convert src_val in src_format to dest_format.

Parameters:

`pad` –

a GstPad, on whose peer pad to invoke the convert query on. Must be a sink pad.

`src_format` –

a GstFormat to convert from.

`src_val` –

a value to convert.

`dest_format` –

the GstFormat to convert to.

`dest_val` ( [out]) –

a pointer to the result.

Returns –

TRUE if the query could be performed.

#### Gst.Pad.prototype.peer_query_convert

    function Gst.Pad.prototype.peer_query_convert(src_format: Gst.Format, src_val: Number, dest_format: Gst.Format): {
        // javascript wrapper for 'gst_pad_peer_query_convert'
    }

Queries the peer pad of a given sink pad to convert src_val in src_format to dest_format.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad, on whose peer pad to invoke the convert query on. Must be a sink pad.

`src_format` (Gst.Format) –

a Gst.Format to convert from.

`src_val` (Number) –

a value to convert.

`dest_format` (Gst.Format) –

the Gst.Format to convert to.

Returns a tuple made of:

(Number ) –

true if the query could be performed.

`dest_val` (Number ) –

true if the query could be performed.

#### Gst.Pad.peer_query_convert

    def Gst.Pad.peer_query_convert (self, src_format, src_val, dest_format):
        #python wrapper for 'gst_pad_peer_query_convert'

Queries the peer pad of a given sink pad to convert src_val in src_format to dest_format.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad, on whose peer pad to invoke the convert query on. Must be a sink pad.

`src_format` (Gst.Format) –

a Gst.Format to convert from.

`src_val` (int) –

a value to convert.

`dest_format` (Gst.Format) –

the Gst.Format to convert to.

Returns a tuple made of:

(bool ) –

True if the query could be performed.

`dest_val` (int ) –

True if the query could be performed.

#### gst_pad_peer_query_duration

    gboolean
    gst_pad_peer_query_duration (GstPad * pad,
                                 GstFormat format,
                                 gint64 * duration)

Queries the peer pad of a given sink pad for the total stream duration.

Parameters:

`pad` –

a GstPad on whose peer pad to invoke the duration query on. Must be a sink pad.

`format` –

the GstFormat requested

`duration` ( [out][optional]) –

a location in which to store the total duration, or NULL.

Returns –

TRUE if the query could be performed.

#### Gst.Pad.prototype.peer_query_duration

    function Gst.Pad.prototype.peer_query_duration(format: Gst.Format): {
        // javascript wrapper for 'gst_pad_peer_query_duration'
    }

Queries the peer pad of a given sink pad for the total stream duration.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad on whose peer pad to invoke the duration query on. Must be a sink pad.

`format` (Gst.Format) –

the Gst.Format requested

Returns a tuple made of:

(Number ) –

true if the query could be performed.

`duration` (Number ) –

true if the query could be performed.

#### Gst.Pad.peer_query_duration

    def Gst.Pad.peer_query_duration (self, format):
        #python wrapper for 'gst_pad_peer_query_duration'

Queries the peer pad of a given sink pad for the total stream duration.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad on whose peer pad to invoke the duration query on. Must be a sink pad.

`format` (Gst.Format) –

the Gst.Format requested

Returns a tuple made of:

(bool ) –

True if the query could be performed.

`duration` (int ) –

True if the query could be performed.

#### gst_pad_peer_query_position

    gboolean
    gst_pad_peer_query_position (GstPad * pad,
                                 GstFormat format,
                                 gint64 * cur)

Queries the peer of a given sink pad for the stream position.

Parameters:

`pad` –

a GstPad on whose peer to invoke the position query on. Must be a sink pad.

`format` –

the GstFormat requested

`cur` ( [out][optional]) –

a location in which to store the current position, or NULL.

Returns –

TRUE if the query could be performed.

#### Gst.Pad.prototype.peer_query_position

    function Gst.Pad.prototype.peer_query_position(format: Gst.Format): {
        // javascript wrapper for 'gst_pad_peer_query_position'
    }

Queries the peer of a given sink pad for the stream position.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad on whose peer to invoke the position query on. Must be a sink pad.

`format` (Gst.Format) –

the Gst.Format requested

Returns a tuple made of:

(Number ) –

true if the query could be performed.

`cur` (Number ) –

true if the query could be performed.

#### Gst.Pad.peer_query_position

    def Gst.Pad.peer_query_position (self, format):
        #python wrapper for 'gst_pad_peer_query_position'

Queries the peer of a given sink pad for the stream position.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad on whose peer to invoke the position query on. Must be a sink pad.

`format` (Gst.Format) –

the Gst.Format requested

Returns a tuple made of:

(bool ) –

True if the query could be performed.

`cur` (int ) –

True if the query could be performed.

#### gst_pad_proxy_query_accept_caps

    gboolean
    gst_pad_proxy_query_accept_caps (GstPad * pad,
                                     GstQuery * query)

Checks if all internally linked pads of pad accepts the caps in query and returns the intersection of the results.

This function is useful as a default accept caps query function for an element that can handle any stream format, but requires caps that are acceptable for all opposite pads.

Parameters:

`pad` –

a GstPad to proxy.

`query` –

an ACCEPT_CAPS GstQuery.

Returns –

TRUE if query could be executed

#### Gst.Pad.prototype.proxy_query_accept_caps

    function Gst.Pad.prototype.proxy_query_accept_caps(query: Gst.Query): {
        // javascript wrapper for 'gst_pad_proxy_query_accept_caps'
    }

Checks if all internally linked pads of pad accepts the caps in query and returns the intersection of the results.

This function is useful as a default accept caps query function for an element that can handle any stream format, but requires caps that are acceptable for all opposite pads.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to proxy.

`query` (Gst.Query) –

an ACCEPT_CAPS Gst.Query.

Returns (Number) –

true if query could be executed

#### Gst.Pad.proxy_query_accept_caps

    def Gst.Pad.proxy_query_accept_caps (self, query):
        #python wrapper for 'gst_pad_proxy_query_accept_caps'

Checks if all internally linked pads of pad accepts the caps in query and returns the intersection of the results.

This function is useful as a default accept caps query function for an element that can handle any stream format, but requires caps that are acceptable for all opposite pads.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to proxy.

`query` (Gst.Query) –

an ACCEPT_CAPS Gst.Query.

Returns (bool) –

True if query could be executed

#### gst_pad_proxy_query_caps

    gboolean
    gst_pad_proxy_query_caps (GstPad * pad,
                              GstQuery * query)

Calls gst_pad_query_caps for all internally linked pads of pad and returns the intersection of the results.

This function is useful as a default caps query function for an element that can handle any stream format, but requires all its pads to have the same caps. Two such elements are tee and adder.

Parameters:

`pad` –

a GstPad to proxy.

`query` –

a CAPS GstQuery.

Returns –

TRUE if query could be executed

#### Gst.Pad.prototype.proxy_query_caps

    function Gst.Pad.prototype.proxy_query_caps(query: Gst.Query): {
        // javascript wrapper for 'gst_pad_proxy_query_caps'
    }

Calls Gst.Pad.prototype.query_caps for all internally linked pads of pad and returns the intersection of the results.

This function is useful as a default caps query function for an element that can handle any stream format, but requires all its pads to have the same caps. Two such elements are tee and adder.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to proxy.

`query` (Gst.Query) –

a CAPS Gst.Query.

Returns (Number) –

true if query could be executed

#### Gst.Pad.proxy_query_caps

    def Gst.Pad.proxy_query_caps (self, query):
        #python wrapper for 'gst_pad_proxy_query_caps'

Calls Gst.Pad.query_caps for all internally linked pads of pad and returns the intersection of the results.

This function is useful as a default caps query function for an element that can handle any stream format, but requires all its pads to have the same caps. Two such elements are tee and adder.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to proxy.

`query` (Gst.Query) –

a CAPS Gst.Query.

Returns (bool) –

True if query could be executed

#### gst_pad_pull_range

    GstFlowReturn
    gst_pad_pull_range (GstPad * pad,
                        guint64 offset,
                        guint size,
                        GstBuffer ** buffer)

Pulls a buffer from the peer pad or fills up a provided buffer.

This function will first trigger the pad block signal if it was installed.

When pad is not linked GST_FLOW_NOT_LINKED is returned else this function returns the result of gst_pad_get_range on the peer pad. See gst_pad_get_range for a list of return values and for the semantics of the arguments of this function.

If buffer points to a variable holding NULL, a valid new GstBuffer will be placed in buffer when this function returns GST_FLOW_OK. The new buffer must be freed with gst_buffer_unref after usage. When this function returns any other result value, buffer will still point to NULL.

When buffer points to a variable that points to a valid GstBuffer, the buffer will be filled with the result data when this function returns GST_FLOW_OK. When this function returns any other result value, buffer will be unchanged. If the provided buffer is larger than size, only size bytes will be filled in the result buffer and its size will be updated accordingly.

Note that less than size bytes can be returned in buffer when, for example, an EOS condition is near or when buffer is not large enough to hold size bytes. The caller should check the result buffer size to get the result size.

Parameters:

`pad` –

a sink GstPad, returns GST_FLOW_ERROR if not.

`offset` –

The start offset of the buffer

`size` –

The length of the buffer

`buffer` ( [out]) –

a pointer to hold the GstBuffer, returns GST_FLOW_ERROR if NULL.

Returns –

a GstFlowReturn from the peer pad.

MT safe.

#### Gst.Pad.prototype.pull_range

    function Gst.Pad.prototype.pull_range(offset: Number, size: Number): {
        // javascript wrapper for 'gst_pad_pull_range'
    }

Pulls a buffer from the peer pad or fills up a provided buffer.

This function will first trigger the pad block signal if it was installed.

When pad is not linked Gst.FlowReturn.NOT_LINKED is returned else this function returns the result of Gst.Pad.prototype.get_range on the peer pad. See Gst.Pad.prototype.get_range for a list of return values and for the semantics of the arguments of this function.

If buffer points to a variable holding null, a valid new Gst.Buffer will be placed in buffer when this function returns Gst.FlowReturn.OK. The new buffer must be freed with gst_buffer_unref (not introspectable) after usage. When this function returns any other result value, buffer will still point to null.

When buffer points to a variable that points to a valid Gst.Buffer, the buffer will be filled with the result data when this function returns Gst.FlowReturn.OK. When this function returns any other result value, buffer will be unchanged. If the provided buffer is larger than size, only size bytes will be filled in the result buffer and its size will be updated accordingly.

Note that less than size bytes can be returned in buffer when, for example, an EOS condition is near or when buffer is not large enough to hold size bytes. The caller should check the result buffer size to get the result size.

Parameters:

`pad` (Gst.Pad) –

a sink Gst.Pad, returns GST_FLOW_ERROR if not.

`offset` (Number) –

The start offset of the buffer

`size` (Number) –

The length of the buffer

Returns a tuple made of:

(Gst.FlowReturn ) –

a Gst.FlowReturn from the peer pad.

MT safe.

`buffer` (Gst.Buffer ) –

a Gst.FlowReturn from the peer pad.

MT safe.

#### Gst.Pad.pull_range

    def Gst.Pad.pull_range (self, offset, size):
        #python wrapper for 'gst_pad_pull_range'

Pulls a buffer from the peer pad or fills up a provided buffer.

This function will first trigger the pad block signal if it was installed.

When pad is not linked Gst.FlowReturn.NOT_LINKED is returned else this function returns the result of Gst.Pad.get_range on the peer pad. See Gst.Pad.get_range for a list of return values and for the semantics of the arguments of this function.

If buffer points to a variable holding None, a valid new Gst.Buffer will be placed in buffer when this function returns Gst.FlowReturn.OK. The new buffer must be freed with gst_buffer_unref (not introspectable) after usage. When this function returns any other result value, buffer will still point to None.

When buffer points to a variable that points to a valid Gst.Buffer, the buffer will be filled with the result data when this function returns Gst.FlowReturn.OK. When this function returns any other result value, buffer will be unchanged. If the provided buffer is larger than size, only size bytes will be filled in the result buffer and its size will be updated accordingly.

Note that less than size bytes can be returned in buffer when, for example, an EOS condition is near or when buffer is not large enough to hold size bytes. The caller should check the result buffer size to get the result size.

Parameters:

`pad` (Gst.Pad) –

a sink Gst.Pad, returns GST_FLOW_ERROR if not.

`offset` (int) –

The start offset of the buffer

`size` (int) –

The length of the buffer

Returns a tuple made of:

(Gst.FlowReturn ) –

a Gst.FlowReturn from the peer pad.

MT safe.

`buffer` (Gst.Buffer ) –

a Gst.FlowReturn from the peer pad.

MT safe.

#### gst_pad_push

    GstFlowReturn
    gst_pad_push (GstPad * pad,
                  GstBuffer * buffer)

Pushes a buffer to the peer of pad.

This function will call installed block probes before triggering any installed data probes.

The function proceeds calling gst_pad_chain on the peer pad and returns the value from that function. If pad has no peer, GST_FLOW_NOT_LINKED will be returned.

In all cases, success or failure, the caller loses its reference to buffer after calling this function.

Parameters:

`pad` –

a source GstPad, returns GST_FLOW_ERROR if not.

`buffer` ( [transfer: full]) –

the GstBuffer to push returns GST_FLOW_ERROR if not.

Returns –

a GstFlowReturn from the peer pad.

MT safe.

#### Gst.Pad.prototype.push

    function Gst.Pad.prototype.push(buffer: Gst.Buffer): {
        // javascript wrapper for 'gst_pad_push'
    }

Pushes a buffer to the peer of pad.

This function will call installed block probes before triggering any installed data probes.

The function proceeds calling Gst.Pad.prototype.chain on the peer pad and returns the value from that function. If pad has no peer, Gst.FlowReturn.NOT_LINKED will be returned.

In all cases, success or failure, the caller loses its reference to buffer after calling this function.

Parameters:

`pad` (Gst.Pad) –

a source Gst.Pad, returns Gst.FlowReturn.ERROR if not.

`buffer` (Gst.Buffer) –

the Gst.Buffer to push returns GST_FLOW_ERROR if not.

Returns (Gst.FlowReturn) –

a Gst.FlowReturn from the peer pad.

MT safe.

#### Gst.Pad.push

    def Gst.Pad.push (self, buffer):
        #python wrapper for 'gst_pad_push'

Pushes a buffer to the peer of pad.

This function will call installed block probes before triggering any installed data probes.

The function proceeds calling Gst.Pad.chain on the peer pad and returns the value from that function. If pad has no peer, Gst.FlowReturn.NOT_LINKED will be returned.

In all cases, success or failure, the caller loses its reference to buffer after calling this function.

Parameters:

`pad` (Gst.Pad) –

a source Gst.Pad, returns Gst.FlowReturn.ERROR if not.

`buffer` (Gst.Buffer) –

the Gst.Buffer to push returns GST_FLOW_ERROR if not.

Returns (Gst.FlowReturn) –

a Gst.FlowReturn from the peer pad.

MT safe.

#### gst_pad_push_event

    gboolean
    gst_pad_push_event (GstPad * pad,
                        GstEvent * event)

Sends the event to the peer of the given pad. This function is mainly used by elements to send events to their peer elements.

This function takes ownership of the provided event so you should gst_event_ref it if you want to reuse the event after this call.

Parameters:

`pad` –

the GstPad that will push the event.

`event` ( [transfer: full]) –

the GstEvent to push out of the pad.

Returns –

TRUE if the event was handled.

MT safe.

#### Gst.Pad.prototype.push_event

    function Gst.Pad.prototype.push_event(event: Gst.Event): {
        // javascript wrapper for 'gst_pad_push_event'
    }

Sends the event to the peer of the given pad. This function is mainly used by elements to send events to their peer elements.

This function takes ownership of the provided event so you should gst_event_ref (not introspectable) it if you want to reuse the event after this call.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad that will push the event.

`event` (Gst.Event) –

the Gst.Event to push out of the pad.

Returns (Number) –

true if the event was handled.

MT safe.

#### Gst.Pad.push_event

    def Gst.Pad.push_event (self, event):
        #python wrapper for 'gst_pad_push_event'

Sends the event to the peer of the given pad. This function is mainly used by elements to send events to their peer elements.

This function takes ownership of the provided event so you should gst_event_ref (not introspectable) it if you want to reuse the event after this call.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad that will push the event.

`event` (Gst.Event) –

the Gst.Event to push out of the pad.

Returns (bool) –

True if the event was handled.

MT safe.

#### gst_pad_push_list

    GstFlowReturn
    gst_pad_push_list (GstPad * pad,
                       GstBufferList * list)

Pushes a buffer list to the peer of pad.

This function will call installed block probes before triggering any installed data probes.

The function proceeds calling the chain function on the peer pad and returns the value from that function. If pad has no peer, GST_FLOW_NOT_LINKED will be returned. If the peer pad does not have any installed chainlist function every group buffer of the list will be merged into a normal GstBuffer and chained via gst_pad_chain.

In all cases, success or failure, the caller loses its reference to list after calling this function.

Parameters:

`pad` –

a source GstPad, returns GST_FLOW_ERROR if not.

`list` ( [transfer: full]) –

the GstBufferList to push returns GST_FLOW_ERROR if not.

Returns –

a GstFlowReturn from the peer pad.

MT safe.

#### Gst.Pad.prototype.push_list

    function Gst.Pad.prototype.push_list(list: Gst.BufferList): {
        // javascript wrapper for 'gst_pad_push_list'
    }

Pushes a buffer list to the peer of pad.

This function will call installed block probes before triggering any installed data probes.

The function proceeds calling the chain function on the peer pad and returns the value from that function. If pad has no peer, Gst.FlowReturn.NOT_LINKED will be returned. If the peer pad does not have any installed chainlist function every group buffer of the list will be merged into a normal Gst.Buffer and chained via Gst.Pad.prototype.chain.

In all cases, success or failure, the caller loses its reference to list after calling this function.

Parameters:

`pad` (Gst.Pad) –

a source Gst.Pad, returns Gst.FlowReturn.ERROR if not.

`list` (Gst.BufferList) –

the Gst.BufferList to push returns GST_FLOW_ERROR if not.

Returns (Gst.FlowReturn) –

a Gst.FlowReturn from the peer pad.

MT safe.

#### Gst.Pad.push_list

    def Gst.Pad.push_list (self, list):
        #python wrapper for 'gst_pad_push_list'

Pushes a buffer list to the peer of pad.

This function will call installed block probes before triggering any installed data probes.

The function proceeds calling the chain function on the peer pad and returns the value from that function. If pad has no peer, Gst.FlowReturn.NOT_LINKED will be returned. If the peer pad does not have any installed chainlist function every group buffer of the list will be merged into a normal Gst.Buffer and chained via Gst.Pad.chain.

In all cases, success or failure, the caller loses its reference to list after calling this function.

Parameters:

`pad` (Gst.Pad) –

a source Gst.Pad, returns Gst.FlowReturn.ERROR if not.

`list` (Gst.BufferList) –

the Gst.BufferList to push returns GST_FLOW_ERROR if not.

Returns (Gst.FlowReturn) –

a Gst.FlowReturn from the peer pad.

MT safe.

#### gst_pad_query

    gboolean
    gst_pad_query (GstPad * pad,
                   GstQuery * query)

Dispatches a query to a pad. The query should have been allocated by the caller via one of the type-specific allocation functions. The element that the pad belongs to is responsible for filling the query with an appropriate response, which should then be parsed with a type-specific query parsing function.

Again, the caller is responsible for both the allocation and deallocation of the query structure.

Please also note that some queries might need a running pipeline to work.

Parameters:

`pad` –

a GstPad to invoke the default query on.

`query` ( [transfer: none]) –

the GstQuery to perform.

Returns –

TRUE if the query could be performed.

#### Gst.Pad.prototype.query

    function Gst.Pad.prototype.query(query: Gst.Query): {
        // javascript wrapper for 'gst_pad_query'
    }

Dispatches a query to a pad. The query should have been allocated by the caller via one of the type-specific allocation functions. The element that the pad belongs to is responsible for filling the query with an appropriate response, which should then be parsed with a type-specific query parsing function.

Again, the caller is responsible for both the allocation and deallocation of the query structure.

Please also note that some queries might need a running pipeline to work.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to invoke the default query on.

`query` (Gst.Query) –

the Gst.Query to perform.

Returns (Number) –

true if the query could be performed.

#### Gst.Pad.query

    def Gst.Pad.query (self, query):
        #python wrapper for 'gst_pad_query'

Dispatches a query to a pad. The query should have been allocated by the caller via one of the type-specific allocation functions. The element that the pad belongs to is responsible for filling the query with an appropriate response, which should then be parsed with a type-specific query parsing function.

Again, the caller is responsible for both the allocation and deallocation of the query structure.

Please also note that some queries might need a running pipeline to work.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to invoke the default query on.

`query` (Gst.Query) –

the Gst.Query to perform.

Returns (bool) –

True if the query could be performed.

#### gst_pad_query_accept_caps

    gboolean
    gst_pad_query_accept_caps (GstPad * pad,
                               GstCaps * caps)

Check if the given pad accepts the caps.

Parameters:

`pad` –

a GstPad to check

`caps` –

a GstCaps to check on the pad

Returns –

TRUE if the pad can accept the caps.

#### Gst.Pad.prototype.query_accept_caps

    function Gst.Pad.prototype.query_accept_caps(caps: Gst.Caps): {
        // javascript wrapper for 'gst_pad_query_accept_caps'
    }

Check if the given pad accepts the caps.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to check

`caps` (Gst.Caps) –

a Gst.Caps to check on the pad

Returns (Number) –

true if the pad can accept the caps.

#### Gst.Pad.query_accept_caps

    def Gst.Pad.query_accept_caps (self, caps):
        #python wrapper for 'gst_pad_query_accept_caps'

Check if the given pad accepts the caps.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to check

`caps` (Gst.Caps) –

a Gst.Caps to check on the pad

Returns (bool) –

True if the pad can accept the caps.

#### gst_pad_query_caps

    GstCaps *
    gst_pad_query_caps (GstPad * pad,
                        GstCaps * filter)

Gets the capabilities this pad can produce or consume. Note that this method doesn't necessarily return the caps set by sending a gst_event_new_caps - use gst_pad_get_current_caps for that instead. gst_pad_query_caps returns all possible caps a pad can operate with, using the pad's CAPS query function, If the query fails, this function will return filter, if not NULL, otherwise ANY.

When called on sinkpads filter contains the caps that upstream could produce in the order preferred by upstream. When called on srcpads filter contains the caps accepted by downstream in the preferred order. filter might be NULL but if it is not NULL the returned caps will be a subset of filter.

Note that this function does not return writable GstCaps, use gst_caps_make_writable before modifying the caps.

Parameters:

`pad` –

a GstPad to get the capabilities of.

`filter` ( [nullable]) –

suggested GstCaps, or NULL

Returns ( [transfer: full]) –

the caps of the pad with incremented ref-count.

#### Gst.Pad.prototype.query_caps

    function Gst.Pad.prototype.query_caps(filter: Gst.Caps): {
        // javascript wrapper for 'gst_pad_query_caps'
    }

Gets the capabilities this pad can produce or consume. Note that this method doesn't necessarily return the caps set by sending a Gst.Event.prototype.new_caps - use Gst.Pad.prototype.get_current_caps for that instead. gst_pad_query_caps returns all possible caps a pad can operate with, using the pad's CAPS query function, If the query fails, this function will return filter, if not null, otherwise ANY.

When called on sinkpads filter contains the caps that upstream could produce in the order preferred by upstream. When called on srcpads filter contains the caps accepted by downstream in the preferred order. filter might be null but if it is not null the returned caps will be a subset of filter.

Note that this function does not return writable Gst.Caps, use Gst.Caps.prototype.make_writable before modifying the caps.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to get the capabilities of.

`filter` (Gst.Caps) –

suggested Gst.Caps, or null

Returns (Gst.Caps) –

the caps of the pad with incremented ref-count.

#### Gst.Pad.query_caps

    def Gst.Pad.query_caps (self, filter):
        #python wrapper for 'gst_pad_query_caps'

Gets the capabilities this pad can produce or consume. Note that this method doesn't necessarily return the caps set by sending a Gst.Event.new_caps - use Gst.Pad.get_current_caps for that instead. gst_pad_query_caps returns all possible caps a pad can operate with, using the pad's CAPS query function, If the query fails, this function will return filter, if not None, otherwise ANY.

When called on sinkpads filter contains the caps that upstream could produce in the order preferred by upstream. When called on srcpads filter contains the caps accepted by downstream in the preferred order. filter might be None but if it is not None the returned caps will be a subset of filter.

Note that this function does not return writable Gst.Caps, use Gst.Caps.make_writable before modifying the caps.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to get the capabilities of.

`filter` (Gst.Caps) –

suggested Gst.Caps, or None

Returns (Gst.Caps) –

the caps of the pad with incremented ref-count.

#### gst_pad_query_convert

    gboolean
    gst_pad_query_convert (GstPad * pad,
                           GstFormat src_format,
                           gint64 src_val,
                           GstFormat dest_format,
                           gint64 * dest_val)

Queries a pad to convert src_val in src_format to dest_format.

Parameters:

`pad` –

a GstPad to invoke the convert query on.

`src_format` –

a GstFormat to convert from.

`src_val` –

a value to convert.

`dest_format` –

the GstFormat to convert to.

`dest_val` ( [out]) –

a pointer to the result.

Returns –

TRUE if the query could be performed.

#### Gst.Pad.prototype.query_convert

    function Gst.Pad.prototype.query_convert(src_format: Gst.Format, src_val: Number, dest_format: Gst.Format): {
        // javascript wrapper for 'gst_pad_query_convert'
    }

Queries a pad to convert src_val in src_format to dest_format.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to invoke the convert query on.

`src_format` (Gst.Format) –

a Gst.Format to convert from.

`src_val` (Number) –

a value to convert.

`dest_format` (Gst.Format) –

the Gst.Format to convert to.

Returns a tuple made of:

(Number ) –

true if the query could be performed.

`dest_val` (Number ) –

true if the query could be performed.

#### Gst.Pad.query_convert

    def Gst.Pad.query_convert (self, src_format, src_val, dest_format):
        #python wrapper for 'gst_pad_query_convert'

Queries a pad to convert src_val in src_format to dest_format.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to invoke the convert query on.

`src_format` (Gst.Format) –

a Gst.Format to convert from.

`src_val` (int) –

a value to convert.

`dest_format` (Gst.Format) –

the Gst.Format to convert to.

Returns a tuple made of:

(bool ) –

True if the query could be performed.

`dest_val` (int ) –

True if the query could be performed.

#### gst_pad_query_default

    gboolean
    gst_pad_query_default (GstPad * pad,
                           GstObject * parent,
                           GstQuery * query)

Invokes the default query handler for the given pad. The query is sent to all pads internally linked to pad. Note that if there are many possible sink pads that are internally linked to pad, only one will be sent the query. Multi-sinkpad elements should implement custom query handlers.

Parameters:

`pad` –

a GstPad to call the default query handler on.

`parent` ( [nullable]) –

the parent of pad or NULL

`query` ( [transfer: none]) –

the GstQuery to handle.

Returns –

TRUE if the query was performed successfully.

#### Gst.Pad.prototype.query_default

    function Gst.Pad.prototype.query_default(parent: Gst.Object, query: Gst.Query): {
        // javascript wrapper for 'gst_pad_query_default'
    }

Invokes the default query handler for the given pad. The query is sent to all pads internally linked to pad. Note that if there are many possible sink pads that are internally linked to pad, only one will be sent the query. Multi-sinkpad elements should implement custom query handlers.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to call the default query handler on.

`parent` (Gst.Object) –

the parent of pad or null

`query` (Gst.Query) –

the Gst.Query to handle.

Returns (Number) –

true if the query was performed successfully.

#### Gst.Pad.query_default

    def Gst.Pad.query_default (self, parent, query):
        #python wrapper for 'gst_pad_query_default'

Invokes the default query handler for the given pad. The query is sent to all pads internally linked to pad. Note that if there are many possible sink pads that are internally linked to pad, only one will be sent the query. Multi-sinkpad elements should implement custom query handlers.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to call the default query handler on.

`parent` (Gst.Object) –

the parent of pad or None

`query` (Gst.Query) –

the Gst.Query to handle.

Returns (bool) –

True if the query was performed successfully.

#### gst_pad_query_duration

    gboolean
    gst_pad_query_duration (GstPad * pad,
                            GstFormat format,
                            gint64 * duration)

Queries a pad for the total stream duration.

Parameters:

`pad` –

a GstPad to invoke the duration query on.

`format` –

the GstFormat requested

`duration` ( [out][optional]) –

a location in which to store the total duration, or NULL.

Returns –

TRUE if the query could be performed.

#### Gst.Pad.prototype.query_duration

    function Gst.Pad.prototype.query_duration(format: Gst.Format): {
        // javascript wrapper for 'gst_pad_query_duration'
    }

Queries a pad for the total stream duration.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to invoke the duration query on.

`format` (Gst.Format) –

the Gst.Format requested

Returns a tuple made of:

(Number ) –

true if the query could be performed.

`duration` (Number ) –

true if the query could be performed.

#### Gst.Pad.query_duration

    def Gst.Pad.query_duration (self, format):
        #python wrapper for 'gst_pad_query_duration'

Queries a pad for the total stream duration.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to invoke the duration query on.

`format` (Gst.Format) –

the Gst.Format requested

Returns a tuple made of:

(bool ) –

True if the query could be performed.

`duration` (int ) –

True if the query could be performed.

#### gst_pad_query_position

    gboolean
    gst_pad_query_position (GstPad * pad,
                            GstFormat format,
                            gint64 * cur)

Queries a pad for the stream position.

Parameters:

`pad` –

a GstPad to invoke the position query on.

`format` –

the GstFormat requested

`cur` ( [out][optional]) –

A location in which to store the current position, or NULL.

Returns –

TRUE if the query could be performed.

#### Gst.Pad.prototype.query_position

    function Gst.Pad.prototype.query_position(format: Gst.Format): {
        // javascript wrapper for 'gst_pad_query_position'
    }

Queries a pad for the stream position.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to invoke the position query on.

`format` (Gst.Format) –

the Gst.Format requested

Returns a tuple made of:

(Number ) –

true if the query could be performed.

`cur` (Number ) –

true if the query could be performed.

#### Gst.Pad.query_position

    def Gst.Pad.query_position (self, format):
        #python wrapper for 'gst_pad_query_position'

Queries a pad for the stream position.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to invoke the position query on.

`format` (Gst.Format) –

the Gst.Format requested

Returns a tuple made of:

(bool ) –

True if the query could be performed.

`cur` (int ) –

True if the query could be performed.

#### gst_pad_remove_probe

    gst_pad_remove_probe (GstPad * pad,
                          gulong id)

Remove the probe with id from pad.

MT safe.

Parameters:

`pad` –

the GstPad with the probe

`id` –

the probe id to remove

#### Gst.Pad.prototype.remove_probe

    function Gst.Pad.prototype.remove_probe(id: Number): {
        // javascript wrapper for 'gst_pad_remove_probe'
    }

Remove the probe with id from pad.

MT safe.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad with the probe

`id` (Number) –

the probe id to remove

#### Gst.Pad.remove_probe

    def Gst.Pad.remove_probe (self, id):
        #python wrapper for 'gst_pad_remove_probe'

Remove the probe with id from pad.

MT safe.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad with the probe

`id` (int) –

the probe id to remove

#### gst_pad_send_event

    gboolean
    gst_pad_send_event (GstPad * pad,
                        GstEvent * event)

Sends the event to the pad. This function can be used by applications to send events in the pipeline.

If pad is a source pad, event should be an upstream event. If pad is a sink pad, event should be a downstream event. For example, you would not send a GST_EVENT_EOS on a src pad; EOS events only propagate downstream. Furthermore, some downstream events have to be serialized with data flow, like EOS, while some can travel out-of-band, like GST_EVENT_FLUSH_START. If the event needs to be serialized with data flow, this function will take the pad's stream lock while calling its event function.

To find out whether an event type is upstream, downstream, or downstream and serialized, see GstEventTypeFlags, gst_event_type_get_flags, GST_EVENT_IS_UPSTREAM, GST_EVENT_IS_DOWNSTREAM, and GST_EVENT_IS_SERIALIZED. Note that in practice that an application or plugin doesn't need to bother itself with this information; the core handles all necessary locks and checks.

This function takes ownership of the provided event so you should gst_event_ref it if you want to reuse the event after this call.

Parameters:

`pad` –

a GstPad to send the event to.

`event` ( [transfer: full]) –

the GstEvent to send to the pad.

Returns –

TRUE if the event was handled.

#### Gst.Pad.prototype.send_event

    function Gst.Pad.prototype.send_event(event: Gst.Event): {
        // javascript wrapper for 'gst_pad_send_event'
    }

Sends the event to the pad. This function can be used by applications to send events in the pipeline.

If pad is a source pad, event should be an upstream event. If pad is a sink pad, event should be a downstream event. For example, you would not send a Gst.EventType.EOS on a src pad; EOS events only propagate downstream. Furthermore, some downstream events have to be serialized with data flow, like EOS, while some can travel out-of-band, like Gst.EventType.FLUSH_START. If the event needs to be serialized with data flow, this function will take the pad's stream lock while calling its event function.

To find out whether an event type is upstream, downstream, or downstream and serialized, see Gst.EventTypeFlags, Gst.prototype.event_type_get_flags, GST_EVENT_IS_UPSTREAM (not introspectable), GST_EVENT_IS_DOWNSTREAM (not introspectable), and GST_EVENT_IS_SERIALIZED (not introspectable). Note that in practice that an application or plugin doesn't need to bother itself with this information; the core handles all necessary locks and checks.

This function takes ownership of the provided event so you should gst_event_ref (not introspectable) it if you want to reuse the event after this call.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to send the event to.

`event` (Gst.Event) –

the Gst.Event to send to the pad.

Returns (Number) –

true if the event was handled.

#### Gst.Pad.send_event

    def Gst.Pad.send_event (self, event):
        #python wrapper for 'gst_pad_send_event'

Sends the event to the pad. This function can be used by applications to send events in the pipeline.

If pad is a source pad, event should be an upstream event. If pad is a sink pad, event should be a downstream event. For example, you would not send a Gst.EventType.EOS on a src pad; EOS events only propagate downstream. Furthermore, some downstream events have to be serialized with data flow, like EOS, while some can travel out-of-band, like Gst.EventType.FLUSH_START. If the event needs to be serialized with data flow, this function will take the pad's stream lock while calling its event function.

To find out whether an event type is upstream, downstream, or downstream and serialized, see Gst.EventTypeFlags, Gst.event_type_get_flags, GST_EVENT_IS_UPSTREAM (not introspectable), GST_EVENT_IS_DOWNSTREAM (not introspectable), and GST_EVENT_IS_SERIALIZED (not introspectable). Note that in practice that an application or plugin doesn't need to bother itself with this information; the core handles all necessary locks and checks.

This function takes ownership of the provided event so you should gst_event_ref (not introspectable) it if you want to reuse the event after this call.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad to send the event to.

`event` (Gst.Event) –

the Gst.Event to send to the pad.

Returns (bool) –

True if the event was handled.

#### gst_pad_set_activate_function_full

    gst_pad_set_activate_function_full (GstPad * pad,
                                        GstPadActivateFunction activate,
                                        gpointer user_data,
                                        GDestroyNotify notify)

Sets the given activate function for pad. The activate function will dispatch to gst_pad_activate_mode to perform the actual activation. Only makes sense to set on sink pads.

Call this function if your sink pad can start a pull-based task.

Parameters:

`pad` –

a GstPad.

`activate` –

the GstPadActivateFunction to set.

`user_data` –

user_data passed to notify

`notify` –

notify called when activate will not be used anymore.

#### Gst.Pad.prototype.set_activate_function_full

    function Gst.Pad.prototype.set_activate_function_full(activate: Gst.PadActivateFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_set_activate_function_full'
    }

Sets the given activate function for pad. The activate function will dispatch to Gst.Pad.prototype.activate_mode to perform the actual activation. Only makes sense to set on sink pads.

Call this function if your sink pad can start a pull-based task.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad.

`activate` (Gst.PadActivateFunction) –

the Gst.PadActivateFunction to set.

`user_data` (Object) –

user_data passed to notify

#### Gst.Pad.set_activate_function_full

    def Gst.Pad.set_activate_function_full (self, activate, *user_data):
        #python wrapper for 'gst_pad_set_activate_function_full'

Sets the given activate function for pad. The activate function will dispatch to Gst.Pad.activate_mode to perform the actual activation. Only makes sense to set on sink pads.

Call this function if your sink pad can start a pull-based task.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad.

`activate` (Gst.PadActivateFunction) –

the Gst.PadActivateFunction to set.

`user_data` (variadic) –

user_data passed to notify

#### gst_pad_set_activatemode_function_full

    gst_pad_set_activatemode_function_full (GstPad * pad,
                                            GstPadActivateModeFunction activatemode,
                                            gpointer user_data,
                                            GDestroyNotify notify)

Sets the given activate_mode function for the pad. An activate_mode function prepares the element for data passing.

Parameters:

`pad` –

a GstPad.

`activatemode` –

the GstPadActivateModeFunction to set.

`user_data` –

user_data passed to notify

`notify` –

notify called when activatemode will not be used anymore.

#### Gst.Pad.prototype.set_activatemode_function_full

    function Gst.Pad.prototype.set_activatemode_function_full(activatemode: Gst.PadActivateModeFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_set_activatemode_function_full'
    }

Sets the given activate_mode function for the pad. An activate_mode function prepares the element for data passing.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad.

`activatemode` (Gst.PadActivateModeFunction) –

the Gst.PadActivateModeFunction to set.

`user_data` (Object) –

user_data passed to notify

#### Gst.Pad.set_activatemode_function_full

    def Gst.Pad.set_activatemode_function_full (self, activatemode, *user_data):
        #python wrapper for 'gst_pad_set_activatemode_function_full'

Sets the given activate_mode function for the pad. An activate_mode function prepares the element for data passing.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad.

`activatemode` (Gst.PadActivateModeFunction) –

the Gst.PadActivateModeFunction to set.

`user_data` (variadic) –

user_data passed to notify

#### gst_pad_set_active

    gboolean
    gst_pad_set_active (GstPad * pad,
                        gboolean active)

Activates or deactivates the given pad. Normally called from within core state change functions.

If active, makes sure the pad is active. If it is already active, either in push or pull mode, just return. Otherwise dispatches to the pad's activate function to perform the actual activation.

If not active, calls gst_pad_activate_mode with the pad's current mode and a FALSE argument.

Parameters:

`pad` –

the GstPad to activate or deactivate.

`active` –

whether or not the pad should be active.

Returns –

TRUE if the operation was successful.

MT safe.

#### Gst.Pad.prototype.set_active

    function Gst.Pad.prototype.set_active(active: Number): {
        // javascript wrapper for 'gst_pad_set_active'
    }

Activates or deactivates the given pad. Normally called from within core state change functions.

If active, makes sure the pad is active. If it is already active, either in push or pull mode, just return. Otherwise dispatches to the pad's activate function to perform the actual activation.

If not active, calls Gst.Pad.prototype.activate_mode with the pad's current mode and a false argument.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to activate or deactivate.

`active` (Number) –

whether or not the pad should be active.

Returns (Number) –

true if the operation was successful.

MT safe.

#### Gst.Pad.set_active

    def Gst.Pad.set_active (self, active):
        #python wrapper for 'gst_pad_set_active'

Activates or deactivates the given pad. Normally called from within core state change functions.

If active, makes sure the pad is active. If it is already active, either in push or pull mode, just return. Otherwise dispatches to the pad's activate function to perform the actual activation.

If not active, calls Gst.Pad.activate_mode with the pad's current mode and a False argument.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to activate or deactivate.

`active` (bool) –

whether or not the pad should be active.

Returns (bool) –

True if the operation was successful.

MT safe.

#### gst_pad_set_chain_function_full

    gst_pad_set_chain_function_full (GstPad * pad,
                                     GstPadChainFunction chain,
                                     gpointer user_data,
                                     GDestroyNotify notify)

Sets the given chain function for the pad. The chain function is called to process a GstBuffer input buffer. see GstPadChainFunction for more details.

Parameters:

`pad` –

a sink GstPad.

`chain` –

the GstPadChainFunction to set.

`user_data` –

user_data passed to notify

`notify` –

notify called when chain will not be used anymore.

#### Gst.Pad.prototype.set_chain_function_full

    function Gst.Pad.prototype.set_chain_function_full(chain: Gst.PadChainFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_set_chain_function_full'
    }

Sets the given chain function for the pad. The chain function is called to process a Gst.Buffer input buffer. see Gst.PadChainFunction for more details.

Parameters:

`pad` (Gst.Pad) –

a sink Gst.Pad.

`chain` (Gst.PadChainFunction) –

the Gst.PadChainFunction to set.

`user_data` (Object) –

user_data passed to notify

#### Gst.Pad.set_chain_function_full

    def Gst.Pad.set_chain_function_full (self, chain, *user_data):
        #python wrapper for 'gst_pad_set_chain_function_full'

Sets the given chain function for the pad. The chain function is called to process a Gst.Buffer input buffer. see Gst.PadChainFunction for more details.

Parameters:

`pad` (Gst.Pad) –

a sink Gst.Pad.

`chain` (Gst.PadChainFunction) –

the Gst.PadChainFunction to set.

`user_data` (variadic) –

user_data passed to notify

#### gst_pad_set_chain_list_function_full

    gst_pad_set_chain_list_function_full (GstPad * pad,
                                          GstPadChainListFunction chainlist,
                                          gpointer user_data,
                                          GDestroyNotify notify)

Sets the given chain list function for the pad. The chainlist function is called to process a GstBufferList input buffer list. See GstPadChainListFunction for more details.

Parameters:

`pad` –

a sink GstPad.

`chainlist` –

the GstPadChainListFunction to set.

`user_data` –

user_data passed to notify

`notify` –

notify called when chainlist will not be used anymore.

#### Gst.Pad.prototype.set_chain_list_function_full

    function Gst.Pad.prototype.set_chain_list_function_full(chainlist: Gst.PadChainListFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_set_chain_list_function_full'
    }

Sets the given chain list function for the pad. The chainlist function is called to process a Gst.BufferList input buffer list. See Gst.PadChainListFunction for more details.

Parameters:

`pad` (Gst.Pad) –

a sink Gst.Pad.

`chainlist` (Gst.PadChainListFunction) –

the Gst.PadChainListFunction to set.

`user_data` (Object) –

user_data passed to notify

#### Gst.Pad.set_chain_list_function_full

    def Gst.Pad.set_chain_list_function_full (self, chainlist, *user_data):
        #python wrapper for 'gst_pad_set_chain_list_function_full'

Sets the given chain list function for the pad. The chainlist function is called to process a Gst.BufferList input buffer list. See Gst.PadChainListFunction for more details.

Parameters:

`pad` (Gst.Pad) –

a sink Gst.Pad.

`chainlist` (Gst.PadChainListFunction) –

the Gst.PadChainListFunction to set.

`user_data` (variadic) –

user_data passed to notify

#### gst_pad_set_element_private

    gst_pad_set_element_private (GstPad * pad,
                                 gpointer priv)

Set the given private data gpointer on the pad. This function can only be used by the element that owns the pad. No locking is performed in this function.

Parameters:

`pad` –

the GstPad to set the private data of.

`priv` –

The private data to attach to the pad.

#### Gst.Pad.prototype.set_element_private

    function Gst.Pad.prototype.set_element_private(priv: Object): {
        // javascript wrapper for 'gst_pad_set_element_private'
    }

Set the given private data gpointer on the pad. This function can only be used by the element that owns the pad. No locking is performed in this function.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to set the private data of.

`priv` (Object) –

The private data to attach to the pad.

#### Gst.Pad.set_element_private

    def Gst.Pad.set_element_private (self, priv):
        #python wrapper for 'gst_pad_set_element_private'

Set the given private data gpointer on the pad. This function can only be used by the element that owns the pad. No locking is performed in this function.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to set the private data of.

`priv` (object) –

The private data to attach to the pad.

#### gst_pad_set_event_full_function_full

    gst_pad_set_event_full_function_full (GstPad * pad,
                                          GstPadEventFullFunction event,
                                          gpointer user_data,
                                          GDestroyNotify notify)

Sets the given event handler for the pad.

Parameters:

`pad` –

a GstPad of either direction.

`event` –

the GstPadEventFullFunction to set.

`user_data` –

user_data passed to notify

`notify` –

notify called when event will not be used anymore.

Since : 1.8

#### Gst.Pad.prototype.set_event_full_function_full

    function Gst.Pad.prototype.set_event_full_function_full(event: Gst.PadEventFullFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_set_event_full_function_full'
    }

Sets the given event handler for the pad.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad of either direction.

`event` (Gst.PadEventFullFunction) –

the Gst.PadEventFullFunction to set.

`user_data` (Object) –

user_data passed to notify

Since : 1.8

#### Gst.Pad.set_event_full_function_full

    def Gst.Pad.set_event_full_function_full (self, event, *user_data):
        #python wrapper for 'gst_pad_set_event_full_function_full'

Sets the given event handler for the pad.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad of either direction.

`event` (Gst.PadEventFullFunction) –

the Gst.PadEventFullFunction to set.

`user_data` (variadic) –

user_data passed to notify

Since : 1.8

#### gst_pad_set_event_function_full

    gst_pad_set_event_function_full (GstPad * pad,
                                     GstPadEventFunction event,
                                     gpointer user_data,
                                     GDestroyNotify notify)

Sets the given event handler for the pad.

Parameters:

`pad` –

a GstPad of either direction.

`event` –

the GstPadEventFunction to set.

`user_data` –

user_data passed to notify

`notify` –

notify called when event will not be used anymore.

#### Gst.Pad.prototype.set_event_function_full

    function Gst.Pad.prototype.set_event_function_full(event: Gst.PadEventFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_set_event_function_full'
    }

Sets the given event handler for the pad.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad of either direction.

`event` (Gst.PadEventFunction) –

the Gst.PadEventFunction to set.

`user_data` (Object) –

user_data passed to notify

#### Gst.Pad.set_event_function_full

    def Gst.Pad.set_event_function_full (self, event, *user_data):
        #python wrapper for 'gst_pad_set_event_function_full'

Sets the given event handler for the pad.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad of either direction.

`event` (Gst.PadEventFunction) –

the Gst.PadEventFunction to set.

`user_data` (variadic) –

user_data passed to notify

#### gst_pad_set_getrange_function_full

    gst_pad_set_getrange_function_full (GstPad * pad,
                                        GstPadGetRangeFunction get,
                                        gpointer user_data,
                                        GDestroyNotify notify)

Sets the given getrange function for the pad. The getrange function is called to produce a new GstBuffer to start the processing pipeline. see GstPadGetRangeFunction for a description of the getrange function.

Parameters:

`pad` –

a source GstPad.

`get` –

the GstPadGetRangeFunction to set.

`user_data` –

user_data passed to notify

`notify` –

notify called when get will not be used anymore.

#### Gst.Pad.prototype.set_getrange_function_full

    function Gst.Pad.prototype.set_getrange_function_full(get: Gst.PadGetRangeFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_set_getrange_function_full'
    }

Sets the given getrange function for the pad. The getrange function is called to produce a new Gst.Buffer to start the processing pipeline. see Gst.PadGetRangeFunction for a description of the getrange function.

Parameters:

`pad` (Gst.Pad) –

a source Gst.Pad.

`get` (Gst.PadGetRangeFunction) –

the Gst.PadGetRangeFunction to set.

`user_data` (Object) –

user_data passed to notify

#### Gst.Pad.set_getrange_function_full

    def Gst.Pad.set_getrange_function_full (self, get, *user_data):
        #python wrapper for 'gst_pad_set_getrange_function_full'

Sets the given getrange function for the pad. The getrange function is called to produce a new Gst.Buffer to start the processing pipeline. see Gst.PadGetRangeFunction for a description of the getrange function.

Parameters:

`pad` (Gst.Pad) –

a source Gst.Pad.

`get` (Gst.PadGetRangeFunction) –

the Gst.PadGetRangeFunction to set.

`user_data` (variadic) –

user_data passed to notify

#### gst_pad_set_iterate_internal_links_function_full

    gst_pad_set_iterate_internal_links_function_full (GstPad * pad,
                                                      GstPadIterIntLinkFunction iterintlink,
                                                      gpointer user_data,
                                                      GDestroyNotify notify)

Sets the given internal link iterator function for the pad.

Parameters:

`pad` –

a GstPad of either direction.

`iterintlink` –

the GstPadIterIntLinkFunction to set.

`user_data` –

user_data passed to notify

`notify` –

notify called when iterintlink will not be used anymore.

#### Gst.Pad.prototype.set_iterate_internal_links_function_full

    function Gst.Pad.prototype.set_iterate_internal_links_function_full(iterintlink: Gst.PadIterIntLinkFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_set_iterate_internal_links_function_full'
    }

Sets the given internal link iterator function for the pad.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad of either direction.

`iterintlink` (Gst.PadIterIntLinkFunction) –

the Gst.PadIterIntLinkFunction to set.

`user_data` (Object) –

user_data passed to notify

#### Gst.Pad.set_iterate_internal_links_function_full

    def Gst.Pad.set_iterate_internal_links_function_full (self, iterintlink, *user_data):
        #python wrapper for 'gst_pad_set_iterate_internal_links_function_full'

Sets the given internal link iterator function for the pad.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad of either direction.

`iterintlink` (Gst.PadIterIntLinkFunction) –

the Gst.PadIterIntLinkFunction to set.

`user_data` (variadic) –

user_data passed to notify

#### gst_pad_set_link_function_full

    gst_pad_set_link_function_full (GstPad * pad,
                                    GstPadLinkFunction link,
                                    gpointer user_data,
                                    GDestroyNotify notify)

Sets the given link function for the pad. It will be called when the pad is linked with another pad.

The return value GST_PAD_LINK_OK should be used when the connection can be made.

The return value GST_PAD_LINK_REFUSED should be used when the connection cannot be made for some reason.

If link is installed on a source pad, it should call the GstPadLinkFunction of the peer sink pad, if present.

Parameters:

`pad` –

a GstPad.

`link` –

the GstPadLinkFunction to set.

`user_data` –

user_data passed to notify

`notify` –

notify called when link will not be used anymore.

#### Gst.Pad.prototype.set_link_function_full

    function Gst.Pad.prototype.set_link_function_full(link: Gst.PadLinkFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_set_link_function_full'
    }

Sets the given link function for the pad. It will be called when the pad is linked with another pad.

The return value Gst.PadLinkReturn.OK should be used when the connection can be made.

The return value Gst.PadLinkReturn.REFUSED should be used when the connection cannot be made for some reason.

If link is installed on a source pad, it should call the Gst.PadLinkFunction of the peer sink pad, if present.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad.

`link` (Gst.PadLinkFunction) –

the Gst.PadLinkFunction to set.

`user_data` (Object) –

user_data passed to notify

#### Gst.Pad.set_link_function_full

    def Gst.Pad.set_link_function_full (self, link, *user_data):
        #python wrapper for 'gst_pad_set_link_function_full'

Sets the given link function for the pad. It will be called when the pad is linked with another pad.

The return value Gst.PadLinkReturn.OK should be used when the connection can be made.

The return value Gst.PadLinkReturn.REFUSED should be used when the connection cannot be made for some reason.

If link is installed on a source pad, it should call the Gst.PadLinkFunction of the peer sink pad, if present.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad.

`link` (Gst.PadLinkFunction) –

the Gst.PadLinkFunction to set.

`user_data` (variadic) –

user_data passed to notify

#### gst_pad_set_offset

    gst_pad_set_offset (GstPad * pad,
                        gint64 offset)

Set the offset that will be applied to the running time of pad. Upon next buffer, every sticky events (notably segment) will be pushed again with their running time adjusted. For that reason this is only reliable on source pads.

Parameters:

`pad` –

a GstPad

`offset` –

the offset

#### Gst.Pad.prototype.set_offset

    function Gst.Pad.prototype.set_offset(offset: Number): {
        // javascript wrapper for 'gst_pad_set_offset'
    }

Set the offset that will be applied to the running time of pad. Upon next buffer, every sticky events (notably segment) will be pushed again with their running time adjusted. For that reason this is only reliable on source pads.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad

`offset` (Number) –

the offset

#### Gst.Pad.set_offset

    def Gst.Pad.set_offset (self, offset):
        #python wrapper for 'gst_pad_set_offset'

Set the offset that will be applied to the running time of pad. Upon next buffer, every sticky events (notably segment) will be pushed again with their running time adjusted. For that reason this is only reliable on source pads.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad

`offset` (int) –

the offset

#### gst_pad_set_query_function_full

    gst_pad_set_query_function_full (GstPad * pad,
                                     GstPadQueryFunction query,
                                     gpointer user_data,
                                     GDestroyNotify notify)

Set the given query function for the pad.

Parameters:

`pad` –

a GstPad of either direction.

`query` –

the GstPadQueryFunction to set.

`user_data` –

user_data passed to notify

`notify` –

notify called when query will not be used anymore.

#### Gst.Pad.prototype.set_query_function_full

    function Gst.Pad.prototype.set_query_function_full(query: Gst.PadQueryFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_set_query_function_full'
    }

Set the given query function for the pad.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad of either direction.

`query` (Gst.PadQueryFunction) –

the Gst.PadQueryFunction to set.

`user_data` (Object) –

user_data passed to notify

#### Gst.Pad.set_query_function_full

    def Gst.Pad.set_query_function_full (self, query, *user_data):
        #python wrapper for 'gst_pad_set_query_function_full'

Set the given query function for the pad.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad of either direction.

`query` (Gst.PadQueryFunction) –

the Gst.PadQueryFunction to set.

`user_data` (variadic) –

user_data passed to notify

#### gst_pad_set_unlink_function_full

    gst_pad_set_unlink_function_full (GstPad * pad,
                                      GstPadUnlinkFunction unlink,
                                      gpointer user_data,
                                      GDestroyNotify notify)

Sets the given unlink function for the pad. It will be called when the pad is unlinked.

Note that the pad's lock is already held when the unlink function is called, so most pad functions cannot be called from within the callback.

Parameters:

`pad` –

a GstPad.

`unlink` –

the GstPadUnlinkFunction to set.

`user_data` –

user_data passed to notify

`notify` –

notify called when unlink will not be used anymore.

#### Gst.Pad.prototype.set_unlink_function_full

    function Gst.Pad.prototype.set_unlink_function_full(unlink: Gst.PadUnlinkFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_set_unlink_function_full'
    }

Sets the given unlink function for the pad. It will be called when the pad is unlinked.

Note that the pad's lock is already held when the unlink function is called, so most pad functions cannot be called from within the callback.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad.

`unlink` (Gst.PadUnlinkFunction) –

the Gst.PadUnlinkFunction to set.

`user_data` (Object) –

user_data passed to notify

#### Gst.Pad.set_unlink_function_full

    def Gst.Pad.set_unlink_function_full (self, unlink, *user_data):
        #python wrapper for 'gst_pad_set_unlink_function_full'

Sets the given unlink function for the pad. It will be called when the pad is unlinked.

Note that the pad's lock is already held when the unlink function is called, so most pad functions cannot be called from within the callback.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad.

`unlink` (Gst.PadUnlinkFunction) –

the Gst.PadUnlinkFunction to set.

`user_data` (variadic) –

user_data passed to notify

#### gst_pad_start_task

    gboolean
    gst_pad_start_task (GstPad * pad,
                        GstTaskFunction func,
                        gpointer user_data,
                        GDestroyNotify notify)

Starts a task that repeatedly calls func with user_data. This function is mostly used in pad activation functions to start the dataflow. The GST_PAD_STREAM_LOCK of pad will automatically be acquired before func is called.

Parameters:

`pad` –

the GstPad to start the task of

`func` –

the task function to call

`user_data` –

user data passed to the task function

`notify` –

called when user_data is no longer referenced

Returns –

a TRUE if the task could be started.

#### Gst.Pad.prototype.start_task

    function Gst.Pad.prototype.start_task(func: Gst.TaskFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_start_task'
    }

Starts a task that repeatedly calls func with user_data. This function is mostly used in pad activation functions to start the dataflow. The GST_PAD_STREAM_LOCK (not introspectable) of pad will automatically be acquired before func is called.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to start the task of

`func` (Gst.TaskFunction) –

the task function to call

`user_data` (Object) –

user data passed to the task function

Returns (Number) –

a true if the task could be started.

#### Gst.Pad.start_task

    def Gst.Pad.start_task (self, func, *user_data):
        #python wrapper for 'gst_pad_start_task'

Starts a task that repeatedly calls func with user_data. This function is mostly used in pad activation functions to start the dataflow. The GST_PAD_STREAM_LOCK (not introspectable) of pad will automatically be acquired before func is called.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to start the task of

`func` (Gst.TaskFunction) –

the task function to call

`user_data` (variadic) –

user data passed to the task function

Returns (bool) –

a True if the task could be started.

#### gst_pad_sticky_events_foreach

    gst_pad_sticky_events_foreach (GstPad * pad,
                                   GstPadStickyEventsForeachFunction foreach_func,
                                   gpointer user_data)

Iterates all sticky events on pad and calls foreach_func for every event. If foreach_func returns FALSE the iteration is immediately stopped.

Parameters:

`pad` –

the GstPad that should be used for iteration.

`foreach_func` ( [scope call][closure]) –

the GstPadStickyEventsForeachFunction that should be called for every event.

`user_data` –

the optional user data.

#### Gst.Pad.prototype.sticky_events_foreach

    function Gst.Pad.prototype.sticky_events_foreach(foreach_func: Gst.PadStickyEventsForeachFunction, user_data: Object): {
        // javascript wrapper for 'gst_pad_sticky_events_foreach'
    }

Iterates all sticky events on pad and calls foreach_func for every event. If foreach_func returns false the iteration is immediately stopped.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad that should be used for iteration.

`foreach_func` (Gst.PadStickyEventsForeachFunction) –

the Gst.PadStickyEventsForeachFunction that should be called for every event.

`user_data` (Object) –

the optional user data.

#### Gst.Pad.sticky_events_foreach

    def Gst.Pad.sticky_events_foreach (self, foreach_func, *user_data):
        #python wrapper for 'gst_pad_sticky_events_foreach'

Iterates all sticky events on pad and calls foreach_func for every event. If foreach_func returns False the iteration is immediately stopped.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad that should be used for iteration.

`foreach_func` (Gst.PadStickyEventsForeachFunction) –

the Gst.PadStickyEventsForeachFunction that should be called for every event.

`user_data` (variadic) –

the optional user data.

#### gst_pad_stop_task

    gboolean
    gst_pad_stop_task (GstPad * pad)

Stop the task of pad. This function will also make sure that the function executed by the task will effectively stop if not called from the GstTaskFunction.

This function will deadlock if called from the GstTaskFunction of the task. Use gst_task_pause instead.

Regardless of whether the pad has a task, the stream lock is acquired and released so as to ensure that streaming through this pad has finished.

Parameters:

`pad` –

the GstPad to stop the task of

Returns –

a TRUE if the task could be stopped or FALSE on error.

#### Gst.Pad.prototype.stop_task

    function Gst.Pad.prototype.stop_task(): {
        // javascript wrapper for 'gst_pad_stop_task'
    }

Stop the task of pad. This function will also make sure that the function executed by the task will effectively stop if not called from the GstTaskFunction.

This function will deadlock if called from the GstTaskFunction of the task. Use Gst.Task.prototype.pause instead.

Regardless of whether the pad has a task, the stream lock is acquired and released so as to ensure that streaming through this pad has finished.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to stop the task of

Returns (Number) –

a true if the task could be stopped or false on error.

#### Gst.Pad.stop_task

    def Gst.Pad.stop_task (self):
        #python wrapper for 'gst_pad_stop_task'

Stop the task of pad. This function will also make sure that the function executed by the task will effectively stop if not called from the GstTaskFunction.

This function will deadlock if called from the GstTaskFunction of the task. Use Gst.Task.pause instead.

Regardless of whether the pad has a task, the stream lock is acquired and released so as to ensure that streaming through this pad has finished.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to stop the task of

Returns (bool) –

a True if the task could be stopped or False on error.

#### gst_pad_store_sticky_event

    GstFlowReturn
    gst_pad_store_sticky_event (GstPad * pad,
                                GstEvent * event)

Store the sticky event on pad

Parameters:

`pad` –

a GstPad

`event` ( [transfer: none]) –

a GstEvent

Returns –

GST_FLOW_OK on success, GST_FLOW_FLUSHING when the pad was flushing or GST_FLOW_EOS when the pad was EOS.

Since : 1.2

#### Gst.Pad.prototype.store_sticky_event

    function Gst.Pad.prototype.store_sticky_event(event: Gst.Event): {
        // javascript wrapper for 'gst_pad_store_sticky_event'
    }

Store the sticky event on pad

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad

`event` (Gst.Event) –

a Gst.Event

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK on success, Gst.FlowReturn.FLUSHING when the pad was flushing or Gst.FlowReturn.EOS when the pad was EOS.

Since : 1.2

#### Gst.Pad.store_sticky_event

    def Gst.Pad.store_sticky_event (self, event):
        #python wrapper for 'gst_pad_store_sticky_event'

Store the sticky event on pad

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad

`event` (Gst.Event) –

a Gst.Event

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK on success, Gst.FlowReturn.FLUSHING when the pad was flushing or Gst.FlowReturn.EOS when the pad was EOS.

Since : 1.2

#### gst_pad_unlink

    gboolean
    gst_pad_unlink (GstPad * srcpad,
                    GstPad * sinkpad)

Unlinks the source pad from the sink pad. Will emit the unlinked signal on both pads.

Parameters:

`srcpad` –

the source GstPad to unlink.

`sinkpad` –

the sink GstPad to unlink.

Returns –

TRUE if the pads were unlinked. This function returns FALSE if the pads were not linked together.

MT safe.

#### Gst.Pad.prototype.unlink

    function Gst.Pad.prototype.unlink(sinkpad: Gst.Pad): {
        // javascript wrapper for 'gst_pad_unlink'
    }

Unlinks the source pad from the sink pad. Will emit the unlinked signal on both pads.

Parameters:

`srcpad` (Gst.Pad) –

the source Gst.Pad to unlink.

`sinkpad` (Gst.Pad) –

the sink Gst.Pad to unlink.

Returns (Number) –

true if the pads were unlinked. This function returns false if the pads were not linked together.

MT safe.

#### Gst.Pad.unlink

    def Gst.Pad.unlink (self, sinkpad):
        #python wrapper for 'gst_pad_unlink'

Unlinks the source pad from the sink pad. Will emit the unlinked signal on both pads.

Parameters:

`srcpad` (Gst.Pad) –

the source Gst.Pad to unlink.

`sinkpad` (Gst.Pad) –

the sink Gst.Pad to unlink.

Returns (bool) –

True if the pads were unlinked. This function returns False if the pads were not linked together.

MT safe.

#### gst_pad_use_fixed_caps

    gst_pad_use_fixed_caps (GstPad * pad)

A helper function you can use that sets the FIXED_CAPS flag This way the default CAPS query will always return the negotiated caps or in case the pad is not negotiated, the padtemplate caps.

The negotiated caps are the caps of the last CAPS event that passed on the pad. Use this function on a pad that, once it negotiated to a CAPS, cannot be renegotiated to something else.

Parameters:

`pad` –

the pad to use

#### Gst.Pad.prototype.use_fixed_caps

    function Gst.Pad.prototype.use_fixed_caps(): {
        // javascript wrapper for 'gst_pad_use_fixed_caps'
    }

A helper function you can use that sets the FIXED_CAPS flag This way the default CAPS query will always return the negotiated caps or in case the pad is not negotiated, the padtemplate caps.

The negotiated caps are the caps of the last CAPS event that passed on the pad. Use this function on a pad that, once it negotiated to a CAPS, cannot be renegotiated to something else.

Parameters:

`pad` (Gst.Pad) –

the pad to use

#### Gst.Pad.use_fixed_caps

    def Gst.Pad.use_fixed_caps (self):
        #python wrapper for 'gst_pad_use_fixed_caps'

A helper function you can use that sets the FIXED_CAPS flag This way the default CAPS query will always return the negotiated caps or in case the pad is not negotiated, the padtemplate caps.

The negotiated caps are the caps of the last CAPS event that passed on the pad. Use this function on a pad that, once it negotiated to a CAPS, cannot be renegotiated to something else.

Parameters:

`pad` (Gst.Pad) –

the pad to use

### Functions

#### gst_pad_link_get_name

    const gchar *
    gst_pad_link_get_name (GstPadLinkReturn ret)

Gets a string representing the given pad-link return.

Parameters:

`ret` –

a GstPadLinkReturn to get the name of.

Returns –

a static string with the name of the pad-link return.

Since : 1.4

#### Gst.Pad.prototype.link_get_name

    function Gst.Pad.prototype.link_get_name(ret: Gst.PadLinkReturn): {
        // javascript wrapper for 'gst_pad_link_get_name'
    }

Gets a string representing the given pad-link return.

Parameters:

`ret` (Gst.PadLinkReturn) –

a Gst.PadLinkReturn to get the name of.

Returns (String) –

a static string with the name of the pad-link return.

Since : 1.4

#### Gst.Pad.link_get_name

    def Gst.Pad.link_get_name (ret):
        #python wrapper for 'gst_pad_link_get_name'

Gets a string representing the given pad-link return.

Parameters:

`ret` (Gst.PadLinkReturn) –

a Gst.PadLinkReturn to get the name of.

Returns (str) –

a static string with the name of the pad-link return.

Since : 1.4

### Signals

#### linked

    linked_callback (GstPad * self,
                     GstPad * peer,
                     gpointer user_data)

Signals that a pad has been linked to the peer pad.

Parameters:

`self` –
No description available
`peer` –

the peer pad that has been connected

`user_data` –
No description available

Flags: Run Last

#### linked

    function linked_callback(self: Gst.Pad, peer: Gst.Pad, user_data: Object): {
        // javascript callback for the 'linked' signal
    }

Signals that a pad has been linked to the peer pad.

Parameters:

`self` (Gst.Pad) –
No description available
`peer` (Gst.Pad) –

the peer pad that has been connected

`user_data` (Object) –
No description available

Flags: Run Last

#### linked

    def linked_callback (self, peer, *user_data):
        #python callback for the 'linked' signal

Signals that a pad has been linked to the peer pad.

Parameters:

`self` (Gst.Pad) –
No description available
`peer` (Gst.Pad) –

the peer pad that has been connected

`user_data` (variadic) –
No description available

Flags: Run Last

#### unlinked

    unlinked_callback (GstPad * self,
                       GstPad * peer,
                       gpointer user_data)

Signals that a pad has been unlinked from the peer pad.

Parameters:

`self` –
No description available
`peer` –

the peer pad that has been disconnected

`user_data` –
No description available

Flags: Run Last

#### unlinked

    function unlinked_callback(self: Gst.Pad, peer: Gst.Pad, user_data: Object): {
        // javascript callback for the 'unlinked' signal
    }

Signals that a pad has been unlinked from the peer pad.

Parameters:

`self` (Gst.Pad) –
No description available
`peer` (Gst.Pad) –

the peer pad that has been disconnected

`user_data` (Object) –
No description available

Flags: Run Last

#### unlinked

    def unlinked_callback (self, peer, *user_data):
        #python callback for the 'unlinked' signal

Signals that a pad has been unlinked from the peer pad.

Parameters:

`self` (Gst.Pad) –
No description available
`peer` (Gst.Pad) –

the peer pad that has been disconnected

`user_data` (variadic) –
No description available

Flags: Run Last

### Properties

#### caps

    “caps” GstCaps *

Flags : Read

#### caps

    “caps” Gst.Caps

Flags : Read

#### caps

    “self.props.caps” Gst.Caps

Flags : Read

#### direction

    “direction” GstPadDirection *

Flags : Read / Write / Construct Only

#### direction

    “direction” Gst.PadDirection

Flags : Read / Write / Construct Only

#### direction

    “self.props.direction” Gst.PadDirection

Flags : Read / Write / Construct Only

#### offset

    “offset” gint64

The offset that will be applied to the running time of the pad.

Flags : Read / Write

Since : 1.6

#### offset

    “offset” Number

The offset that will be applied to the running time of the pad.

Flags : Read / Write

Since : 1.6

#### offset

    “self.props.offset” int

The offset that will be applied to the running time of the pad.

Flags : Read / Write

Since : 1.6

#### template

    “template” GstPadTemplate *

Flags : Read / Write

#### template

    “template” Gst.PadTemplate

Flags : Read / Write

#### template

    “self.props.template” Gst.PadTemplate

Flags : Read / Write

### Virtual Methods

#### linked

    linked (GstPad * pad,
            GstPad * peer)

Parameters:

`pad` –
No description available
`peer` –
No description available

#### vfunc_linked

    function vfunc_linked(pad: Gst.Pad, peer: Gst.Pad): {
        // javascript implementation of the 'linked' virtual method
    }

Parameters:

`pad` (Gst.Pad) –
No description available
`peer` (Gst.Pad) –
No description available

#### do_linked

    def do_linked (pad, peer):
        #python implementation of the 'linked' virtual method

Parameters:

`pad` (Gst.Pad) –
No description available
`peer` (Gst.Pad) –
No description available

#### unlinked

    unlinked (GstPad * pad,
              GstPad * peer)

Parameters:

`pad` –
No description available
`peer` –
No description available

#### vfunc_unlinked

    function vfunc_unlinked(pad: Gst.Pad, peer: Gst.Pad): {
        // javascript implementation of the 'unlinked' virtual method
    }

Parameters:

`pad` (Gst.Pad) –
No description available
`peer` (Gst.Pad) –
No description available

#### do_unlinked

    def do_unlinked (pad, peer):
        #python implementation of the 'unlinked' virtual method

Parameters:

`pad` (Gst.Pad) –
No description available
`peer` (Gst.Pad) –
No description available

## GstPadProbeInfo

Info passed in the GstPadProbeCallback.

### Members

`type` (GstPadProbeType) –

the current probe type

`id` (gulong) –

the id of the probe

`data` (gpointer) –

type specific data, check the type field to know the datatype. This field can be NULL.

`offset` (guint64) –

offset of pull probe, this field is valid when type contains GST_PAD_PROBE_TYPE_PULL

`size` (guint) –

size of pull probe, this field is valid when type contains GST_PAD_PROBE_TYPE_PULL

`ABI._gst_reserved` (gpointer *) –
No description available
`ABI.abi.flow_ret` (GstFlowReturn) –
No description available

## Gst.PadProbeInfo

Info passed in the Gst.PadProbeCallback.

### Members

`type` (Gst.PadProbeType) –

the current probe type

`id` (Number) –

the id of the probe

`data` (Object) –

type specific data, check the type field to know the datatype. This field can be null.

`offset` (Number) –

offset of pull probe, this field is valid when type contains Gst.PadProbeType.PULL

`size` (Number) –

size of pull probe, this field is valid when type contains Gst.PadProbeType.PULL

## Gst.PadProbeInfo

Info passed in the Gst.PadProbeCallback.

### Members

`type` (Gst.PadProbeType) –

the current probe type

`id` (int) –

the id of the probe

`data` (object) –

type specific data, check the type field to know the datatype. This field can be None.

`offset` (int) –

offset of pull probe, this field is valid when type contains Gst.PadProbeType.PULL

`size` (int) –

size of pull probe, this field is valid when type contains Gst.PadProbeType.PULL

### Methods

#### gst_pad_probe_info_get_buffer

    GstBuffer *
    gst_pad_probe_info_get_buffer (GstPadProbeInfo * info)

Parameters:

`info` –

a GstPadProbeInfo

Returns ( [transfer: none][nullable]) –

The GstBuffer from the probe

#### Gst.PadProbeInfo.prototype.get_buffer

    function Gst.PadProbeInfo.prototype.get_buffer(): {
        // javascript wrapper for 'gst_pad_probe_info_get_buffer'
    }

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Gst.Buffer) –

The Gst.Buffer from the probe

#### Gst.PadProbeInfo.get_buffer

    def Gst.PadProbeInfo.get_buffer (self):
        #python wrapper for 'gst_pad_probe_info_get_buffer'

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Gst.Buffer) –

The Gst.Buffer from the probe

#### gst_pad_probe_info_get_buffer_list

    GstBufferList *
    gst_pad_probe_info_get_buffer_list (GstPadProbeInfo * info)

Parameters:

`info` –

a GstPadProbeInfo

Returns ( [transfer: none][nullable]) –

The GstBufferList from the probe

#### Gst.PadProbeInfo.prototype.get_buffer_list

    function Gst.PadProbeInfo.prototype.get_buffer_list(): {
        // javascript wrapper for 'gst_pad_probe_info_get_buffer_list'
    }

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Gst.BufferList) –

The Gst.BufferList from the probe

#### Gst.PadProbeInfo.get_buffer_list

    def Gst.PadProbeInfo.get_buffer_list (self):
        #python wrapper for 'gst_pad_probe_info_get_buffer_list'

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Gst.BufferList) –

The Gst.BufferList from the probe

#### gst_pad_probe_info_get_event

    GstEvent *
    gst_pad_probe_info_get_event (GstPadProbeInfo * info)

Parameters:

`info` –

a GstPadProbeInfo

Returns ( [transfer: none][nullable]) –

The GstEvent from the probe

#### Gst.PadProbeInfo.prototype.get_event

    function Gst.PadProbeInfo.prototype.get_event(): {
        // javascript wrapper for 'gst_pad_probe_info_get_event'
    }

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Gst.Event) –

The Gst.Event from the probe

#### Gst.PadProbeInfo.get_event

    def Gst.PadProbeInfo.get_event (self):
        #python wrapper for 'gst_pad_probe_info_get_event'

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Gst.Event) –

The Gst.Event from the probe

#### gst_pad_probe_info_get_flow_return

    GstFlowReturn
    gst_pad_probe_info_get_flow_return (GstPadProbeInfo * info)

Parameters:

`info` –

a GstPadProbeInfo

Returns –

The GstFlowReturn from the probe

Since : 1.28

#### Gst.PadProbeInfo.prototype.get_flow_return

    function Gst.PadProbeInfo.prototype.get_flow_return(): {
        // javascript wrapper for 'gst_pad_probe_info_get_flow_return'
    }

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Gst.FlowReturn) –

The Gst.FlowReturn from the probe

Since : 1.28

#### Gst.PadProbeInfo.get_flow_return

    def Gst.PadProbeInfo.get_flow_return (self):
        #python wrapper for 'gst_pad_probe_info_get_flow_return'

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Gst.FlowReturn) –

The Gst.FlowReturn from the probe

Since : 1.28

#### gst_pad_probe_info_get_id

    gulong
    gst_pad_probe_info_get_id (GstPadProbeInfo * info)

Parameters:

`info` –

a GstPadProbeInfo

Returns –

The probe ID from the probe

Since : 1.28

#### Gst.PadProbeInfo.prototype.get_id

    function Gst.PadProbeInfo.prototype.get_id(): {
        // javascript wrapper for 'gst_pad_probe_info_get_id'
    }

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Number) –

The probe ID from the probe

Since : 1.28

#### Gst.PadProbeInfo.get_id

    def Gst.PadProbeInfo.get_id (self):
        #python wrapper for 'gst_pad_probe_info_get_id'

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (int) –

The probe ID from the probe

Since : 1.28

#### gst_pad_probe_info_get_offset

    guint64
    gst_pad_probe_info_get_offset (GstPadProbeInfo * info)

Parameters:

`info` –

a GstPadProbeInfo

Returns –

The offset from the probe

Since : 1.28

#### Gst.PadProbeInfo.prototype.get_offset

    function Gst.PadProbeInfo.prototype.get_offset(): {
        // javascript wrapper for 'gst_pad_probe_info_get_offset'
    }

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Number) –

The offset from the probe

Since : 1.28

#### Gst.PadProbeInfo.get_offset

    def Gst.PadProbeInfo.get_offset (self):
        #python wrapper for 'gst_pad_probe_info_get_offset'

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (int) –

The offset from the probe

Since : 1.28

#### gst_pad_probe_info_get_query

    GstQuery *
    gst_pad_probe_info_get_query (GstPadProbeInfo * info)

Parameters:

`info` –

a GstPadProbeInfo

Returns ( [transfer: none][nullable]) –

The GstQuery from the probe

#### Gst.PadProbeInfo.prototype.get_query

    function Gst.PadProbeInfo.prototype.get_query(): {
        // javascript wrapper for 'gst_pad_probe_info_get_query'
    }

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Gst.Query) –

The Gst.Query from the probe

#### Gst.PadProbeInfo.get_query

    def Gst.PadProbeInfo.get_query (self):
        #python wrapper for 'gst_pad_probe_info_get_query'

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Gst.Query) –

The Gst.Query from the probe

#### gst_pad_probe_info_get_size

    gsize
    gst_pad_probe_info_get_size (GstPadProbeInfo * info)

Parameters:

`info` –

a GstPadProbeInfo

Returns –

The size from the probe

Since : 1.28

#### Gst.PadProbeInfo.prototype.get_size

    function Gst.PadProbeInfo.prototype.get_size(): {
        // javascript wrapper for 'gst_pad_probe_info_get_size'
    }

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Number) –

The size from the probe

Since : 1.28

#### Gst.PadProbeInfo.get_size

    def Gst.PadProbeInfo.get_size (self):
        #python wrapper for 'gst_pad_probe_info_get_size'

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (int) –

The size from the probe

Since : 1.28

#### gst_pad_probe_info_get_type

    GstPadProbeType
    gst_pad_probe_info_get_type (GstPadProbeInfo * info)

Parameters:

`info` –

a GstPadProbeInfo

Returns –

The GstPadProbeType from the probe

Since : 1.28

#### Gst.PadProbeInfo.prototype.get_type

    function Gst.PadProbeInfo.prototype.get_type(): {
        // javascript wrapper for 'gst_pad_probe_info_get_type'
    }

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Gst.PadProbeType) –

The Gst.PadProbeType from the probe

Since : 1.28

#### Gst.PadProbeInfo.get_type

    def Gst.PadProbeInfo.get_type (self):
        #python wrapper for 'gst_pad_probe_info_get_type'

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

Returns (Gst.PadProbeType) –

The Gst.PadProbeType from the probe

Since : 1.28

#### gst_pad_probe_info_set_buffer

    gst_pad_probe_info_set_buffer (GstPadProbeInfo * info,
                                   GstBuffer * buffer)

Updates info with buffer or NULL.

Parameters:

`info` –

a GstPadProbeInfo

`buffer` ( [transfer: full][nullable]) –

a GstBuffer

Since : 1.28

#### Gst.PadProbeInfo.prototype.set_buffer

    function Gst.PadProbeInfo.prototype.set_buffer(buffer: Gst.Buffer): {
        // javascript wrapper for 'gst_pad_probe_info_set_buffer'
    }

Updates info with buffer or null.

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

`buffer` (Gst.Buffer) –

a Gst.Buffer

Since : 1.28

#### Gst.PadProbeInfo.set_buffer

    def Gst.PadProbeInfo.set_buffer (self, buffer):
        #python wrapper for 'gst_pad_probe_info_set_buffer'

Updates info with buffer or None.

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

`buffer` (Gst.Buffer) –

a Gst.Buffer

Since : 1.28

#### gst_pad_probe_info_set_buffer_list

    gst_pad_probe_info_set_buffer_list (GstPadProbeInfo * info,
                                        GstBufferList * list)

Updates info with list or NULL.

Parameters:

`info` –

a GstPadProbeInfo

`list` ( [transfer: full][nullable]) –

a GstBufferList

Since : 1.28

#### Gst.PadProbeInfo.prototype.set_buffer_list

    function Gst.PadProbeInfo.prototype.set_buffer_list(list: Gst.BufferList): {
        // javascript wrapper for 'gst_pad_probe_info_set_buffer_list'
    }

Updates info with list or null.

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

`list` (Gst.BufferList) –

a Gst.BufferList

Since : 1.28

#### Gst.PadProbeInfo.set_buffer_list

    def Gst.PadProbeInfo.set_buffer_list (self, list):
        #python wrapper for 'gst_pad_probe_info_set_buffer_list'

Updates info with list or None.

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

`list` (Gst.BufferList) –

a Gst.BufferList

Since : 1.28

#### gst_pad_probe_info_set_event

    gst_pad_probe_info_set_event (GstPadProbeInfo * info,
                                  GstEvent * event)

Updates info with event or NULL.

Parameters:

`info` –

a GstPadProbeInfo

`event` ( [transfer: full][nullable]) –

a GstEvent

Since : 1.28

#### Gst.PadProbeInfo.prototype.set_event

    function Gst.PadProbeInfo.prototype.set_event(event: Gst.Event): {
        // javascript wrapper for 'gst_pad_probe_info_set_event'
    }

Updates info with event or null.

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

`event` (Gst.Event) –

a Gst.Event

Since : 1.28

#### Gst.PadProbeInfo.set_event

    def Gst.PadProbeInfo.set_event (self, event):
        #python wrapper for 'gst_pad_probe_info_set_event'

Updates info with event or None.

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

`event` (Gst.Event) –

a Gst.Event

Since : 1.28

#### gst_pad_probe_info_set_flow_return

    gst_pad_probe_info_set_flow_return (GstPadProbeInfo * info,
                                        GstFlowReturn flow_ret)

Updates info with flow_ret.

Parameters:

`info` –

a GstPadProbeInfo

`flow_ret` –

A GstFlowReturn

Since : 1.28

#### Gst.PadProbeInfo.prototype.set_flow_return

    function Gst.PadProbeInfo.prototype.set_flow_return(flow_ret: Gst.FlowReturn): {
        // javascript wrapper for 'gst_pad_probe_info_set_flow_return'
    }

Updates info with flow_ret.

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

`flow_ret` (Gst.FlowReturn) –

A Gst.FlowReturn

Since : 1.28

#### Gst.PadProbeInfo.set_flow_return

    def Gst.PadProbeInfo.set_flow_return (self, flow_ret):
        #python wrapper for 'gst_pad_probe_info_set_flow_return'

Updates info with flow_ret.

Parameters:

`info` (Gst.PadProbeInfo) –

a Gst.PadProbeInfo

`flow_ret` (Gst.FlowReturn) –

A Gst.FlowReturn

Since : 1.28

## Functions

### gst_flow_get_name

    const gchar *
    gst_flow_get_name (GstFlowReturn ret)

Gets a string representing the given flow return.

Parameters:

`ret` –

a GstFlowReturn to get the name of.

Returns –

a static string with the name of the flow return.

### Gst.prototype.flow_get_name

    function Gst.prototype.flow_get_name(ret: Gst.FlowReturn): {
        // javascript wrapper for 'gst_flow_get_name'
    }

Gets a string representing the given flow return.

Parameters:

`ret` (Gst.FlowReturn) –

a Gst.FlowReturn to get the name of.

Returns (String) –

a static string with the name of the flow return.

### Gst.flow_get_name

    def Gst.flow_get_name (ret):
        #python wrapper for 'gst_flow_get_name'

Gets a string representing the given flow return.

Parameters:

`ret` (Gst.FlowReturn) –

a Gst.FlowReturn to get the name of.

Returns (str) –

a static string with the name of the flow return.

### gst_flow_to_quark

    GQuark
    gst_flow_to_quark (GstFlowReturn ret)

Get the unique quark for the given GstFlowReturn.

Parameters:

`ret` –

a GstFlowReturn to get the quark of.

Returns –

the quark associated with the flow return or 0 if an invalid return was specified.

### Gst.prototype.flow_to_quark

    function Gst.prototype.flow_to_quark(ret: Gst.FlowReturn): {
        // javascript wrapper for 'gst_flow_to_quark'
    }

Get the unique quark for the given GstFlowReturn.

Parameters:

`ret` (Gst.FlowReturn) –

a Gst.FlowReturn to get the quark of.

Returns (GLib.Quark) –

the quark associated with the flow return or 0 if an invalid return was specified.

### Gst.flow_to_quark

    def Gst.flow_to_quark (ret):
        #python wrapper for 'gst_flow_to_quark'

Get the unique quark for the given GstFlowReturn.

Parameters:

`ret` (Gst.FlowReturn) –

a Gst.FlowReturn to get the quark of.

Returns (GLib.Quark) –

the quark associated with the flow return or 0 if an invalid return was specified.

### gst_pad_mode_get_name

    const gchar *
    gst_pad_mode_get_name (GstPadMode mode)

Return the name of a pad mode, for use in debug messages mostly.

Parameters:

`mode` –

the pad mode

Returns –

short mnemonic for pad mode mode

### Gst.prototype.pad_mode_get_name

    function Gst.prototype.pad_mode_get_name(mode: Gst.PadMode): {
        // javascript wrapper for 'gst_pad_mode_get_name'
    }

Return the name of a pad mode, for use in debug messages mostly.

Parameters:

`mode` (Gst.PadMode) –

the pad mode

Returns (String) –

short mnemonic for pad mode mode

### Gst.pad_mode_get_name

    def Gst.pad_mode_get_name (mode):
        #python wrapper for 'gst_pad_mode_get_name'

Return the name of a pad mode, for use in debug messages mostly.

Parameters:

`mode` (Gst.PadMode) –

the pad mode

Returns (str) –

short mnemonic for pad mode mode

## Function Macros

### GST_PAD_ACTIVATEFUNC

    #define GST_PAD_ACTIVATEFUNC(pad)	(GST_PAD_CAST(pad)->activatefunc)

Get the GstPadActivateFunction from pad.

Parameters:

`pad` –

a GstPad

### GST_PAD_ACTIVATEMODEFUNC

    #define GST_PAD_ACTIVATEMODEFUNC(pad)	(GST_PAD_CAST(pad)->activatemodefunc)

Get the GstPadActivateModeFunction from the given pad.

Parameters:

`pad` –

a GstPad

### GST_PAD_BLOCK_BROADCAST

    #define GST_PAD_BLOCK_BROADCAST(pad)    (g_cond_broadcast(GST_PAD_BLOCK_GET_COND (pad)))

### GST_PAD_BLOCK_GET_COND

    #define GST_PAD_BLOCK_GET_COND(pad)     (&GST_PAD_CAST(pad)->block_cond)

### GST_PAD_BLOCK_SIGNAL

    #define GST_PAD_BLOCK_SIGNAL(pad)       (g_cond_signal(GST_PAD_BLOCK_GET_COND (pad)))

### GST_PAD_BLOCK_WAIT

    #define GST_PAD_BLOCK_WAIT(pad)         (g_cond_wait(GST_PAD_BLOCK_GET_COND (pad), GST_OBJECT_GET_LOCK (pad)))

### GST_PAD_CAST

    #define GST_PAD_CAST(obj)		((GstPad*)(obj))

### GST_PAD_CHAINFUNC

    #define GST_PAD_CHAINFUNC(pad)		(GST_PAD_CAST(pad)->chainfunc)

Get the GstPadChainFunction from the given pad.

Parameters:

`pad` –

a GstPad

### GST_PAD_CHAINLISTFUNC

    #define GST_PAD_CHAINLISTFUNC(pad)      (GST_PAD_CAST(pad)->chainlistfunc)

Get the GstPadChainListFunction from the given pad.

Parameters:

`pad` –

a GstPad

### GST_PAD_DIRECTION

    #define GST_PAD_DIRECTION(pad)		(GST_PAD_CAST(pad)->direction)

Get the GstPadDirection of the given pad. Accessor macro, use gst_pad_get_direction instead.

Parameters:

`pad` –

a GstPad

### GST_PAD_ELEMENT_PRIVATE

    #define GST_PAD_ELEMENT_PRIVATE(pad)    (GST_PAD_CAST(pad)->element_private)

Get the private data of pad, which is usually some pad- or stream-specific structure created by the element and set on the pad when creating it. No locking is performed in this function.

Parameters:

`pad` –

a GstPad

### GST_PAD_EVENTFULLFUNC

    #define GST_PAD_EVENTFULLFUNC(pad)	(GST_PAD_CAST(pad)->ABI.abi.eventfullfunc)

Get the GstPadEventFullFunction from the given pad, which is the function that handles events on the pad. You can use this to set your own event handling function on a pad after you create it. If your element derives from a base class, use the base class's virtual functions instead.

Parameters:

`pad` –

a GstPad

Since : 1.8

### GST_PAD_EVENTFUNC

    #define GST_PAD_EVENTFUNC(pad)		(GST_PAD_CAST(pad)->eventfunc)

Get the GstPadEventFunction from the given pad, which is the function that handles events on the pad. You can use this to set your own event handling function on a pad after you create it. If your element derives from a base class, use the base class's virtual functions instead.

Parameters:

`pad` –

a GstPad

### GST_PAD_GETRANGEFUNC

    #define GST_PAD_GETRANGEFUNC(pad)	(GST_PAD_CAST(pad)->getrangefunc)

Get the GstPadGetRangeFunction from the given pad.

Parameters:

`pad` –

a GstPad

### GST_PAD_GET_STREAM_LOCK

    #define GST_PAD_GET_STREAM_LOCK(pad)    (&(GST_PAD_CAST(pad)->stream_rec_lock))

Get the stream lock of pad. The stream lock is protecting the resources used in the data processing functions of pad. Accessor macro, use GST_PAD_STREAM_LOCK and GST_PAD_STREAM_UNLOCK instead to take/release the pad's stream lock.

Parameters:

`pad` –

a GstPad

### GST_PAD_HAS_PENDING_EVENTS

    #define GST_PAD_HAS_PENDING_EVENTS(pad) (GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_PENDING_EVENTS))

Check if the given pad has pending events. This is used internally by GStreamer.

Parameters:

`pad` –

a GstPad

### GST_PAD_IS_ACCEPT_INTERSECT

    #define GST_PAD_IS_ACCEPT_INTERSECT(pad)    (GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_ACCEPT_INTERSECT))

Check if the pad's accept intersect flag is set. The default accept-caps handler will check if the caps intersect the query-caps result instead of checking for a subset. This is interesting for parser elements that can accept incompletely specified caps.

Parameters:

`pad` –

a GstPad

### GST_PAD_IS_ACCEPT_TEMPLATE

    #define GST_PAD_IS_ACCEPT_TEMPLATE(pad)    (GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_ACCEPT_TEMPLATE))

Check if the pad's accept caps operation will use the pad template caps. The default accept-caps will do a query caps to get the caps, which might be querying downstream causing unnecessary overhead. It is recommended to implement a proper accept-caps query handler or to use this flag to prevent recursive accept-caps handling.

Parameters:

`pad` –

a GstPad

Since : 1.6

### GST_PAD_IS_ACTIVE

    #define GST_PAD_IS_ACTIVE(pad)          (GST_PAD_MODE(pad) != GST_PAD_MODE_NONE)

Parameters:

`pad` –

a GstPad

Returns –

TRUE if the pad has been activated.

### GST_PAD_IS_BLOCKED

    #define GST_PAD_IS_BLOCKED(pad)		(GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_BLOCKED))

Check if the dataflow on a pad is blocked. Use gst_pad_is_blocked instead.

Parameters:

`pad` –

a GstPad

### GST_PAD_IS_BLOCKING

    #define GST_PAD_IS_BLOCKING(pad)	(GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_BLOCKING))

Check if the pad is currently blocking on a buffer or event. Use gst_pad_is_blocking instead.

Parameters:

`pad` –

a GstPad

### GST_PAD_IS_EOS

    #define GST_PAD_IS_EOS(pad)	        (GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_EOS))

Check if the pad is in EOS state.

Parameters:

`pad` –

a GstPad

### GST_PAD_IS_FIXED_CAPS

    #define GST_PAD_IS_FIXED_CAPS(pad)	(GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_FIXED_CAPS))

Check if the given pad is using fixed caps, which means that once the caps are set on the pad, the caps query function will only return those caps. See gst_pad_use_fixed_caps.

Parameters:

`pad` –

a GstPad

### GST_PAD_IS_FLUSHING

    #define GST_PAD_IS_FLUSHING(pad)	(GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_FLUSHING))

Check if the given pad is flushing.

Parameters:

`pad` –

a GstPad

### GST_PAD_IS_LINKED

    #define GST_PAD_IS_LINKED(pad)		(GST_PAD_PEER(pad) != NULL)

Parameters:

`pad` –

a GstPad

Returns –

TRUE if the pad is linked to another pad. Use gst_pad_is_linked instead.

### GST_PAD_IS_PROXY_ALLOCATION

    #define GST_PAD_IS_PROXY_ALLOCATION(pad)    (GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_PROXY_ALLOCATION))

Check if the given pad is set as proxy allocation which means that the default query handler will forward allocation queries to the internally linked pads instead of discarding them.

Parameters:

`pad` –

a GstPad

### GST_PAD_IS_PROXY_CAPS

    #define GST_PAD_IS_PROXY_CAPS(pad)      (GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_PROXY_CAPS))

Check if the given pad is set to proxy caps. This means that the default event and query handler will forward all events and queries to the internally linked pads instead of discarding them.

Parameters:

`pad` –

a GstPad

### GST_PAD_IS_PROXY_SCHEDULING

    #define GST_PAD_IS_PROXY_SCHEDULING(pad)    (GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_PROXY_SCHEDULING))

Check if the given pad is set to proxy scheduling queries, which means that the default query handler will forward scheduling queries to the internally linked pads instead of discarding them.

Parameters:

`pad` –

a GstPad

### GST_PAD_IS_SINK

    #define GST_PAD_IS_SINK(pad)		(GST_PAD_DIRECTION(pad) == GST_PAD_SINK)

Parameters:

`pad` –

a GstPad

Returns –

TRUE if the pad is a sink pad (i.e. consumes data).

### GST_PAD_IS_SRC

    #define GST_PAD_IS_SRC(pad)		(GST_PAD_DIRECTION(pad) == GST_PAD_SRC)

Parameters:

`pad` –

a GstPad

Returns –

TRUE if the pad is a source pad (i.e. produces data).

### GST_PAD_ITERINTLINKFUNC

    #define GST_PAD_ITERINTLINKFUNC(pad)    (GST_PAD_CAST(pad)->iterintlinkfunc)

Get the GstPadIterIntLinkFunction from the given pad.

Parameters:

`pad` –

a GstPad

### GST_PAD_LAST_FLOW_RETURN

    #define GST_PAD_LAST_FLOW_RETURN(pad)   (GST_PAD_CAST(pad)->ABI.abi.last_flowret)

Gets the last flow return on this pad

Parameters:

`pad` –

a GstPad

Since : 1.4

### GST_PAD_LINKFUNC

    #define GST_PAD_LINKFUNC(pad)		(GST_PAD_CAST(pad)->linkfunc)

Get the GstPadLinkFunction for the given pad.

Parameters:

`pad` –

a GstPad

### GST_PAD_LINK_FAILED

    #define GST_PAD_LINK_FAILED(ret) ((ret) < GST_PAD_LINK_OK)

Macro to test if the given GstPadLinkReturn value indicates a failed link step.

Parameters:

`ret` –

the GstPadLinkReturn value

### GST_PAD_LINK_SUCCESSFUL

    #define GST_PAD_LINK_SUCCESSFUL(ret) ((ret) >= GST_PAD_LINK_OK)

Macro to test if the given GstPadLinkReturn value indicates a successful link step.

Parameters:

`ret` –

the GstPadLinkReturn value

### GST_PAD_MODE

    #define GST_PAD_MODE(pad)	        (GST_PAD_CAST(pad)->mode)

Get the GstPadMode of pad, which will be GST_PAD_MODE_NONE if the pad has not been activated yet, and otherwise either GST_PAD_MODE_PUSH or GST_PAD_MODE_PULL depending on which mode the pad was activated in.

Parameters:

`pad` –

a GstPad

### GST_PAD_NAME

    #define GST_PAD_NAME(pad)		(GST_OBJECT_NAME(pad))

Get name of the given pad. No locking is performed in this function, use gst_pad_get_name instead.

Parameters:

`pad` –

a GstPad

### GST_PAD_NEEDS_PARENT

    #define GST_PAD_NEEDS_PARENT(pad)       (GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_NEED_PARENT))

Check if there is a parent object before calling into the pad callbacks. This is used internally by GStreamer.

Parameters:

`pad` –

a GstPad

### GST_PAD_NEEDS_RECONFIGURE

    #define GST_PAD_NEEDS_RECONFIGURE(pad)  (GST_OBJECT_FLAG_IS_SET (pad, GST_PAD_FLAG_NEED_RECONFIGURE))

Check if the pad should be reconfigured/renegotiated. The flag has to be unset manually after reconfiguration happened. Use gst_pad_needs_reconfigure or gst_pad_check_reconfigure instead.

Parameters:

`pad` –

a GstPad

### GST_PAD_PAD_TEMPLATE

    #define GST_PAD_PAD_TEMPLATE(pad)	(GST_PAD_CAST(pad)->padtemplate)

Get the pad GstPadTemplate. It describes the possible media types a pad or an element factory can handle.

Parameters:

`pad` –

a GstPad

### GST_PAD_PARENT

    #define GST_PAD_PARENT(pad)		(GST_ELEMENT_CAST(GST_OBJECT_PARENT(pad)))

Get the pad parent. No locking is performed in this function, use gst_pad_get_parent instead.

Parameters:

`pad` –

a GstPad

### GST_PAD_PEER

    #define GST_PAD_PEER(pad)		(GST_PAD_CAST(pad)->peer)

Return the pad's peer member. This member is a pointer to the linked pad. No locking is performed in this function, use gst_pad_get_peer instead.

Parameters:

`pad` –

a GstPad

### GST_PAD_PROBE_INFO_BUFFER

    #define GST_PAD_PROBE_INFO_BUFFER(d)       GST_BUFFER_CAST(GST_PAD_PROBE_INFO_DATA(d))

### GST_PAD_PROBE_INFO_BUFFER_LIST

    #define GST_PAD_PROBE_INFO_BUFFER_LIST(d)  GST_BUFFER_LIST_CAST(GST_PAD_PROBE_INFO_DATA(d))

### GST_PAD_PROBE_INFO_DATA

    #define GST_PAD_PROBE_INFO_DATA(d)         ((d)->data)

### GST_PAD_PROBE_INFO_EVENT

    #define GST_PAD_PROBE_INFO_EVENT(d)        GST_EVENT_CAST(GST_PAD_PROBE_INFO_DATA(d))

### GST_PAD_PROBE_INFO_FLOW_RETURN

    #define GST_PAD_PROBE_INFO_FLOW_RETURN(d)  ((d)->ABI.abi.flow_ret)

### GST_PAD_PROBE_INFO_ID

    #define GST_PAD_PROBE_INFO_ID(d)           ((d)->id)

### GST_PAD_PROBE_INFO_OFFSET

    #define GST_PAD_PROBE_INFO_OFFSET(d)       ((d)->offset)

### GST_PAD_PROBE_INFO_QUERY

    #define GST_PAD_PROBE_INFO_QUERY(d)        GST_QUERY_CAST(GST_PAD_PROBE_INFO_DATA(d))

### GST_PAD_PROBE_INFO_SIZE

    #define GST_PAD_PROBE_INFO_SIZE(d)         ((d)->size)

### GST_PAD_PROBE_INFO_TYPE

    #define GST_PAD_PROBE_INFO_TYPE(d)         ((d)->type)

### GST_PAD_QUERYFUNC

    #define GST_PAD_QUERYFUNC(pad)		(GST_PAD_CAST(pad)->queryfunc)

Get the GstPadQueryFunction from pad, which is the function that handles queries on the pad. You can use this to set your own query handling function on a pad after you create it. If your element derives from a base class, use the base class's virtual functions instead.

Parameters:

`pad` –

a GstPad

### GST_PAD_SET_ACCEPT_INTERSECT

    #define GST_PAD_SET_ACCEPT_INTERSECT(pad)   (GST_OBJECT_FLAG_SET (pad, GST_PAD_FLAG_ACCEPT_INTERSECT))

Set pad to by default accept caps by intersecting the result instead of checking for a subset. This is interesting for parser elements that can accept incompletely specified caps.

Parameters:

`pad` –

a GstPad

### GST_PAD_SET_ACCEPT_TEMPLATE

    #define GST_PAD_SET_ACCEPT_TEMPLATE(pad)   (GST_OBJECT_FLAG_SET (pad, GST_PAD_FLAG_ACCEPT_TEMPLATE))

Set pad to by default use the pad template caps to compare with the accept caps instead of using a caps query result.

Parameters:

`pad` –

a GstPad

Since : 1.6

### GST_PAD_SET_FLUSHING

    #define GST_PAD_SET_FLUSHING(pad)	(GST_OBJECT_FLAG_SET (pad, GST_PAD_FLAG_FLUSHING))

Set the given pad to flushing state, which means it will not accept any more events, queries or buffers, and return GST_FLOW_FLUSHING if any buffers are pushed on it. This usually happens when the pad is shut down or when a flushing seek happens. This is used inside GStreamer when flush start/stop events pass through pads, or when an element state is changed and pads are activated or deactivated.

Parameters:

`pad` –

a GstPad

### GST_PAD_SET_PROXY_ALLOCATION

    #define GST_PAD_SET_PROXY_ALLOCATION(pad)   (GST_OBJECT_FLAG_SET (pad, GST_PAD_FLAG_PROXY_ALLOCATION))

Set pad to proxy allocation queries, which means that the default query handler will forward allocation queries to the internally linked pads instead of discarding them. Set this if the element always outputs data in the exact same format as it receives as input. This is just for convenience to avoid implementing some standard query handling code in an element.

Parameters:

`pad` –

a GstPad

### GST_PAD_SET_PROXY_CAPS

    #define GST_PAD_SET_PROXY_CAPS(pad)     (GST_OBJECT_FLAG_SET (pad, GST_PAD_FLAG_PROXY_CAPS))

Set pad to proxy caps, so that all caps-related events and queries are proxied down- or upstream to the other side of the element automatically. Set this if the element always outputs data in the exact same format as it receives as input. This is just for convenience to avoid implementing some standard event and query handling code in an element.

Parameters:

`pad` –

a GstPad

### GST_PAD_SET_PROXY_SCHEDULING

    #define GST_PAD_SET_PROXY_SCHEDULING(pad)   (GST_OBJECT_FLAG_SET (pad, GST_PAD_FLAG_PROXY_SCHEDULING))

Set pad to proxy scheduling queries, which means that the default query handler will forward scheduling queries to the internally linked pads instead of discarding them. You will usually want to handle scheduling queries explicitly if your element supports multiple scheduling modes.

Parameters:

`pad` –

a GstPad

### GST_PAD_STREAM_AUTO_LOCK

    #define GST_PAD_STREAM_AUTO_LOCK(pad, var) g_autoptr(GRecMutexLocker) G_GNUC_UNUSED var = g_rec_mutex_locker_new(GST_PAD_GET_STREAM_LOCK(pad))

Declare a GRecMutexLocker variable with g_autoptr and lock the pad. The recursive mutex will be unlocked automatically when leaving the scope.

    {
      GST_PAD_STREAM_AUTO_LOCK (pad, locker);

      gst_pad_push_event(pad, event1);
      if (cond) {
        // No need to unlock
        return;
      }

      // Unlock before end of scope
      g_clear_pointer (&locker, g_rec_mutex_locker_free);
      gst_pad_push_event(pad, event2);
    }

Parameters:

`pad` –

a GstPad

`var` –

a variable name to be declared

Since : 1.24.0

### GST_PAD_STREAM_LOCK

    #define GST_PAD_STREAM_LOCK(pad)        g_rec_mutex_lock(GST_PAD_GET_STREAM_LOCK(pad))

Take the pad's stream lock. The stream lock is recursive and will be taken when buffers or serialized downstream events are pushed on a pad.

Parameters:

`pad` –

a GstPad

### GST_PAD_STREAM_TRYLOCK

    #define GST_PAD_STREAM_TRYLOCK(pad)     g_rec_mutex_trylock(GST_PAD_GET_STREAM_LOCK(pad))

Try to take the pad's stream lock, and return TRUE if the lock could be taken, and otherwise FALSE.

Parameters:

`pad` –

a GstPad

### GST_PAD_STREAM_UNLOCK

    #define GST_PAD_STREAM_UNLOCK(pad)      g_rec_mutex_unlock(GST_PAD_GET_STREAM_LOCK(pad))

Release the pad's stream lock.

Parameters:

`pad` –

a GstPad

### GST_PAD_TASK

    #define GST_PAD_TASK(pad)		(GST_PAD_CAST(pad)->task)

Get the GstTask of pad. Accessor macro used by GStreamer. Use the gst_pad_start_task, gst_pad_stop_task and gst_pad_pause_task functions instead.

Parameters:

`pad` –

a GstPad

### GST_PAD_UNLINKFUNC

    #define GST_PAD_UNLINKFUNC(pad)		(GST_PAD_CAST(pad)->unlinkfunc)

Get the GstPadUnlinkFunction from the given pad.

Parameters:

`pad` –

a GstPad

### GST_PAD_UNSET_ACCEPT_INTERSECT

    #define GST_PAD_UNSET_ACCEPT_INTERSECT(pad) (GST_OBJECT_FLAG_UNSET (pad, GST_PAD_FLAG_ACCEPT_INTERSECT))

Unset accept intersect flag.

Parameters:

`pad` –

a GstPad

### GST_PAD_UNSET_ACCEPT_TEMPLATE

    #define GST_PAD_UNSET_ACCEPT_TEMPLATE(pad) (GST_OBJECT_FLAG_UNSET (pad, GST_PAD_FLAG_ACCEPT_TEMPLATE))

Unset accept template flag.

Parameters:

`pad` –

a GstPad

Since : 1.6

### GST_PAD_UNSET_FLUSHING

    #define GST_PAD_UNSET_FLUSHING(pad)	(GST_OBJECT_FLAG_UNSET (pad, GST_PAD_FLAG_FLUSHING))

Unset the flushing flag.

Parameters:

`pad` –

a GstPad

### GST_PAD_UNSET_PROXY_ALLOCATION

    #define GST_PAD_UNSET_PROXY_ALLOCATION(pad) (GST_OBJECT_FLAG_UNSET (pad, GST_PAD_FLAG_PROXY_ALLOCATION))

Unset proxy allocation flag.

Parameters:

`pad` –

a GstPad

### GST_PAD_UNSET_PROXY_CAPS

    #define GST_PAD_UNSET_PROXY_CAPS(pad)   (GST_OBJECT_FLAG_UNSET (pad, GST_PAD_FLAG_PROXY_CAPS))

Unset proxy caps flag.

Parameters:

`pad` –

a GstPad

### GST_PAD_UNSET_PROXY_SCHEDULING

    #define GST_PAD_UNSET_PROXY_SCHEDULING(pad) (GST_OBJECT_FLAG_UNSET (pad, GST_PAD_FLAG_PROXY_SCHEDULING))

Unset proxy scheduling flag.

Parameters:

`pad` –

a GstPad

### gst_pad_get_name

    #define gst_pad_get_name(pad) gst_object_get_name (GST_OBJECT_CAST (pad))

Get a copy of the name of the pad. g_free after usage.

MT safe.

Parameters:

`pad` –

the pad to get the name from

### gst_pad_get_parent

    #define gst_pad_get_parent(pad) gst_object_get_parent (GST_OBJECT_CAST (pad))

Get the parent of pad. This function increases the refcount of the parent object so you should gst_object_unref it after usage. Can return NULL if the pad did not have a parent.

MT safe.

Parameters:

`pad` –

the pad to get the parent of

Returns ( [nullable]) –

the parent

### gst_pad_set_activate_function

    #define gst_pad_set_activate_function(p,f)      gst_pad_set_activate_function_full((p),(f),NULL,NULL)

Calls gst_pad_set_activate_function_full with NULL for the user_data and notify.

Parameters:

`p` –

a GstPad.

`f` –

the GstPadActivateFunction to set.

### gst_pad_set_activatemode_function

    #define gst_pad_set_activatemode_function(p,f)  gst_pad_set_activatemode_function_full((p),(f),NULL,NULL)

Calls gst_pad_set_activatemode_function_full with NULL for the user_data and notify.

Parameters:

`p` –

a GstPad.

`f` –

the GstPadActivateModeFunction to set.

### gst_pad_set_chain_function

    #define gst_pad_set_chain_function(p,f)         gst_pad_set_chain_function_full((p),(f),NULL,NULL)

Calls gst_pad_set_chain_function_full with NULL for the user_data and notify.

Parameters:

`p` –

a sink GstPad.

`f` –

the GstPadChainFunction to set.

### gst_pad_set_chain_list_function

    #define gst_pad_set_chain_list_function(p,f)    gst_pad_set_chain_list_function_full((p),(f),NULL,NULL)

Calls gst_pad_set_chain_list_function_full with NULL for the user_data and notify.

Parameters:

`p` –

a sink GstPad.

`f` –

the GstPadChainListFunction to set.

### gst_pad_set_event_full_function

    #define gst_pad_set_event_full_function(p,f)    gst_pad_set_event_full_function_full((p),(f),NULL,NULL)

Calls gst_pad_set_event_full_function_full with NULL for the user_data and notify.

Parameters:

`p` –

a GstPad of either direction.

`f` –

the GstPadEventFullFunction to set.

### gst_pad_set_event_function

    #define gst_pad_set_event_function(p,f)         gst_pad_set_event_function_full((p),(f),NULL,NULL)

Calls gst_pad_set_event_function_full with NULL for the user_data and notify.

Parameters:

`p` –

a GstPad of either direction.

`f` –

the GstPadEventFunction to set.

### gst_pad_set_getrange_function

    #define gst_pad_set_getrange_function(p,f)      gst_pad_set_getrange_function_full((p),(f),NULL,NULL)

Calls gst_pad_set_getrange_function_full with NULL for the user_data and notify.

Parameters:

`p` –

a source GstPad.

`f` –

the GstPadGetRangeFunction to set.

### gst_pad_set_iterate_internal_links_function

    #define gst_pad_set_iterate_internal_links_function(p,f) gst_pad_set_iterate_internal_links_function_full((p),(f),NULL,NULL)

Calls gst_pad_set_iterate_internal_links_function_full with NULL for the user_data and notify.

Parameters:

`p` –

a GstPad of either direction.

`f` –

the GstPadIterIntLinkFunction to set.

### gst_pad_set_link_function

    #define gst_pad_set_link_function(p,f)          gst_pad_set_link_function_full((p),(f),NULL,NULL)

Calls gst_pad_set_link_function_full with NULL for the user_data and notify.

Parameters:

`p` –

a GstPad.

`f` –

the GstPadLinkFunction to set.

### gst_pad_set_query_function

    #define gst_pad_set_query_function(p,f)   gst_pad_set_query_function_full((p),(f),NULL,NULL)

Calls gst_pad_set_query_function_full with NULL for the user_data and notify.

Parameters:

`p` –

a GstPad of either direction.

`f` –

the GstPadQueryFunction to set.

### gst_pad_set_unlink_function

    #define gst_pad_set_unlink_function(p,f)        gst_pad_set_unlink_function_full((p),(f),NULL,NULL)

Calls gst_pad_set_unlink_function_full with NULL for the user_data and notify.

Parameters:

`p` –

a GstPad.

`f` –

the GstPadUnlinkFunction to set.

## Enumerations

### GstFlowReturn

The result of passing data to a pad.

Note that the custom return values should not be exposed outside of the element scope.

##### Members

`GST_FLOW_CUSTOM_SUCCESS_2` (102) –

Pre-defined custom success code.

`GST_FLOW_CUSTOM_SUCCESS_1` (101) –

Pre-defined custom success code (define your custom success code to this to avoid compiler warnings).

`GST_FLOW_CUSTOM_SUCCESS` (100) –

Elements can use values starting from this (and higher) to define custom success codes.

`GST_FLOW_OK` (0) –

Data passing was ok.

`GST_FLOW_NOT_LINKED` (-1) –

Pad is not linked.

`GST_FLOW_FLUSHING` (-2) –

Pad is flushing.

`GST_FLOW_EOS` (-3) –

Pad is EOS.

`GST_FLOW_NOT_NEGOTIATED` (-4) –

Pad is not negotiated.

`GST_FLOW_ERROR` (-5) –

Some (fatal) error occurred. Element generating this error should post an error message using GST_ELEMENT_ERROR with more details.

`GST_FLOW_NOT_SUPPORTED` (-6) –

This operation is not supported.

`GST_FLOW_CUSTOM_ERROR` (-100) –

Elements can use values starting from this (and lower) to define custom error codes.

`GST_FLOW_CUSTOM_ERROR_1` (-101) –

Pre-defined custom error code (define your custom error code to this to avoid compiler warnings).

`GST_FLOW_CUSTOM_ERROR_2` (-102) –

Pre-defined custom error code.

### Gst.FlowReturn

The result of passing data to a pad.

Note that the custom return values should not be exposed outside of the element scope.

##### Members

`Gst.FlowReturn.CUSTOM_SUCCESS_2` (102) –

Pre-defined custom success code.

`Gst.FlowReturn.CUSTOM_SUCCESS_1` (101) –

Pre-defined custom success code (define your custom success code to this to avoid compiler warnings).

`Gst.FlowReturn.CUSTOM_SUCCESS` (100) –

Elements can use values starting from this (and higher) to define custom success codes.

`Gst.FlowReturn.OK` (0) –

Data passing was ok.

`Gst.FlowReturn.NOT_LINKED` (-1) –

Pad is not linked.

`Gst.FlowReturn.FLUSHING` (-2) –

Pad is flushing.

`Gst.FlowReturn.EOS` (-3) –

Pad is EOS.

`Gst.FlowReturn.NOT_NEGOTIATED` (-4) –

Pad is not negotiated.

`Gst.FlowReturn.ERROR` (-5) –

Some (fatal) error occurred. Element generating this error should post an error message using GST_ELEMENT_ERROR (not introspectable) with more details.

`Gst.FlowReturn.NOT_SUPPORTED` (-6) –

This operation is not supported.

`Gst.FlowReturn.CUSTOM_ERROR` (-100) –

Elements can use values starting from this (and lower) to define custom error codes.

`Gst.FlowReturn.CUSTOM_ERROR_1` (-101) –

Pre-defined custom error code (define your custom error code to this to avoid compiler warnings).

`Gst.FlowReturn.CUSTOM_ERROR_2` (-102) –

Pre-defined custom error code.

### Gst.FlowReturn

The result of passing data to a pad.

Note that the custom return values should not be exposed outside of the element scope.

##### Members

`Gst.FlowReturn.CUSTOM_SUCCESS_2` (102) –

Pre-defined custom success code.

`Gst.FlowReturn.CUSTOM_SUCCESS_1` (101) –

Pre-defined custom success code (define your custom success code to this to avoid compiler warnings).

`Gst.FlowReturn.CUSTOM_SUCCESS` (100) –

Elements can use values starting from this (and higher) to define custom success codes.

`Gst.FlowReturn.OK` (0) –

Data passing was ok.

`Gst.FlowReturn.NOT_LINKED` (-1) –

Pad is not linked.

`Gst.FlowReturn.FLUSHING` (-2) –

Pad is flushing.

`Gst.FlowReturn.EOS` (-3) –

Pad is EOS.

`Gst.FlowReturn.NOT_NEGOTIATED` (-4) –

Pad is not negotiated.

`Gst.FlowReturn.ERROR` (-5) –

Some (fatal) error occurred. Element generating this error should post an error message using GST_ELEMENT_ERROR (not introspectable) with more details.

`Gst.FlowReturn.NOT_SUPPORTED` (-6) –

This operation is not supported.

`Gst.FlowReturn.CUSTOM_ERROR` (-100) –

Elements can use values starting from this (and lower) to define custom error codes.

`Gst.FlowReturn.CUSTOM_ERROR_1` (-101) –

Pre-defined custom error code (define your custom error code to this to avoid compiler warnings).

`Gst.FlowReturn.CUSTOM_ERROR_2` (-102) –

Pre-defined custom error code.

### GstPadDirection

The direction of a pad.

##### Members

`GST_PAD_UNKNOWN` (0) –

direction is unknown.

`GST_PAD_SRC` (1) –

the pad is a source pad.

`GST_PAD_SINK` (2) –

the pad is a sink pad.

### Gst.PadDirection

The direction of a pad.

##### Members

`Gst.PadDirection.UNKNOWN` (0) –

direction is unknown.

`Gst.PadDirection.SRC` (1) –

the pad is a source pad.

`Gst.PadDirection.SINK` (2) –

the pad is a sink pad.

### Gst.PadDirection

The direction of a pad.

##### Members

`Gst.PadDirection.UNKNOWN` (0) –

direction is unknown.

`Gst.PadDirection.SRC` (1) –

the pad is a source pad.

`Gst.PadDirection.SINK` (2) –

the pad is a sink pad.

### GstPadFlags

Pad state flags

##### Members

`GST_PAD_FLAG_BLOCKED` (16) –

is dataflow on a pad blocked

`GST_PAD_FLAG_FLUSHING` (32) –

is pad flushing

`GST_PAD_FLAG_EOS` (64) –

is pad in EOS state

`GST_PAD_FLAG_BLOCKING` (128) –

is pad currently blocking on a buffer or event

`GST_PAD_FLAG_NEED_PARENT` (256) –

ensure that there is a parent object before calling into the pad callbacks.

`GST_PAD_FLAG_NEED_RECONFIGURE` (512) –

the pad should be reconfigured/renegotiated. The flag has to be unset manually after reconfiguration happened.

`GST_PAD_FLAG_PENDING_EVENTS` (1024) –

the pad has pending events

`GST_PAD_FLAG_FIXED_CAPS` (2048) –

the pad is using fixed caps. This means that once the caps are set on the pad, the default caps query function will only return those caps.

`GST_PAD_FLAG_PROXY_CAPS` (4096) –

the default event and query handler will forward all events and queries to the internally linked pads instead of discarding them.

`GST_PAD_FLAG_PROXY_ALLOCATION` (8192) –

the default query handler will forward allocation queries to the internally linked pads instead of discarding them.

`GST_PAD_FLAG_PROXY_SCHEDULING` (16384) –

the default query handler will forward scheduling queries to the internally linked pads instead of discarding them.

`GST_PAD_FLAG_ACCEPT_INTERSECT` (32768) –

the default accept-caps handler will check it the caps intersect the query-caps result instead of checking for a subset. This is interesting for parsers that can accept incompletely specified caps.

`GST_PAD_FLAG_ACCEPT_TEMPLATE` (65536) –

the default accept-caps handler will use the template pad caps instead of query caps to compare with the accept caps. Use this in combination with GST_PAD_FLAG_ACCEPT_INTERSECT. (Since: 1.6)

`GST_PAD_FLAG_LAST` (1048576) –

offset to define more flags

### Gst.PadFlags

Pad state flags

##### Members

`Gst.PadFlags.BLOCKED` (16) –

is dataflow on a pad blocked

`Gst.PadFlags.FLUSHING` (32) –

is pad flushing

`Gst.PadFlags.EOS` (64) –

is pad in EOS state

`Gst.PadFlags.BLOCKING` (128) –

is pad currently blocking on a buffer or event

`Gst.PadFlags.NEED_PARENT` (256) –

ensure that there is a parent object before calling into the pad callbacks.

`Gst.PadFlags.NEED_RECONFIGURE` (512) –

the pad should be reconfigured/renegotiated. The flag has to be unset manually after reconfiguration happened.

`Gst.PadFlags.PENDING_EVENTS` (1024) –

the pad has pending events

`Gst.PadFlags.FIXED_CAPS` (2048) –

the pad is using fixed caps. This means that once the caps are set on the pad, the default caps query function will only return those caps.

`Gst.PadFlags.PROXY_CAPS` (4096) –

the default event and query handler will forward all events and queries to the internally linked pads instead of discarding them.

`Gst.PadFlags.PROXY_ALLOCATION` (8192) –

the default query handler will forward allocation queries to the internally linked pads instead of discarding them.

`Gst.PadFlags.PROXY_SCHEDULING` (16384) –

the default query handler will forward scheduling queries to the internally linked pads instead of discarding them.

`Gst.PadFlags.ACCEPT_INTERSECT` (32768) –

the default accept-caps handler will check it the caps intersect the query-caps result instead of checking for a subset. This is interesting for parsers that can accept incompletely specified caps.

`Gst.PadFlags.ACCEPT_TEMPLATE` (65536) –

the default accept-caps handler will use the template pad caps instead of query caps to compare with the accept caps. Use this in combination with Gst.PadFlags.ACCEPT_INTERSECT. (Since: 1.6)

`Gst.PadFlags.LAST` (1048576) –

offset to define more flags

### Gst.PadFlags

Pad state flags

##### Members

`Gst.PadFlags.BLOCKED` (16) –

is dataflow on a pad blocked

`Gst.PadFlags.FLUSHING` (32) –

is pad flushing

`Gst.PadFlags.EOS` (64) –

is pad in EOS state

`Gst.PadFlags.BLOCKING` (128) –

is pad currently blocking on a buffer or event

`Gst.PadFlags.NEED_PARENT` (256) –

ensure that there is a parent object before calling into the pad callbacks.

`Gst.PadFlags.NEED_RECONFIGURE` (512) –

the pad should be reconfigured/renegotiated. The flag has to be unset manually after reconfiguration happened.

`Gst.PadFlags.PENDING_EVENTS` (1024) –

the pad has pending events

`Gst.PadFlags.FIXED_CAPS` (2048) –

the pad is using fixed caps. This means that once the caps are set on the pad, the default caps query function will only return those caps.

`Gst.PadFlags.PROXY_CAPS` (4096) –

the default event and query handler will forward all events and queries to the internally linked pads instead of discarding them.

`Gst.PadFlags.PROXY_ALLOCATION` (8192) –

the default query handler will forward allocation queries to the internally linked pads instead of discarding them.

`Gst.PadFlags.PROXY_SCHEDULING` (16384) –

the default query handler will forward scheduling queries to the internally linked pads instead of discarding them.

`Gst.PadFlags.ACCEPT_INTERSECT` (32768) –

the default accept-caps handler will check it the caps intersect the query-caps result instead of checking for a subset. This is interesting for parsers that can accept incompletely specified caps.

`Gst.PadFlags.ACCEPT_TEMPLATE` (65536) –

the default accept-caps handler will use the template pad caps instead of query caps to compare with the accept caps. Use this in combination with Gst.PadFlags.ACCEPT_INTERSECT. (Since: 1.6)

`Gst.PadFlags.LAST` (1048576) –

offset to define more flags

### GstPadLinkCheck

The amount of checking to be done when linking pads. GST_PAD_LINK_CHECK_CAPS and GST_PAD_LINK_CHECK_TEMPLATE_CAPS are mutually exclusive. If both are specified, expensive but safe GST_PAD_LINK_CHECK_CAPS are performed.

> Only disable some of the checks if you are 100% certain you know the link will not fail because of hierarchy/caps compatibility failures. If uncertain, use the default checks (%GST_PAD_LINK_CHECK_DEFAULT) or the regular methods for linking the pads.

##### Members

`GST_PAD_LINK_CHECK_NOTHING` (0) –

Don't check hierarchy or caps compatibility.

`GST_PAD_LINK_CHECK_HIERARCHY` (1) –

Check the pads have same parents/grandparents. Could be omitted if it is already known that the two elements that own the pads are in the same bin.

`GST_PAD_LINK_CHECK_TEMPLATE_CAPS` (2) –

Check if the pads are compatible by using their template caps. This is much faster than GST_PAD_LINK_CHECK_CAPS, but would be unsafe e.g. if one pad has GST_CAPS_ANY.

`GST_PAD_LINK_CHECK_CAPS` (4) –

Check if the pads are compatible by comparing the caps returned by gst_pad_query_caps.

`GST_PAD_LINK_CHECK_NO_RECONFIGURE` (8) –

Disables pushing a reconfigure event when pads are linked.

`GST_PAD_LINK_CHECK_DEFAULT` (5) –

The default checks done when linking pads (i.e. the ones used by gst_pad_link).

### Gst.PadLinkCheck

The amount of checking to be done when linking pads. GST_PAD_LINK_CHECK_CAPS and GST_PAD_LINK_CHECK_TEMPLATE_CAPS are mutually exclusive. If both are specified, expensive but safe GST_PAD_LINK_CHECK_CAPS are performed.

> Only disable some of the checks if you are 100% certain you know the link will not fail because of hierarchy/caps compatibility failures. If uncertain, use the default checks (%GST_PAD_LINK_CHECK_DEFAULT) or the regular methods for linking the pads.

##### Members

`Gst.PadLinkCheck.NOTHING` (0) –

Don't check hierarchy or caps compatibility.

`Gst.PadLinkCheck.HIERARCHY` (1) –

Check the pads have same parents/grandparents. Could be omitted if it is already known that the two elements that own the pads are in the same bin.

`Gst.PadLinkCheck.TEMPLATE_CAPS` (2) –

Check if the pads are compatible by using their template caps. This is much faster than GST_PAD_LINK_CHECK_CAPS, but would be unsafe e.g. if one pad has GST_CAPS_ANY (not introspectable).

`Gst.PadLinkCheck.CAPS` (4) –

Check if the pads are compatible by comparing the caps returned by Gst.Pad.prototype.query_caps.

`Gst.PadLinkCheck.NO_RECONFIGURE` (8) –

Disables pushing a reconfigure event when pads are linked.

`Gst.PadLinkCheck.DEFAULT` (5) –

The default checks done when linking pads (i.e. the ones used by Gst.Pad.prototype.link).

### Gst.PadLinkCheck

The amount of checking to be done when linking pads. GST_PAD_LINK_CHECK_CAPS and GST_PAD_LINK_CHECK_TEMPLATE_CAPS are mutually exclusive. If both are specified, expensive but safe GST_PAD_LINK_CHECK_CAPS are performed.

> Only disable some of the checks if you are 100% certain you know the link will not fail because of hierarchy/caps compatibility failures. If uncertain, use the default checks (%GST_PAD_LINK_CHECK_DEFAULT) or the regular methods for linking the pads.

##### Members

`Gst.PadLinkCheck.NOTHING` (0) –

Don't check hierarchy or caps compatibility.

`Gst.PadLinkCheck.HIERARCHY` (1) –

Check the pads have same parents/grandparents. Could be omitted if it is already known that the two elements that own the pads are in the same bin.

`Gst.PadLinkCheck.TEMPLATE_CAPS` (2) –

Check if the pads are compatible by using their template caps. This is much faster than GST_PAD_LINK_CHECK_CAPS, but would be unsafe e.g. if one pad has GST_CAPS_ANY (not introspectable).

`Gst.PadLinkCheck.CAPS` (4) –

Check if the pads are compatible by comparing the caps returned by Gst.Pad.query_caps.

`Gst.PadLinkCheck.NO_RECONFIGURE` (8) –

Disables pushing a reconfigure event when pads are linked.

`Gst.PadLinkCheck.DEFAULT` (5) –

The default checks done when linking pads (i.e. the ones used by Gst.Pad.link).

### GstPadLinkReturn

Result values from gst_pad_link and friends.

##### Members

`GST_PAD_LINK_OK` (0) –

link succeeded

`GST_PAD_LINK_WRONG_HIERARCHY` (-1) –

pads have no common grandparent

`GST_PAD_LINK_WAS_LINKED` (-2) –

pad was already linked

`GST_PAD_LINK_WRONG_DIRECTION` (-3) –

pads have wrong direction

`GST_PAD_LINK_NOFORMAT` (-4) –

pads do not have common format

`GST_PAD_LINK_NOSCHED` (-5) –

pads cannot cooperate in scheduling

`GST_PAD_LINK_REFUSED` (-6) –

refused for some reason

### Gst.PadLinkReturn

Result values from gst_pad_link and friends.

##### Members

`Gst.PadLinkReturn.OK` (0) –

link succeeded

`Gst.PadLinkReturn.WRONG_HIERARCHY` (-1) –

pads have no common grandparent

`Gst.PadLinkReturn.WAS_LINKED` (-2) –

pad was already linked

`Gst.PadLinkReturn.WRONG_DIRECTION` (-3) –

pads have wrong direction

`Gst.PadLinkReturn.NOFORMAT` (-4) –

pads do not have common format

`Gst.PadLinkReturn.NOSCHED` (-5) –

pads cannot cooperate in scheduling

`Gst.PadLinkReturn.REFUSED` (-6) –

refused for some reason

### Gst.PadLinkReturn

Result values from gst_pad_link and friends.

##### Members

`Gst.PadLinkReturn.OK` (0) –

link succeeded

`Gst.PadLinkReturn.WRONG_HIERARCHY` (-1) –

pads have no common grandparent

`Gst.PadLinkReturn.WAS_LINKED` (-2) –

pad was already linked

`Gst.PadLinkReturn.WRONG_DIRECTION` (-3) –

pads have wrong direction

`Gst.PadLinkReturn.NOFORMAT` (-4) –

pads do not have common format

`Gst.PadLinkReturn.NOSCHED` (-5) –

pads cannot cooperate in scheduling

`Gst.PadLinkReturn.REFUSED` (-6) –

refused for some reason

### GstPadMode

The status of a GstPad. After activating a pad, which usually happens when the parent element goes from READY to PAUSED, the GstPadMode defines if the pad operates in push or pull mode.

##### Members

`GST_PAD_MODE_NONE` (0) –

Pad will not handle dataflow

`GST_PAD_MODE_PUSH` (1) –

Pad handles dataflow in downstream push mode

`GST_PAD_MODE_PULL` (2) –

Pad handles dataflow in upstream pull mode

### Gst.PadMode

The status of a GstPad. After activating a pad, which usually happens when the parent element goes from READY to PAUSED, the GstPadMode defines if the pad operates in push or pull mode.

##### Members

`Gst.PadMode.NONE` (0) –

Pad will not handle dataflow

`Gst.PadMode.PUSH` (1) –

Pad handles dataflow in downstream push mode

`Gst.PadMode.PULL` (2) –

Pad handles dataflow in upstream pull mode

### Gst.PadMode

The status of a GstPad. After activating a pad, which usually happens when the parent element goes from READY to PAUSED, the GstPadMode defines if the pad operates in push or pull mode.

##### Members

`Gst.PadMode.NONE` (0) –

Pad will not handle dataflow

`Gst.PadMode.PUSH` (1) –

Pad handles dataflow in downstream push mode

`Gst.PadMode.PULL` (2) –

Pad handles dataflow in upstream pull mode

### GstPadProbeReturn

Different return values for the GstPadProbeCallback.

##### Members

`GST_PAD_PROBE_DROP` (0) –

drop data in data probes. For push mode this means that the data item is not sent downstream. For pull mode, it means that the data item is not passed upstream. In both cases, no other probes are called for this item and GST_FLOW_OK or TRUE is returned to the caller.

`GST_PAD_PROBE_OK` (1) –

normal probe return value. This leaves the probe in place, and defers decisions about dropping or passing data to other probes, if any. If there are no other probes, the default behaviour for the probe type applies ('block' for blocking probes, and 'pass' for non-blocking probes).

`GST_PAD_PROBE_REMOVE` (2) –

remove this probe, passing the data. For blocking probes this will cause data flow to unblock, unless there are also other blocking probes installed.

`GST_PAD_PROBE_PASS` (3) –

pass the data item in the block probe and block on the next item. Note, that if there are multiple pad probes installed and any probe returns PASS, the data will be passed.

`GST_PAD_PROBE_HANDLED` (4) –

Data has been handled in the probe and will not be forwarded further. For events and buffers this is the same behaviour as GST_PAD_PROBE_DROP (except that in this case you need to unref the buffer or event yourself). For queries it will also return TRUE to the caller. The probe can also modify the GstFlowReturn value by using the GST_PAD_PROBE_INFO_FLOW_RETURN() accessor. Note that the resulting query must contain valid entries. Since: 1.6

### Gst.PadProbeReturn

Different return values for the Gst.PadProbeCallback.

##### Members

`Gst.PadProbeReturn.DROP` (0) –

drop data in data probes. For push mode this means that the data item is not sent downstream. For pull mode, it means that the data item is not passed upstream. In both cases, no other probes are called for this item and Gst.FlowReturn.OK or true is returned to the caller.

`Gst.PadProbeReturn.OK` (1) –

normal probe return value. This leaves the probe in place, and defers decisions about dropping or passing data to other probes, if any. If there are no other probes, the default behaviour for the probe type applies ('block' for blocking probes, and 'pass' for non-blocking probes).

`Gst.PadProbeReturn.REMOVE` (2) –

remove this probe, passing the data. For blocking probes this will cause data flow to unblock, unless there are also other blocking probes installed.

`Gst.PadProbeReturn.PASS` (3) –

pass the data item in the block probe and block on the next item. Note, that if there are multiple pad probes installed and any probe returns PASS, the data will be passed.

`Gst.PadProbeReturn.HANDLED` (4) –

Data has been handled in the probe and will not be forwarded further. For events and buffers this is the same behaviour as Gst.PadProbeReturn.DROP (except that in this case you need to unref the buffer or event yourself). For queries it will also return true to the caller. The probe can also modify the Gst.FlowReturn value by using the GST_PAD_PROBE_INFO_FLOW_RETURN (not introspectable)() accessor. Note that the resulting query must contain valid entries. Since: 1.6

### Gst.PadProbeReturn

Different return values for the Gst.PadProbeCallback.

##### Members

`Gst.PadProbeReturn.DROP` (0) –

drop data in data probes. For push mode this means that the data item is not sent downstream. For pull mode, it means that the data item is not passed upstream. In both cases, no other probes are called for this item and Gst.FlowReturn.OK or True is returned to the caller.

`Gst.PadProbeReturn.OK` (1) –

normal probe return value. This leaves the probe in place, and defers decisions about dropping or passing data to other probes, if any. If there are no other probes, the default behaviour for the probe type applies ('block' for blocking probes, and 'pass' for non-blocking probes).

`Gst.PadProbeReturn.REMOVE` (2) –

remove this probe, passing the data. For blocking probes this will cause data flow to unblock, unless there are also other blocking probes installed.

`Gst.PadProbeReturn.PASS` (3) –

pass the data item in the block probe and block on the next item. Note, that if there are multiple pad probes installed and any probe returns PASS, the data will be passed.

`Gst.PadProbeReturn.HANDLED` (4) –

Data has been handled in the probe and will not be forwarded further. For events and buffers this is the same behaviour as Gst.PadProbeReturn.DROP (except that in this case you need to unref the buffer or event yourself). For queries it will also return True to the caller. The probe can also modify the Gst.FlowReturn value by using the GST_PAD_PROBE_INFO_FLOW_RETURN (not introspectable)() accessor. Note that the resulting query must contain valid entries. Since: 1.6

### GstPadProbeType

The different probing types that can occur. When either one of GST_PAD_PROBE_TYPE_IDLE or GST_PAD_PROBE_TYPE_BLOCK is used, the probe will be a blocking probe.

##### Members

`GST_PAD_PROBE_TYPE_INVALID` (0) –

invalid probe type

`GST_PAD_PROBE_TYPE_IDLE` (1) –

probe idle pads and block while the callback is called

`GST_PAD_PROBE_TYPE_BLOCK` (2) –

probe and block pads

`GST_PAD_PROBE_TYPE_BUFFER` (16) –

probe buffers

`GST_PAD_PROBE_TYPE_BUFFER_LIST` (32) –

probe buffer lists

`GST_PAD_PROBE_TYPE_EVENT_DOWNSTREAM` (64) –

probe downstream events

`GST_PAD_PROBE_TYPE_EVENT_UPSTREAM` (128) –

probe upstream events

`GST_PAD_PROBE_TYPE_EVENT_FLUSH` (256) –

probe flush events. This probe has to be explicitly enabled and is not included in the @GST_PAD_PROBE_TYPE_EVENT_DOWNSTREAM or @GST_PAD_PROBE_TYPE_EVENT_UPSTREAM probe types.

`GST_PAD_PROBE_TYPE_QUERY_DOWNSTREAM` (512) –

probe downstream queries

`GST_PAD_PROBE_TYPE_QUERY_UPSTREAM` (1024) –

probe upstream queries

`GST_PAD_PROBE_TYPE_PUSH` (4096) –

probe push

`GST_PAD_PROBE_TYPE_PULL` (8192) –

probe pull

`GST_PAD_PROBE_TYPE_BLOCKING` (3) –

probe and block at the next opportunity, at data flow or when idle

`GST_PAD_PROBE_TYPE_DATA_DOWNSTREAM` (112) –

probe downstream data (buffers, buffer lists, and events)

`GST_PAD_PROBE_TYPE_DATA_UPSTREAM` (128) –

probe upstream data (events)

`GST_PAD_PROBE_TYPE_DATA_BOTH` (240) –

probe upstream and downstream data (buffers, buffer lists, and events)

`GST_PAD_PROBE_TYPE_BLOCK_DOWNSTREAM` (114) –

probe and block downstream data (buffers, buffer lists, and events)

`GST_PAD_PROBE_TYPE_BLOCK_UPSTREAM` (130) –

probe and block upstream data (events)

`GST_PAD_PROBE_TYPE_EVENT_BOTH` (192) –

probe upstream and downstream events

`GST_PAD_PROBE_TYPE_QUERY_BOTH` (1536) –

probe upstream and downstream queries

`GST_PAD_PROBE_TYPE_ALL_BOTH` (1776) –

probe upstream events and queries and downstream buffers, buffer lists, events and queries

`GST_PAD_PROBE_TYPE_SCHEDULING` (12288) –

probe push and pull

### Gst.PadProbeType

The different probing types that can occur. When either one of GST_PAD_PROBE_TYPE_IDLE or GST_PAD_PROBE_TYPE_BLOCK is used, the probe will be a blocking probe.

##### Members

`Gst.PadProbeType.INVALID` (0) –

invalid probe type

`Gst.PadProbeType.IDLE` (1) –

probe idle pads and block while the callback is called

`Gst.PadProbeType.BLOCK` (2) –

probe and block pads

`Gst.PadProbeType.BUFFER` (16) –

probe buffers

`Gst.PadProbeType.BUFFER_LIST` (32) –

probe buffer lists

`Gst.PadProbeType.EVENT_DOWNSTREAM` (64) –

probe downstream events

`Gst.PadProbeType.EVENT_UPSTREAM` (128) –

probe upstream events

`Gst.PadProbeType.EVENT_FLUSH` (256) –

probe flush events. This probe has to be explicitly enabled and is not included in the @GST_PAD_PROBE_TYPE_EVENT_DOWNSTREAM or @GST_PAD_PROBE_TYPE_EVENT_UPSTREAM probe types.

`Gst.PadProbeType.QUERY_DOWNSTREAM` (512) –

probe downstream queries

`Gst.PadProbeType.QUERY_UPSTREAM` (1024) –

probe upstream queries

`Gst.PadProbeType.PUSH` (4096) –

probe push

`Gst.PadProbeType.PULL` (8192) –

probe pull

`Gst.PadProbeType.BLOCKING` (3) –

probe and block at the next opportunity, at data flow or when idle

`Gst.PadProbeType.DATA_DOWNSTREAM` (112) –

probe downstream data (buffers, buffer lists, and events)

`Gst.PadProbeType.DATA_UPSTREAM` (128) –

probe upstream data (events)

`Gst.PadProbeType.DATA_BOTH` (240) –

probe upstream and downstream data (buffers, buffer lists, and events)

`Gst.PadProbeType.BLOCK_DOWNSTREAM` (114) –

probe and block downstream data (buffers, buffer lists, and events)

`Gst.PadProbeType.BLOCK_UPSTREAM` (130) –

probe and block upstream data (events)

`Gst.PadProbeType.EVENT_BOTH` (192) –

probe upstream and downstream events

`Gst.PadProbeType.QUERY_BOTH` (1536) –

probe upstream and downstream queries

`Gst.PadProbeType.ALL_BOTH` (1776) –

probe upstream events and queries and downstream buffers, buffer lists, events and queries

`Gst.PadProbeType.SCHEDULING` (12288) –

probe push and pull

### Gst.PadProbeType

The different probing types that can occur. When either one of GST_PAD_PROBE_TYPE_IDLE or GST_PAD_PROBE_TYPE_BLOCK is used, the probe will be a blocking probe.

##### Members

`Gst.PadProbeType.INVALID` (0) –

invalid probe type

`Gst.PadProbeType.IDLE` (1) –

probe idle pads and block while the callback is called

`Gst.PadProbeType.BLOCK` (2) –

probe and block pads

`Gst.PadProbeType.BUFFER` (16) –

probe buffers

`Gst.PadProbeType.BUFFER_LIST` (32) –

probe buffer lists

`Gst.PadProbeType.EVENT_DOWNSTREAM` (64) –

probe downstream events

`Gst.PadProbeType.EVENT_UPSTREAM` (128) –

probe upstream events

`Gst.PadProbeType.EVENT_FLUSH` (256) –

probe flush events. This probe has to be explicitly enabled and is not included in the @GST_PAD_PROBE_TYPE_EVENT_DOWNSTREAM or @GST_PAD_PROBE_TYPE_EVENT_UPSTREAM probe types.

`Gst.PadProbeType.QUERY_DOWNSTREAM` (512) –

probe downstream queries

`Gst.PadProbeType.QUERY_UPSTREAM` (1024) –

probe upstream queries

`Gst.PadProbeType.PUSH` (4096) –

probe push

`Gst.PadProbeType.PULL` (8192) –

probe pull

`Gst.PadProbeType.BLOCKING` (3) –

probe and block at the next opportunity, at data flow or when idle

`Gst.PadProbeType.DATA_DOWNSTREAM` (112) –

probe downstream data (buffers, buffer lists, and events)

`Gst.PadProbeType.DATA_UPSTREAM` (128) –

probe upstream data (events)

`Gst.PadProbeType.DATA_BOTH` (240) –

probe upstream and downstream data (buffers, buffer lists, and events)

`Gst.PadProbeType.BLOCK_DOWNSTREAM` (114) –

probe and block downstream data (buffers, buffer lists, and events)

`Gst.PadProbeType.BLOCK_UPSTREAM` (130) –

probe and block upstream data (events)

`Gst.PadProbeType.EVENT_BOTH` (192) –

probe upstream and downstream events

`Gst.PadProbeType.QUERY_BOTH` (1536) –

probe upstream and downstream queries

`Gst.PadProbeType.ALL_BOTH` (1776) –

probe upstream events and queries and downstream buffers, buffer lists, events and queries

`Gst.PadProbeType.SCHEDULING` (12288) –

probe push and pull

## Callbacks

### GstPadActivateFunction

    gboolean
    (*GstPadActivateFunction) (GstPad * pad,
                               GstObject * parent)

This function is called when the pad is activated during the element READY to PAUSED state change. By default this function will call the activate function that puts the pad in push mode but elements can override this function to activate the pad in pull mode if they wish.

Parameters:

`pad` –

a GstPad

`parent` –

the parent of pad

Returns –

TRUE if the pad could be activated.

### Gst.PadActivateFunction

    function Gst.PadActivateFunction(pad: Gst.Pad, parent: Gst.Object): {
        // javascript wrapper for 'GstPadActivateFunction'
    }

This function is called when the pad is activated during the element READY to PAUSED state change. By default this function will call the activate function that puts the pad in push mode but elements can override this function to activate the pad in pull mode if they wish.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad

`parent` (Gst.Object) –

the parent of pad

Returns (Number) –

true if the pad could be activated.

### Gst.PadActivateFunction

    def Gst.PadActivateFunction (pad, parent):
        #python wrapper for 'GstPadActivateFunction'

This function is called when the pad is activated during the element READY to PAUSED state change. By default this function will call the activate function that puts the pad in push mode but elements can override this function to activate the pad in pull mode if they wish.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad

`parent` (Gst.Object) –

the parent of pad

Returns (bool) –

True if the pad could be activated.

### GstPadActivateModeFunction

    gboolean
    (*GstPadActivateModeFunction) (GstPad * pad,
                                   GstObject * parent,
                                   GstPadMode mode,
                                   gboolean active)

The prototype of the push and pull activate functions.

Parameters:

`pad` –

a GstPad

`parent` –

the parent of pad

`mode` –

the requested activation mode of pad

`active` –

activate or deactivate the pad.

Returns –

TRUE if the pad could be activated or deactivated.

### Gst.PadActivateModeFunction

    function Gst.PadActivateModeFunction(pad: Gst.Pad, parent: Gst.Object, mode: Gst.PadMode, active: Number): {
        // javascript wrapper for 'GstPadActivateModeFunction'
    }

The prototype of the push and pull activate functions.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad

`parent` (Gst.Object) –

the parent of pad

`mode` (Gst.PadMode) –

the requested activation mode of pad

`active` (Number) –

activate or deactivate the pad.

Returns (Number) –

true if the pad could be activated or deactivated.

### Gst.PadActivateModeFunction

    def Gst.PadActivateModeFunction (pad, parent, mode, active):
        #python wrapper for 'GstPadActivateModeFunction'

The prototype of the push and pull activate functions.

Parameters:

`pad` (Gst.Pad) –

a Gst.Pad

`parent` (Gst.Object) –

the parent of pad

`mode` (Gst.PadMode) –

the requested activation mode of pad

`active` (bool) –

activate or deactivate the pad.

Returns (bool) –

True if the pad could be activated or deactivated.

### GstPadChainFunction

    GstFlowReturn
    (*GstPadChainFunction) (GstPad * pad,
                            GstObject * parent,
                            GstBuffer * buffer)

A function that will be called on sinkpads when chaining buffers. The function typically processes the data contained in the buffer and either consumes the data or passes it on to the internally linked pad(s).

The implementer of this function receives a refcount to buffer and should gst_buffer_unref when the buffer is no longer needed.

When a chain function detects an error in the data stream, it must post an error on the bus and return an appropriate GstFlowReturn value.

Parameters:

`pad` –

the sink GstPad that performed the chain.

`parent` ( [nullable]) –

the parent of pad. If the GST_PAD_FLAG_NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`buffer` ( [transfer: full]) –

the GstBuffer that is chained, not NULL.

Returns –

GST_FLOW_OK for success

### Gst.PadChainFunction

    function Gst.PadChainFunction(pad: Gst.Pad, parent: Gst.Object, buffer: Gst.Buffer): {
        // javascript wrapper for 'GstPadChainFunction'
    }

A function that will be called on sinkpads when chaining buffers. The function typically processes the data contained in the buffer and either consumes the data or passes it on to the internally linked pad(s).

The implementer of this function receives a refcount to buffer and should gst_buffer_unref (not introspectable) when the buffer is no longer needed.

When a chain function detects an error in the data stream, it must post an error on the bus and return an appropriate Gst.FlowReturn value.

Parameters:

`pad` (Gst.Pad) –

the sink Gst.Pad that performed the chain.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`buffer` (Gst.Buffer) –

the Gst.Buffer that is chained, not null.

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK for success

### Gst.PadChainFunction

    def Gst.PadChainFunction (pad, parent, buffer):
        #python wrapper for 'GstPadChainFunction'

A function that will be called on sinkpads when chaining buffers. The function typically processes the data contained in the buffer and either consumes the data or passes it on to the internally linked pad(s).

The implementer of this function receives a refcount to buffer and should gst_buffer_unref (not introspectable) when the buffer is no longer needed.

When a chain function detects an error in the data stream, it must post an error on the bus and return an appropriate Gst.FlowReturn value.

Parameters:

`pad` (Gst.Pad) –

the sink Gst.Pad that performed the chain.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`buffer` (Gst.Buffer) –

the Gst.Buffer that is chained, not None.

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK for success

### GstPadChainListFunction

    GstFlowReturn
    (*GstPadChainListFunction) (GstPad * pad,
                                GstObject * parent,
                                GstBufferList * list)

A function that will be called on sinkpads when chaining buffer lists. The function typically processes the data contained in the buffer list and either consumes the data or passes it on to the internally linked pad(s).

The implementer of this function receives a refcount to list and should gst_buffer_list_unref when the list is no longer needed.

When a chainlist function detects an error in the data stream, it must post an error on the bus and return an appropriate GstFlowReturn value.

Parameters:

`pad` –

the sink GstPad that performed the chain.

`parent` ( [nullable]) –

the parent of pad. If the GST_PAD_FLAG_NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`list` ( [transfer: full]) –

the GstBufferList that is chained, not NULL.

Returns –

GST_FLOW_OK for success

### Gst.PadChainListFunction

    function Gst.PadChainListFunction(pad: Gst.Pad, parent: Gst.Object, list: Gst.BufferList): {
        // javascript wrapper for 'GstPadChainListFunction'
    }

A function that will be called on sinkpads when chaining buffer lists. The function typically processes the data contained in the buffer list and either consumes the data or passes it on to the internally linked pad(s).

The implementer of this function receives a refcount to list and should gst_buffer_list_unref (not introspectable) when the list is no longer needed.

When a chainlist function detects an error in the data stream, it must post an error on the bus and return an appropriate Gst.FlowReturn value.

Parameters:

`pad` (Gst.Pad) –

the sink Gst.Pad that performed the chain.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`list` (Gst.BufferList) –

the Gst.BufferList that is chained, not null.

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK for success

### Gst.PadChainListFunction

    def Gst.PadChainListFunction (pad, parent, list):
        #python wrapper for 'GstPadChainListFunction'

A function that will be called on sinkpads when chaining buffer lists. The function typically processes the data contained in the buffer list and either consumes the data or passes it on to the internally linked pad(s).

The implementer of this function receives a refcount to list and should gst_buffer_list_unref (not introspectable) when the list is no longer needed.

When a chainlist function detects an error in the data stream, it must post an error on the bus and return an appropriate Gst.FlowReturn value.

Parameters:

`pad` (Gst.Pad) –

the sink Gst.Pad that performed the chain.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`list` (Gst.BufferList) –

the Gst.BufferList that is chained, not None.

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK for success

### GstPadEventFullFunction

    GstFlowReturn
    (*GstPadEventFullFunction) (GstPad * pad,
                                GstObject * parent,
                                GstEvent * event)

Function signature to handle an event for the pad.

This variant is for specific elements that will take into account the last downstream flow return (from a pad push), in which case they can return it.

Parameters:

`pad` –

the GstPad to handle the event.

`parent` ( [nullable]) –

the parent of pad. If the GST_PAD_FLAG_NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`event` ( [transfer: full]) –

the GstEvent to handle.

Returns –

GST_FLOW_OK if the event was handled properly, or any other GstFlowReturn dependent on downstream state.

Since : 1.8

### Gst.PadEventFullFunction

    function Gst.PadEventFullFunction(pad: Gst.Pad, parent: Gst.Object, event: Gst.Event): {
        // javascript wrapper for 'GstPadEventFullFunction'
    }

Function signature to handle an event for the pad.

This variant is for specific elements that will take into account the last downstream flow return (from a pad push), in which case they can return it.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to handle the event.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`event` (Gst.Event) –

the Gst.Event to handle.

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK if the event was handled properly, or any other Gst.FlowReturn dependent on downstream state.

Since : 1.8

### Gst.PadEventFullFunction

    def Gst.PadEventFullFunction (pad, parent, event):
        #python wrapper for 'GstPadEventFullFunction'

Function signature to handle an event for the pad.

This variant is for specific elements that will take into account the last downstream flow return (from a pad push), in which case they can return it.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to handle the event.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`event` (Gst.Event) –

the Gst.Event to handle.

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK if the event was handled properly, or any other Gst.FlowReturn dependent on downstream state.

Since : 1.8

### GstPadEventFunction

    gboolean
    (*GstPadEventFunction) (GstPad * pad,
                            GstObject * parent,
                            GstEvent * event)

Function signature to handle an event for the pad.

Parameters:

`pad` –

the GstPad to handle the event.

`parent` ( [nullable]) –

the parent of pad. If the GST_PAD_FLAG_NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`event` ( [transfer: full]) –

the GstEvent to handle.

Returns –

TRUE if the pad could handle the event.

### Gst.PadEventFunction

    function Gst.PadEventFunction(pad: Gst.Pad, parent: Gst.Object, event: Gst.Event): {
        // javascript wrapper for 'GstPadEventFunction'
    }

Function signature to handle an event for the pad.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to handle the event.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`event` (Gst.Event) –

the Gst.Event to handle.

Returns (Number) –

true if the pad could handle the event.

### Gst.PadEventFunction

    def Gst.PadEventFunction (pad, parent, event):
        #python wrapper for 'GstPadEventFunction'

Function signature to handle an event for the pad.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to handle the event.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`event` (Gst.Event) –

the Gst.Event to handle.

Returns (bool) –

True if the pad could handle the event.

### GstPadForwardFunction

    gboolean
    (*GstPadForwardFunction) (GstPad * pad,
                              gpointer user_data)

A forward function is called for all internally linked pads, see gst_pad_forward.

Parameters:

`pad` –

the GstPad that is forwarded.

`user_data` –

the gpointer to optional user data.

Returns –

TRUE if the dispatching procedure has to be stopped.

### Gst.PadForwardFunction

    function Gst.PadForwardFunction(pad: Gst.Pad, user_data: Object): {
        // javascript wrapper for 'GstPadForwardFunction'
    }

A forward function is called for all internally linked pads, see Gst.Pad.prototype.forward.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad that is forwarded.

`user_data` (Object) –

the gpointer to optional user data.

Returns (Number) –

true if the dispatching procedure has to be stopped.

### Gst.PadForwardFunction

    def Gst.PadForwardFunction (pad, *user_data):
        #python wrapper for 'GstPadForwardFunction'

A forward function is called for all internally linked pads, see Gst.Pad.forward.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad that is forwarded.

`user_data` (variadic) –

the gpointer to optional user data.

Returns (bool) –

True if the dispatching procedure has to be stopped.

### GstPadGetRangeFunction

    GstFlowReturn
    (*GstPadGetRangeFunction) (GstPad * pad,
                               GstObject * parent,
                               guint64 offset,
                               guint length,
                               GstBuffer ** buffer)

This function will be called on source pads when a peer element request a buffer at the specified offset and length. If this function returns GST_FLOW_OK, the result buffer will be stored in buffer. The contents of buffer is invalid for any other return value.

This function is installed on a source pad with gst_pad_set_getrange_function and can only be called on source pads after they are successfully activated with gst_pad_activate_mode with the GST_PAD_MODE_PULL.

offset and length are always given in byte units. offset must normally be a value between 0 and the length in bytes of the data available on pad. The length (duration in bytes) can be retrieved with a GST_QUERY_DURATION or with a GST_QUERY_SEEKING.

Any offset larger or equal than the length will make the function return GST_FLOW_EOS, which corresponds to EOS. In this case buffer does not contain a valid buffer.

The buffer size of buffer will only be smaller than length when offset is near the end of the stream. In all other cases, the size of buffer must be exactly the requested size.

It is allowed to call this function with a 0 length and valid offset, in which case buffer will contain a 0-sized buffer and the function returns GST_FLOW_OK.

When this function is called with a -1 offset, the sequentially next buffer of length length in the stream is returned.

When this function is called with a -1 length, a buffer with a default optimal length is returned in buffer. The length might depend on the value of offset.

Parameters:

`pad` –

the src GstPad to perform the getrange on.

`parent` ( [nullable]) –

the parent of pad. If the GST_PAD_FLAG_NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`offset` –

the offset of the range

`length` –

the length of the range

`buffer` –

a memory location to hold the result buffer, cannot be NULL.

Returns –

GST_FLOW_OK for success and a valid buffer in buffer. Any other return value leaves buffer undefined.

### Gst.PadGetRangeFunction

    function Gst.PadGetRangeFunction(pad: Gst.Pad, parent: Gst.Object, offset: Number, length: Number, buffer: Gst.Buffer): {
        // javascript wrapper for 'GstPadGetRangeFunction'
    }

This function will be called on source pads when a peer element request a buffer at the specified offset and length. If this function returns Gst.FlowReturn.OK, the result buffer will be stored in buffer. The contents of buffer is invalid for any other return value.

This function is installed on a source pad with gst_pad_set_getrange_function (not introspectable) and can only be called on source pads after they are successfully activated with Gst.Pad.prototype.activate_mode with the Gst.PadMode.PULL.

offset and length are always given in byte units. offset must normally be a value between 0 and the length in bytes of the data available on pad. The length (duration in bytes) can be retrieved with a Gst.QueryType.DURATION or with a Gst.QueryType.SEEKING.

Any offset larger or equal than the length will make the function return Gst.FlowReturn.EOS, which corresponds to EOS. In this case buffer does not contain a valid buffer.

The buffer size of buffer will only be smaller than length when offset is near the end of the stream. In all other cases, the size of buffer must be exactly the requested size.

It is allowed to call this function with a 0 length and valid offset, in which case buffer will contain a 0-sized buffer and the function returns Gst.FlowReturn.OK.

When this function is called with a -1 offset, the sequentially next buffer of length length in the stream is returned.

When this function is called with a -1 length, a buffer with a default optimal length is returned in buffer. The length might depend on the value of offset.

Parameters:

`pad` (Gst.Pad) –

the src Gst.Pad to perform the getrange on.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`offset` (Number) –

the offset of the range

`length` (Number) –

the length of the range

`buffer` (Gst.Buffer) –

a memory location to hold the result buffer, cannot be null.

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK for success and a valid buffer in buffer. Any other return value leaves buffer undefined.

### Gst.PadGetRangeFunction

    def Gst.PadGetRangeFunction (pad, parent, offset, length, buffer):
        #python wrapper for 'GstPadGetRangeFunction'

This function will be called on source pads when a peer element request a buffer at the specified offset and length. If this function returns Gst.FlowReturn.OK, the result buffer will be stored in buffer. The contents of buffer is invalid for any other return value.

This function is installed on a source pad with gst_pad_set_getrange_function (not introspectable) and can only be called on source pads after they are successfully activated with Gst.Pad.activate_mode with the Gst.PadMode.PULL.

offset and length are always given in byte units. offset must normally be a value between 0 and the length in bytes of the data available on pad. The length (duration in bytes) can be retrieved with a Gst.QueryType.DURATION or with a Gst.QueryType.SEEKING.

Any offset larger or equal than the length will make the function return Gst.FlowReturn.EOS, which corresponds to EOS. In this case buffer does not contain a valid buffer.

The buffer size of buffer will only be smaller than length when offset is near the end of the stream. In all other cases, the size of buffer must be exactly the requested size.

It is allowed to call this function with a 0 length and valid offset, in which case buffer will contain a 0-sized buffer and the function returns Gst.FlowReturn.OK.

When this function is called with a -1 offset, the sequentially next buffer of length length in the stream is returned.

When this function is called with a -1 length, a buffer with a default optimal length is returned in buffer. The length might depend on the value of offset.

Parameters:

`pad` (Gst.Pad) –

the src Gst.Pad to perform the getrange on.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`offset` (int) –

the offset of the range

`length` (int) –

the length of the range

`buffer` (Gst.Buffer) –

a memory location to hold the result buffer, cannot be None.

Returns (Gst.FlowReturn) –

Gst.FlowReturn.OK for success and a valid buffer in buffer. Any other return value leaves buffer undefined.

### GstPadIterIntLinkFunction

    GstIterator *
    (*GstPadIterIntLinkFunction) (GstPad * pad,
                                  GstObject * parent)

The signature of the internal pad link iterator function.

Parameters:

`pad` –

The GstPad to query.

`parent` ( [nullable]) –

the parent of pad. If the GST_PAD_FLAG_NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

Returns –

a new GstIterator that will iterate over all pads that are linked to the given pad on the inside of the parent element.

the caller must call gst_iterator_free after usage.

### Gst.PadIterIntLinkFunction

    function Gst.PadIterIntLinkFunction(pad: Gst.Pad, parent: Gst.Object): {
        // javascript wrapper for 'GstPadIterIntLinkFunction'
    }

The signature of the internal pad link iterator function.

Parameters:

`pad` (Gst.Pad) –

The Gst.Pad to query.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

Returns (Gst.Iterator) –

a new Gst.Iterator that will iterate over all pads that are linked to the given pad on the inside of the parent element.

the caller must call Gst.Iterator.prototype.free after usage.

### Gst.PadIterIntLinkFunction

    def Gst.PadIterIntLinkFunction (pad, parent):
        #python wrapper for 'GstPadIterIntLinkFunction'

The signature of the internal pad link iterator function.

Parameters:

`pad` (Gst.Pad) –

The Gst.Pad to query.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

Returns (Gst.Iterator) –

a new Gst.Iterator that will iterate over all pads that are linked to the given pad on the inside of the parent element.

the caller must call Gst.Iterator.free after usage.

### GstPadLinkFunction

    GstPadLinkReturn
    (*GstPadLinkFunction) (GstPad * pad,
                           GstObject * parent,
                           GstPad * peer)

Function signature to handle a new link on the pad.

Parameters:

`pad` –

the GstPad that is linked.

`parent` ( [nullable]) –

the parent of pad. If the GST_PAD_FLAG_NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`peer` –

the peer GstPad of the link

Returns –

the result of the link with the specified peer.

### Gst.PadLinkFunction

    function Gst.PadLinkFunction(pad: Gst.Pad, parent: Gst.Object, peer: Gst.Pad): {
        // javascript wrapper for 'GstPadLinkFunction'
    }

Function signature to handle a new link on the pad.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad that is linked.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`peer` (Gst.Pad) –

the peer Gst.Pad of the link

Returns (Gst.PadLinkReturn) –

the result of the link with the specified peer.

### Gst.PadLinkFunction

    def Gst.PadLinkFunction (pad, parent, peer):
        #python wrapper for 'GstPadLinkFunction'

Function signature to handle a new link on the pad.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad that is linked.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`peer` (Gst.Pad) –

the peer Gst.Pad of the link

Returns (Gst.PadLinkReturn) –

the result of the link with the specified peer.

### GstPadProbeCallback

    GstPadProbeReturn
    (*GstPadProbeCallback) (GstPad * pad,
                            GstPadProbeInfo * info,
                            gpointer user_data)

Callback used by gst_pad_add_probe. Gets called to notify about the current blocking type.

The callback is allowed to modify the data pointer in info.

Parameters:

`pad` –

the GstPad that is blocked

`info` –

GstPadProbeInfo

`user_data` –

the gpointer to optional user data.

Returns –

a GstPadProbeReturn

### Gst.PadProbeCallback

    function Gst.PadProbeCallback(pad: Gst.Pad, info: Gst.PadProbeInfo, user_data: Object): {
        // javascript wrapper for 'GstPadProbeCallback'
    }

Callback used by Gst.Pad.prototype.add_probe. Gets called to notify about the current blocking type.

The callback is allowed to modify the data pointer in info.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad that is blocked

`info` (Gst.PadProbeInfo) –

Gst.PadProbeInfo

`user_data` (Object) –

the gpointer to optional user data.

Returns (Gst.PadProbeReturn) –

a Gst.PadProbeReturn

### Gst.PadProbeCallback

    def Gst.PadProbeCallback (pad, info, *user_data):
        #python wrapper for 'GstPadProbeCallback'

Callback used by Gst.Pad.add_probe. Gets called to notify about the current blocking type.

The callback is allowed to modify the data pointer in info.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad that is blocked

`info` (Gst.PadProbeInfo) –

Gst.PadProbeInfo

`user_data` (variadic) –

the gpointer to optional user data.

Returns (Gst.PadProbeReturn) –

a Gst.PadProbeReturn

### GstPadQueryFunction

    gboolean
    (*GstPadQueryFunction) (GstPad * pad,
                            GstObject * parent,
                            GstQuery * query)

The signature of the query function.

Parameters:

`pad` –

the GstPad to query.

`parent` ( [nullable]) –

the parent of pad. If the GST_PAD_FLAG_NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`query` –

the GstQuery object to execute

Returns –

TRUE if the query could be performed.

### Gst.PadQueryFunction

    function Gst.PadQueryFunction(pad: Gst.Pad, parent: Gst.Object, query: Gst.Query): {
        // javascript wrapper for 'GstPadQueryFunction'
    }

The signature of the query function.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to query.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`query` (Gst.Query) –

the Gst.Query object to execute

Returns (Number) –

true if the query could be performed.

### Gst.PadQueryFunction

    def Gst.PadQueryFunction (pad, parent, query):
        #python wrapper for 'GstPadQueryFunction'

The signature of the query function.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad to query.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

`query` (Gst.Query) –

the Gst.Query object to execute

Returns (bool) –

True if the query could be performed.

### GstPadStickyEventsForeachFunction

    gboolean
    (*GstPadStickyEventsForeachFunction) (GstPad * pad,
                                          GstEvent ** event,
                                          gpointer user_data)

Callback used by gst_pad_sticky_events_foreach.

When this function returns TRUE, the next event will be returned. When FALSE is returned, gst_pad_sticky_events_foreach will return.

When event is set to NULL, the item will be removed from the list of sticky events. event can be replaced by assigning a new reference to it. This function is responsible for unreffing the old event when removing or modifying.

Parameters:

`pad` –

the GstPad.

`event` ( [inout][nullable]) –

a sticky GstEvent.

`user_data` –

the gpointer to optional user data.

Returns –

TRUE if the iteration should continue

### Gst.PadStickyEventsForeachFunction

    function Gst.PadStickyEventsForeachFunction(pad: Gst.Pad, event: Gst.Event, user_data: Object): {
        // javascript wrapper for 'GstPadStickyEventsForeachFunction'
    }

Callback used by Gst.Pad.prototype.sticky_events_foreach.

When this function returns true, the next event will be returned. When false is returned, Gst.Pad.prototype.sticky_events_foreach will return.

When event is set to null, the item will be removed from the list of sticky events. event can be replaced by assigning a new reference to it. This function is responsible for unreffing the old event when removing or modifying.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad.

`event` (Gst.Event) –

a sticky Gst.Event.

`user_data` (Object) –

the Object to optional user data.

Returns a tuple made of:

(Number ) –

true if the iteration should continue

`event` (Gst.Event ) –

true if the iteration should continue

### Gst.PadStickyEventsForeachFunction

    def Gst.PadStickyEventsForeachFunction (pad, event, *user_data):
        #python wrapper for 'GstPadStickyEventsForeachFunction'

Callback used by Gst.Pad.sticky_events_foreach.

When this function returns True, the next event will be returned. When False is returned, Gst.Pad.sticky_events_foreach will return.

When event is set to None, the item will be removed from the list of sticky events. event can be replaced by assigning a new reference to it. This function is responsible for unreffing the old event when removing or modifying.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad.

`event` (Gst.Event) –

a sticky Gst.Event.

`user_data` (variadic) –

the object to optional user data.

Returns a tuple made of:

(bool ) –

True if the iteration should continue

`event` (Gst.Event ) –

True if the iteration should continue

### GstPadUnlinkFunction

    (*GstPadUnlinkFunction) (GstPad * pad,
                             GstObject * parent)

Function signature to handle a unlinking the pad prom its peer.

The pad's lock is already held when the unlink function is called, so most pad functions cannot be called from within the callback.

Parameters:

`pad` –

the GstPad that is linked.

`parent` ( [nullable]) –

the parent of pad. If the GST_PAD_FLAG_NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

### Gst.PadUnlinkFunction

    function Gst.PadUnlinkFunction(pad: Gst.Pad, parent: Gst.Object): {
        // javascript wrapper for 'GstPadUnlinkFunction'
    }

Function signature to handle a unlinking the pad prom its peer.

The pad's lock is already held when the unlink function is called, so most pad functions cannot be called from within the callback.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad that is linked.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

### Gst.PadUnlinkFunction

    def Gst.PadUnlinkFunction (pad, parent):
        #python wrapper for 'GstPadUnlinkFunction'

Function signature to handle a unlinking the pad prom its peer.

The pad's lock is already held when the unlink function is called, so most pad functions cannot be called from within the callback.

Parameters:

`pad` (Gst.Pad) –

the Gst.Pad that is linked.

`parent` (Gst.Object) –

the parent of pad. If the Gst.PadFlags.NEED_PARENT flag is set, parent is guaranteed to be not-%NULL and remain valid during the execution of this function.

The results of the search are